<script>
$(function() {
    $("input[type='checkbox']").bootstrapSwitch({
	    onColor: 'success',
	    size: 'small',
	    labelWidth: '60',
		onText:'启用',
		offText:'停用'
    });
    
    $("button").click(function(){
		$('.fa-spinner').removeClass('hidden');		
        $.ajax({
			type: 'POST',
			url: '{$module}&action=config',
			data: $('#config').serialize(),
			dataType: 'json',
            beforeSend: function() {
	        	$('.form-wrap .alert').addClass('hidden');
            },
			success: function(data) {
				console.log(data.info);
	        	$('.form-wrap .alert').removeClass('hidden').addClass('alert-'+data.status);
	        	$('.form-wrap .alert div').html('');
	        	$('.form-wrap .alert div').prepend(data.message);
	        	$('.fa-spinner').addClass('hidden');
	        	
				window.location.reload();
			}
		});
    });
});
</script>
<style>
.form-wrap label {
	color: #666;
    min-width: 150px;
    vertical-align: top;
}
.form-wrap textarea {
	outline: none;
	resize: none;
}
#config h3 {
	color: #333;
	font-weight: 400;
	line-height: 30px;
}
#config h3:before {
	content: '';
	display: inline-block;
    width: 4px;
    height: 22px;
    border-radius: 4px;
	margin-right: 15px;
    background-image: linear-gradient(0deg,#33aaf7,#00c4e2);
    vertical-align: middle;
}
</style>
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-switch/3.3.4/js/bootstrap-switch.min.js"></script>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-switch/3.3.4/css/bootstrap3/bootstrap-switch.min.css" />
<div class="row">
	<div class="col-md-12">
		<div class="block block-rounded block-bordered">
			<div class="block-header bg-gray-lighter">
				<h3 class="block-title">模块设置</h3>
			</div>
			<div class="block-content" style="padding-bottom: 0;">
				<div class="form-wrap">
				
					<div class="alert hidden" style="margin: 15px 0;padding: 10px;">
						<div style="display: inline-block;"></div>
						<button type="button" class="close" data-dismiss="alert" aria-label="Close">
							<span aria-hidden="true">&times;</span>
						</button>
					</div>
					
					<form id="config" method="post" class="form-inline row">
						
						<div class="col-md-12">
							<h3>服务商设置</h3>
						</div>
						
						<!-- Start -->						
						<div class="form-group col-md-6">
							<label for="system">短信服务商</label>
							<select name="system" class="form-control">
								<option value="aliyun" {if $system == 'aliyun'}selected{/if}>阿里云短信服务</option>
								<option value="qcloud" {if $system == 'qcloud'}selected{/if}>腾讯云短信服务</option>
							</select>
						</div>
						<!-- End -->
						
						<div class="col-md-12">
							<h3>系统参数设置</h3>
						</div>
						
						<!-- Start -->						
						<div class="form-group col-md-6">
							<label for="bit">验证码位数</label>
							<select name="bit" class="form-control">
								<option value="4" {if $bit == '4'}selected{/if}>4位</option>
								<option value="6" {if $bit == '6'}selected{/if}>6位</option>
								<option value="8" {if $bit == '8'}selected{/if}>8位</option>
							</select>
						</div>
						<!-- End -->
						
						<!-- Start -->						
						<div class="form-group col-md-6">
							<label for="company">短信签名</label>
							<input id="company" name="company" type="text" placeholder="模块海洋" class="form-control" value="{$company}">
						</div>
						<!-- End -->
						
						<!-- Start -->						
						<div class="form-group col-md-6">
							<label for="appkey">{if $system == 'aliyun'}Access Key{else}App ID{/if}</label>
							<input id="appkey" name="appkey" type="text" placeholder="{if $system == 'aliyun'}Access Key{else}App ID{/if}" class="form-control" value="{$appkey}">
							
							{if $system == 'aliyun'}
							<i class="fa fa-exclamation-circle" data-toggle="popover" data-placement="bottom" data-html="true" data-content="<a href='https://ak-console.aliyun.com/' target='_target' style='color: green;'>获取Access Key</a>"></i>
							{/if}
						</div>
						<!-- End -->
						<!-- Start -->						
						<div class="form-group col-md-6">
							<label for="secret">{if $system == 'aliyun'}Secret Key{else}App Key{/if}</label>
							<input id="secret" name="secret" type="text" placeholder="{if $system == 'aliyun'}Secret Key{else}App Key{/if}" class="form-control" value="{$secret}">
						</div>
						<!-- End -->
						
						<!-- Start -->						
						<div class="form-group col-md-6">
							<label for="admintel">管理员手机</label>
							<input id="admintel" name="admintel" type="text" placeholder="管理员接收通知的手机号码" class="form-control" value="{$admintel}">
						</div>
						<!-- End -->
						<div class="col-md-12">
							<h3>消息模板设置</h3>
						</div>
						
						<!-- Start -->										
						<div class="form-group col-md-6">
							<label for="verifyid">
								<input type="checkbox" id="is_verify" name="is_verify" value="on" data-label-text="注册验证" {if $is_verify}checked{/if}>
							</label>
						
							<input id="verifyid" name="verifyid" type="text" class="form-control" placeholder="请输入模板 Code" value="{$verifyid}">
							<i class="fa fa-exclamation-circle" data-toggle="popover" data-placement="bottom" data-content="您的验证码为：${ldelim}code{rdelim}，该验证码 5 分钟内有效，请勿泄漏于他人。"></i>
						</div>
						<!-- End -->
						
						<!-- Start -->
						<div class="form-group col-md-6">
							<label for="is_pwd">
								<input type="checkbox" id="is_pwd" name="is_pwd" value="on" data-label-text="密码修改" {if $is_pwd}checked{/if}>
							</label>
							
							<input id="pwdid" type="text" name="pwdid" class="form-control" placeholder="请输入模板 Code" value="{$pwdid}">
							
							<i class="fa fa-exclamation-circle" data-toggle="popover" data-placement="bottom" data-content="您的网站登录密码已修改为：${ldelim}password{rdelim}，如果不是您本人操作,请及时联系我们进行处理。"></i>
						</div>
						<!-- End -->
						
						<!-- Start -->						
						<div class="form-group col-md-6">
							<label for="dueid">
								<input type="checkbox" id="is_due" name="is_due" value="on" data-label-text="账单创建" {if $is_due}checked{/if}>
							</label>
							
							<input id="dueid" type="text" name="dueid" class="form-control" placeholder="请输入模板 Code" value="{$dueid}">
							
							<i class="fa fa-exclamation-circle" data-toggle="popover" data-placement="bottom" data-content="您有一张新的账单！产品名称：${ldelim}name{rdelim} 金额：${ldelim}amount{rdelim} 请尽快支付账单以免影响您的使用体验。"></i>
						</div>
						<!-- End -->
						
						<!-- Start -->
						<div class="form-group col-md-6">
							<label for="paidid">
								<input type="checkbox" id="is_paid" name="is_paid" value="on" data-label-text="账单支付" {if $is_paid}checked{/if}>
							</label>
							
							<input id="paidid" type="text" name="paidid" class="form-control" placeholder="请输入模板 Code" value="{$paidid}">
							
							<i class="fa fa-exclamation-circle" data-toggle="popover" data-placement="bottom" data-content="您的验证码为：${ldelim}code{rdelim}，该验证码 5 分钟内有效，请勿泄漏于他人。"></i>
						</div>
						<!-- End -->
						
						<!-- Start -->
						<div class="form-group col-md-6">
							<label for="createid">
								<input type="checkbox" id="is_create" name="is_create" value="on" data-label-text="产品开通" {if $is_create}checked{/if}>
							</label>
							
							<input id="createid" type="text" name="createid" class="form-control" placeholder="请输入模板 Code" value="{$createid}">
							
							<i class="fa fa-exclamation-circle" data-toggle="popover" data-placement="bottom" data-content="您购买的产品：${ldelim}domain{rdelim} 已开通，用户名：${ldelim}username{rdelim} 密码：${ldelim}password{rdelim} ，有任何问题可登陆网站进行咨询。"></i>
						</div>
						<!-- End -->
						
						<!-- Start -->
						<div class="form-group col-md-6">
							<label for="is_suspend">
								<input type="checkbox" id="is_suspend" name="is_suspend" value="on" data-label-text="产品暂停" {if $is_suspend}checked{/if}>
							</label>
							
							<input id="suspendid" type="text" name="suspendid" class="form-control" placeholder="请输入模板 Code" value="{$suspendid}">
							
							<i class="fa fa-exclamation-circle" data-toggle="popover" data-placement="bottom" data-content="您的产品/服务：${ldelim}domain{rdelim} 被暂停使用，请登录网站查看详情。"></i>
						</div>
						<!-- End -->
						
						<!-- Start -->
						<div class="form-group col-md-6">
							<label for="is_unsuspend">
								<input type="checkbox" id="is_unsuspend" name="is_unsuspend" value="on" data-label-text="解除暂停" {if $is_unsuspend}checked{/if}>
							</label>
							
							<input id="unsuspendid" type="text" name="unsuspendid" class="form-control" placeholder="请输入模板 Code" value="{$unsuspendid}">
							
							<i class="fa fa-exclamation-circle" data-toggle="popover" data-placement="bottom" data-content="您的验证码为：${ldelim}code{rdelim}，该验证码 5 分钟内有效，请勿泄漏于他人。"></i>
						</div>
						<!-- End -->
						
						<!-- Start -->
						<div class="form-group col-md-6">
							<label for="is_domainreg">
								<input type="checkbox" id="is_domainreg" name="is_domainreg" value="on" data-label-text="域名注册" {if $is_domainreg}checked{/if}>
							</label>
							
							<input id="domainregid" type="text" name="domainregid" class="form-control" placeholder="请输入模板 Code" value="{$domainregid}">
							
							<i class="fa fa-exclamation-circle" data-toggle="popover" data-placement="bottom" data-content="您的域名：{ldelim}domain{rdelim} 已经注册成功，更多信息请登录网站进行查看。"></i>
						</div>
						<!-- End -->
						
						<!-- Start -->
						<div class="form-group col-md-6">
							<label for="is_tkreply">
								<input type="checkbox" id="is_tkreply" name="is_tkreply" value="on" data-label-text="工单回复" {if $is_tkreply}checked{/if}>
							</label>
							<input id="tkreplyid" type="text" name="tkreplyid" class="form-control" placeholder="请输入模板 Code" value="{$tkreplyid}">
							
							<i class="fa fa-exclamation-circle" data-toggle="popover" data-placement="bottom" data-content="您提交的工单:${ldelim}ticketsubject{rdelim} 已经回复，待您确认问题是否已解决。请及时反馈与我们联系，谢谢。"></i>
						</div>
						<!-- End -->
						
						<!-- Start -->
						<div class="form-group col-md-6">
							<label for="is_admintkreply">
								<input type="checkbox" id="is_admintkreply" name="is_admintkreply" value="on" data-label-text="(管)新工单" {if $is_admintkreply}checked{/if}>
							</label>
							
							<input id="admintkreplyid" type="text" name="admintkreplyid" class="form-control" placeholder="请输入模板 Code" value="{$admintkreplyid}">
							
							<i class="fa fa-exclamation-circle" data-toggle="popover" data-placement="bottom" data-content="有用户回复了工单：${ldelim}ticketsubject{rdelim}。"></i>
						</div>
						<!-- End -->
						
						<div class="form-group col-md-12">
							<button type="button" class="button button-primary">提交</button>
							<i class="fas fa-spinner fa-spin hidden" style="margin-top: 7px;margin-left: 5px;"></i>
						</div>
						
					</form>
					
				</div>
			</div>
		</div>
	</div>
</div>