<style>
:focus {
	outline: none !important;
}
.btn-group .btn-default {
	font-weight: 400;
	padding: 5px 15px;
	background-color: #FFF;
}
.btn-group .btn-default:focus,
.btn-group .btn-default:active,
.btn-group .btn-default.active {
	color: #006eff;
	border-color: #006eff;
	background-color: #FFF;
}
.highcharts-credits {
	display: none;
}
.title-head {
	color: #333;
	font-weight: 400;
	line-height: 30px;
}
.title-head:before {
	content: '';
	display: inline-block;
    width: 4px;
    height: 22px;
    border-radius: 4px;
	margin-right: 15px;
    background-image: linear-gradient(0deg,#33aaf7,#00c4e2);
    vertical-align: middle;
}
.statistics,
.qcloud_statistics {
	min-width: 400px;
	height: 300px;
	text-align: center;
	position: relative;
}
.spinner {
    height: 50px;
    width: 50px;
    margin: -25px 0 20px -25px;
    border: 4px solid rgba(0,0,0,.15);
    border-top: 4px solid #fff;
    border-radius: 100%;
    animation: rotation .6s infinite linear;
    border-top-color: #7CB4EC;
    position: absolute;
    left: 50%;
    top: 50%;
}
.package {
	position: relative;
}
@keyframes rotation {
    0% {
        transform: rotate(360deg);
    }
    100% {
        transform: rotate(0deg);
    }
}
@keyframes check {
    0% {
        height: 0;
        width: 0
    }
    25% {
        height: 0;
        width: 10px
    }
    50% {
        height: 20px;
        width: 10px
    }
}
</style>
<div class="row">
	<div class="col-md-12">
		<div class="block block-rounded block-bordered">
			<div class="block-header bg-gray-lighter">
				<small class="pull-right text-muted">数据获取时间：{$smarty.now|date_format: "H:i"}</small>
				<h3 class="block-title">发送量数据</h3>
			</div>
			<div class="block-content">
				<div class="btn-group btn-group-sm" role="group" style="margin-bottom: 20px;">
				    <button type="button" class="btn btn-default active" data-day="0">24小时</button>
				    <button type="button" class="btn btn-default" data-day="7">近7天</button>
				    <button type="button" class="btn btn-default" data-day="30">近30天</button>
				</div>
				<h3 class="title-head">趋势图 <small>按照每日发送量统计</small></h3>
				<div class="statistics">
					<i class="spinner"></i>
				</div>
				{if $system='qcloud'}
				<h3 class="title-head">腾讯云统计数据 <small>按照每日发送量统计</small></h3>
				<div class="qcloud_statistics">
					<i class="spinner"></i>
				</div>
				{/if}
			</div>
		</div>
	</div>
	{if $system == 'qcloud'}
	<div class="package">
		<div class="col-md-12">
			<h3 class="title-head">腾讯云国内短信套餐包</h3>
			<div class="block block-rounded block-bordered">
				<div class="block-content" style="padding: 0;position: relative;min-height: 200px;">
					<i class="spinner"></i>
				</div>
			</div>
		</div>
	</div>
	{/if}
</div>
<script type="text/javascript">
$(function () {
	getHTML();
	
	{if $system == 'qcloud'}
	getPackage();
	{/if}

	$('.btn-group .btn').click(function() {
		$(this).addClass('active');
		$(this).siblings('.btn').removeClass('active');
		var day = $(this).data('day');
		$('.statistics').html('<i class="spinner"></i>');
		{if $system == 'qcloud'}
		$('.qcloud_statistics').html('<i class="spinner"></i>');
		{/if}
		getHTML( day );
	});
	
	function getHTML ( day = '0' ) {
		$.get("{$module}&action=statistics&day="+day, function(data){
			//console.log(data);
			var statistics = jQuery(data).find('.statistics').html();
			$('.statistics').html(statistics);
			{if $system == 'qcloud'}
			var qcloud_statistics = jQuery(data).find('.qcloud_statistics').html();
			$('.qcloud_statistics').html(qcloud_statistics);
			{/if}
		});
	}
	
	{if $system == 'qcloud'}
	function getPackage () {
		$.get("{$module}&action=statistics", function(data){
			var packages = jQuery(data).find('.package').html();
			$('.package .block-content').html(packages);
		});
	}
	{/if}
});
</script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highcharts/7.0.1/highcharts.js"></script>