<style>
.search {
	margin-bottom: 20px;
}
.form-group {
	margin-right: 10px;
}
.form-group label {
	font-weight: 400;
	margin-right: 5px;
}
.table>thead>tr>th {
	font-size: 14px;
	font-weight: 400 !important;
}
.table>tbody>tr>td {
	font-size: 12px;
}
.status {
    width: 12px;
    height: 12px;
    margin-right: 5px;
    display: inline-block;
    border-radius: 50px;
    vertical-align: middle;
    margin-bottom: 1px;
}
.status-success {
	background-color: #36B34A;
}
.status-waiting {
	background-color: gray;
}
.status-error {
	background-color: #D84042;
}
.table>tbody>tr:last-child>td {
	border-bottom: 0 none;
}
.table-empty {
	position: relative;
    color: #c3c5c6;
    padding: 50px 0;
    text-align: center;
}
.spinner {
    height: 50px;
    width: 50px;
    margin: -25px 0 0 -25px;
    border: 4px solid rgba(0,0,0,.15);
    border-top: 4px solid #fff;
    border-radius: 100%;
    animation: rotation .6s infinite linear;
    border-top-color: #48b54a;
    position: absolute;
    left: 50%;
    top: 50%;
}
@keyframes rotation {
    0% {
        transform: rotate(360deg);
    }
    100% {
        transform: rotate(0deg);
    }
}
@keyframes check {
    0% {
        height: 0;
        width: 0
    }
    25% {
        height: 0;
        width: 10px
    }
    50% {
        height: 20px;
        width: 10px
    }
}
</style>
<script type="text/javascript">
$(document).ready( function () {
    $('#tableLoading').addClass('hidden');
    
	$('.btn-search').click(function(){
		var pNumber = $('#phoneNum').val();
		var sendDate = $('#sendDate').val();
		
		$.ajax({
		    type: 'post',
		    timeout : 3000,
		    url: "{$module}&action=record",
		    data: { "pNumber": pNumber, "sendDate": sendDate },
		    dataType: 'json',
            beforeSend: function() {
                // 禁用按钮
				$('.detail-list').html('<tr class="empty" style="border-bottom: 0 none;"><td colspan="5"><div class="table-empty" style="font-size: 14px;"><i class="spinner"></i></div></td></tr>');
            },
			success: function(data) { //提交成功后的回调。											
		        if ( data.total > '1' ) {
			        $.each(data.detail, function(key, item) {
				        if ( item.SendStatus == '1' ) {
					        status = '<i class="status status-waiting"></i> 等待回执';
				        } else if ( item.SendStatus == '2' ) {
					        status = '<i class="status status-error"></i> 发送失败';
				        } else {
					        status = '<i class="status status-success"></i> 发送成功';
				        }
				        var html = '<tr></tr>';
				        	html += '<td>'+item.PhoneNum+'</td><td>'+item.SendDate+'</td><td>'+item.ReceiveDate+'</td><td>'+item.Content+'</td><td>'+status+'</td>';
				        	html += '</tr>';
				        //console.log(html);
				        $('.empty').remove();
						$('.detail-list').append($(html));
					});
		        } else {
					$('.detail-list').html('<tr class="empty" style="border-bottom: 0 none;"><td colspan="5"><div class="table-empty" style="font-size: 14px;">没有数据</div></td></tr>');
		        }
			}
		});
	});
});
</script>
<div class="row">
	<div class="col-sm-12">
		<div class="search">
		    <form class="form-inline">
		
		        <div class="form-group">
		            <label for="phoneNum" required>手机号码:</label>
		            <input placeholder="请输入手机号码搜索" id="phoneNum" class="form-control" type="text">
		        </div>
		
		        <div class="form-group">
		            <label for="sendDate" required>发送日期:</label>
		            <input placeholder="请选择日期" id="sendDate" class="form-control" type="text">
		        </div>
		
		        <div class="form-group">
		            <button type="button" class="btn btn-primary btn-search" style="width: 82px;">查询</button>
		        </div>
		        
		    </form>
		</div>
		<div class="block block-rounded block-bordered">
			<div class="block-content" style="padding: 0;">
                <table class="table table-hover" style="margin-bottom:0">
				    <colgroup>
			            <col style="width: 10%">
			            <col style="width: 12%"> 
			            <col style="width: 12%">
			            <col style="width: 20%">
			            <col style="width: 20%">
			        </colgroup>
                    <thead>
                        <tr>
                            <th>手机号码</th>
                            <th>发送时间</th>
                            <th>接收时间</th>
                            <th>短信内容</th>
                            <th>发送状态</th>
                        </tr>
                    </thead>
                    <tbody class="detail-list text-muted">
						<tr class="empty" style="border-bottom: 0 none;"><td colspan="5"><div class="table-empty" style="font-size: 14px;">没有数据</div></td></tr>
                    </tbody>
                </table>
			</div>
		</div>
	</div>
</div>