<!-- SMS_Verification Start -->
<style>
input {
	font-family: 'Montserrat', 'HanHei SC', 'PingFang SC', 'Helvetica Neue', 'Helvetica', 'STHeitiSC-Light', 'Arial', sans-serif;
}
.swal-title {
  margin-top: 0px !important;
  font-size: 16px;
  border-bottom: 1px solid #DDD;
  margin-bottom: 28px !important;
}
.form-control[name^=qty] {
	max-height: 24px;
}
#registration .form-control {
	color: #333;
	min-height: 36px;
	font-size: 14px !important;
	font-family: 'Montserrat', 'HanHei SC', 'PingFang SC', 'Helvetica Neue', 'Helvetica', 'STHeitiSC-Light', 'Arial', sans-serif;
    height: calc(2.25rem + 2px) !important;
}
.intl-tel-input .flag-container {
    bottom: inherit;
    line-height: 36px;
}
.valid-feedback {
	display: block;
}
.btn-sms {
	position: absolute;
	top: 0;
    right: 0;
    cursor: pointer;
    border-color: #DDD;
    background-color: #F8FAFE;
    min-height: 36px;
    height: calc(2.25rem + 2px);
    padding: 0 10px;
    font-size: 12px;
    color: #007CFF;
    line-height: 36px;
    border-radius: 0 3px 3px 0;
}
.btn.disabled {
    cursor: no-drop;
}
.btn-sms:focus,.btn-sms:hover {
	color: #FFF;
    border-color: #007CFF;
	background-color: #007CFF;
}
.intl-tel-input.allow-dropdown .flag-container:hover .selected-flag,
.intl-tel-input.separate-dial-code .selected-flag {
	background-color: transparent;
}
.close {
    font-size: 1.1rem;
    padding: .75rem 1rem !important;
}
.alert-dismissible {
    padding-right: 2.5rem;
}
</style>
<script type="text/javascript">
$(function () {
	var phone = $('#inputPhone');
	var submit = $('input[type=submit]');
	var btn = '<botton class="btn btn-xs btn-default btn-sms">{$text}</button>';
	phone.after(btn);
	
	// 给按钮加入 禁止
	submit.addClass('disabled').attr("disabled",true);
	
	$('#inputCurrency').prepend('<option selected disabled>货币选择</option>');
	
	phone.blur(function(){
	    try {
			var pNumber = phone.val().replace(/\s+/g, "");
			if ( pNumber.length == 0 ) throw "手机号不能为空";
			if ( pNumber.length != 11 ) throw "请输入有效的手机号码";
			//if ( $('#verifyCode').val() != 'yes' ) throw "必须验证手机号码";
 		} catch ( error ) {
	        notice( error );
	    }
	});
	
	$('.btn-sms').click(function(){
	    try {
			var pNumber = phone.val().replace(/\s+/g, "");
			var token = $("input[name=token]").val();
			if ( pNumber.length == 0 ) throw "手机号不能为空";
			if ( pNumber.length != 11 ) throw "请输入有效的手机号码";
			var result = /^1[3-9]\d{ldelim}9{rdelim}$/.test( pNumber );
			
	        if ( !result ) throw "手机号码 [ "+ pNumber +" ] 格式有误，请修改后重试";
	        
			var sendButton = $('.btn-sms');
			
			var api = '{$systemurl}modules/addons/SMS_Verification/action.php?action=';
			
            // 发起 POST
            $.ajax({
                type: 'post',
                timeout : 3000,
                url: api + "send",
                data: { "phone": pNumber, "token": token },
                dataType: 'json',
                beforeSend: function() {
                    // 禁用按钮
                    sendButton.addClass('disabled');
                },
                success: function(data) { //提交成功后的回调。
                    try {
	                    switch (data.status) {
	                        case 'error':
	                            // 恢复按钮
	                            sendButton.removeClass('disabled');
	
	                            throw data.info;
	                            break;
	                        case 'success':
								console.log('发送手机：' + pNumber)
                                // 按钮倒数秒数
                                var i = 120;

                                // 隔一秒修改一次按钮的数字
                                var interval = setInterval(function () {
                                    sendButton.addClass('btn-danger');
                                    sendButton.removeClass('btn-default');
                                    sendButton.html(i + ' s');

                                    if (i == 0) {
                                        sendButton.addClass('btn-default');
                                        sendButton.removeClass('btn-danger');

                                        // 恢复按钮文字
                                        sendButton.html('获取验证码');

                                        // 恢复按钮
                                        sendButton.removeClass('disabled');

                                        clearInterval(interval);
                                    } else {
                                        i--;
                                    }
                                }, 1000);
	
	                            swal({
	                                title: '发送成功',
	                                text: '请查看您手机的验证码',
									content: {
									    element: "input",
									    attributes: {
									      placeholder: "请输入收到的验证码",
									    },
									},
									buttons: {
										cancel: "取消",
										confirm: "确定",
									},
									closeOnEsc: false,
									closeOnClickOutside: false,
	                            })
								.then((code) => {
									if (!code) throw null;
									
									console.log(pNumber + ' ' + code );
									
						            $.ajax({
						                type: 'post',
						                timeout : 3000,
						                url: api + "{$action}",
						                data: { "phone": pNumber, "code": code },
						                dataType: 'json',
										success: function(data) { //提交成功后的回调。											
						                    try {
						                        switch (data.status) {
						                            case 'error':
						                                // 恢复按钮
						                                sendButton.removeClass('disabled');
						                                throw data.info;
						                                break;
						                            case 'success':
						                                // 禁用手机号码输入框
				                                        sendButton.addClass('btn-default');
				                                        sendButton.removeClass('btn-danger');
														clearInterval(interval);
				
				                                        // 恢复按钮文字
				                                        sendButton.html('获取验证码');
						                                sendButton.addClass('disabled').css({ 'border-color': '#28a745', 'background-color': '#28a745', 'color': '#FFF' });
						                                phone.addClass('disabled').attr("disabled",true).css({ 'border-color':  '#28a745','color': '#28a745' });
						                                phone.after('<div class="valid-feedback"><i class="fa fa-exclamation-circle"></i> 手机号验证成功</div>');
														submit.removeClass('disabled').attr("disabled",false);
														//$('#frmCheckout').prepend('<input type="hidden" id="verifyCode" name="verifyCode" value="yes" />');
														notice( '手机号验证成功', 'success');
						                                break;
						                            default:
						                                throw "无法解析系统所返回的内容";
						                                break;
						                        }
						                    }
						                    catch (err) {
												notice( data.info, "error");
						                    }
						                    swal.close();
										}
									});
									//swal(`You typed: ${ldelim}code{rdelim}`);
								});
	                            break;
	                        default:
	                            throw "无法解析系统所返回的内容";
	                            break;
	                    }
                    }
                    catch (err) {
						notice( data.info, "error");
                    }
                },
                complete : function(XMLHttpRequest, status){
                    try {
                        switch (status) {
                            case 'success':
                                break;
                            case 'error':
                                throw "系统未做出任何响应，请重试操作";
                                break;
                            case 'timeout':
                                throw "可能由于网络原因，网页请求超时";
                                break;
                            default:
                                throw "无法解析系统返回的内容";
                        }
                    }
                    catch (err) {
						notice( data.info, "error");
                    }
                }
            });
 		} catch ( error ) {
	        notice( error, "error");
	    }
	});
	
	function notice ( content, status = null ) {
		swal( content, {
			icon: status,
			buttons: false,
			timer: 4000,
		});
	}
});
</script>
<script src="https://cdnjs.loli.net/ajax/libs/sweetalert/2.1.2/sweetalert.min.js"></script>
<!-- SMS_Verification End -->