<?php

namespace AlibabaCloud\CCC\V20170705;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the CCC based on the method name as the Api name.
 *
 * @package   AlibabaCloud\CCC\V20170705
 *
 * @method AddNumberToSkillGroup addNumberToSkillGroup(array $options = [])
 * @method AddPhoneNumber addPhoneNumber(array $options = [])
 * @method AssignJobs assignJobs(array $options = [])
 * @method AssignUsers assignUsers(array $options = [])
 * @method CallOnlinePrivacyNumber callOnlinePrivacyNumber(array $options = [])
 * @method CancelJobs cancelJobs(array $options = [])
 * @method CancelPredictiveJobs cancelPredictiveJobs(array $options = [])
 * @method CommitContactFlowVersionModification commitContactFlowVersionModification(array $options = [])
 * @method CreateAndPublishSpecialContactFlow createAndPublishSpecialContactFlow(array $options = [])
 * @method CreateBatchJobs createBatchJobs(array $options = [])
 * @method CreateCCCPostOrder createCCCPostOrder(array $options = [])
 * @method CreateContactFlow createContactFlow(array $options = [])
 * @method CreateInstance createInstance(array $options = [])
 * @method CreateJobGroup createJobGroup(array $options = [])
 * @method CreateMedia createMedia(array $options = [])
 * @method CreatePredictiveJobs createPredictiveJobs(array $options = [])
 * @method CreateScenario createScenario(array $options = [])
 * @method CreateScenarioFromTemplate createScenarioFromTemplate(array $options = [])
 * @method CreateSkillGroup createSkillGroup(array $options = [])
 * @method CreateSurvey createSurvey(array $options = [])
 * @method CreateUser createUser(array $options = [])
 * @method DeleteInstance deleteInstance(array $options = [])
 * @method DeleteJobGroup deleteJobGroup(array $options = [])
 * @method DeleteMedia deleteMedia(array $options = [])
 * @method DeleteSkillGroup deleteSkillGroup(array $options = [])
 * @method DeleteSurvey deleteSurvey(array $options = [])
 * @method Dialogue dialogue(array $options = [])
 * @method DownloadOriginalStatisticsReport downloadOriginalStatisticsReport(array $options = [])
 * @method DownloadRecording downloadRecording(array $options = [])
 * @method DownloadUnreachableContacts downloadUnreachableContacts(array $options = [])
 * @method FindUsers findUsers(array $options = [])
 * @method GenerateAgentStatisticReport generateAgentStatisticReport(array $options = [])
 * @method GetAgentData getAgentData(array $options = [])
 * @method GetAgentState getAgentState(array $options = [])
 * @method GetCallMeasureSummaryReport getCallMeasureSummaryReport(array $options = [])
 * @method GetConfig getConfig(array $options = [])
 * @method GetContactIdentifyByOutBoundTaskId getContactIdentifyByOutBoundTaskId(array $options = [])
 * @method GetConversationDetailByContactId getConversationDetailByContactId(array $options = [])
 * @method GetConversationList getConversationList(array $options = [])
 * @method GetInstance getInstance(array $options = [])
 * @method GetInstanceState getInstanceState(array $options = [])
 * @method GetInstanceSummaryReport getInstanceSummaryReport(array $options = [])
 * @method GetInstanceSummaryReportByInterval getInstanceSummaryReportByInterval(array $options = [])
 * @method GetInstanceSummaryReportSinceMidnight getInstanceSummaryReportSinceMidnight(array $options = [])
 * @method GetJob getJob(array $options = [])
 * @method GetJobDataUploadParams getJobDataUploadParams(array $options = [])
 * @method GetJobGroup getJobGroup(array $options = [])
 * @method GetJobList getJobList(array $options = [])
 * @method GetJobStatusByCallId getJobStatusByCallId(array $options = [])
 * @method GetJobTemplateDownloadParams getJobTemplateDownloadParams(array $options = [])
 * @method GetNumberRegionInfo getNumberRegionInfo(array $options = [])
 * @method GetPredictiveJob getPredictiveJob(array $options = [])
 * @method GetScenario getScenario(array $options = [])
 * @method GetServiceExtensions getServiceExtensions(array $options = [])
 * @method GetSmsConfig getSmsConfig(array $options = [])
 * @method GetSurvey getSurvey(array $options = [])
 * @method GetTaskList getTaskList(array $options = [])
 * @method GetUser getUser(array $options = [])
 * @method LaunchAppraise launchAppraise(array $options = [])
 * @method LaunchShortMessageAppraise launchShortMessageAppraise(array $options = [])
 * @method ListAgentStates listAgentStates(array $options = [])
 * @method ListAgentSummaryReports listAgentSummaryReports(array $options = [])
 * @method ListAgentSummaryReportsByInterval listAgentSummaryReportsByInterval(array $options = [])
 * @method ListAgentSummaryReportsSinceMidnight listAgentSummaryReportsSinceMidnight(array $options = [])
 * @method ListBasicStatisticsReportSubItems listBasicStatisticsReportSubItems(array $options = [])
 * @method ListCallDetailRecords listCallDetailRecords(array $options = [])
 * @method ListCallMeasureSummaryReports listCallMeasureSummaryReports(array $options = [])
 * @method ListConfig listConfig(array $options = [])
 * @method ListContactFlows listContactFlows(array $options = [])
 * @method ListIvrTrackingDetail listIvrTrackingDetail(array $options = [])
 * @method ListJobGroups listJobGroups(array $options = [])
 * @method ListJobStatus listJobStatus(array $options = [])
 * @method ListJobsByGroup listJobsByGroup(array $options = [])
 * @method ListMedias listMedias(array $options = [])
 * @method ListOutboundPhoneNumberOfUser listOutboundPhoneNumberOfUser(array $options = [])
 * @method ListPhoneNumbers listPhoneNumbers(array $options = [])
 * @method ListPredictiveJobStatus listPredictiveJobStatus(array $options = [])
 * @method ListPrivacyNumberCallDetails listPrivacyNumberCallDetails(array $options = [])
 * @method ListPrivilegesOfUser listPrivilegesOfUser(array $options = [])
 * @method ListRealTimeAgent listRealTimeAgent(array $options = [])
 * @method ListRecentCallRecords listRecentCallRecords(array $options = [])
 * @method ListRecordingOfDualTrack listRecordingOfDualTrack(array $options = [])
 * @method ListRecordings listRecordings(array $options = [])
 * @method ListRecordingsByContactId listRecordingsByContactId(array $options = [])
 * @method ListRoles listRoles(array $options = [])
 * @method ListScenarioTemplates listScenarioTemplates(array $options = [])
 * @method ListScenarios listScenarios(array $options = [])
 * @method ListSkillGroupStates listSkillGroupStates(array $options = [])
 * @method ListSkillGroupSummaryReports listSkillGroupSummaryReports(array $options = [])
 * @method ListSkillGroupSummaryReportsByInterval listSkillGroupSummaryReportsByInterval(array $options = [])
 * @method ListSkillGroupSummaryReportsSinceMidnight listSkillGroupSummaryReportsSinceMidnight(array $options = [])
 * @method ListSkillGroups listSkillGroups(array $options = [])
 * @method ListSkillGroupsOfUser listSkillGroupsOfUser(array $options = [])
 * @method ListSurveys listSurveys(array $options = [])
 * @method ListUnreachableContacts listUnreachableContacts(array $options = [])
 * @method ListUsers listUsers(array $options = [])
 * @method ListUsersOfSkillGroup listUsersOfSkillGroup(array $options = [])
 * @method ModifyMedia modifyMedia(array $options = [])
 * @method ModifyNotificationConfig modifyNotificationConfig(array $options = [])
 * @method ModifyPhoneNumber modifyPhoneNumber(array $options = [])
 * @method ModifyPrivacyNumberCallDetail modifyPrivacyNumberCallDetail(array $options = [])
 * @method ModifyScenario modifyScenario(array $options = [])
 * @method ModifySkillGroup modifySkillGroup(array $options = [])
 * @method ModifySkillGroupOfUser modifySkillGroupOfUser(array $options = [])
 * @method ModifySurvey modifySurvey(array $options = [])
 * @method ModifyUser modifyUser(array $options = [])
 * @method PickLocalNumber pickLocalNumber(array $options = [])
 * @method PickOutboundNumbers pickOutboundNumbers(array $options = [])
 * @method PreCreateMedia preCreateMedia(array $options = [])
 * @method PreModifyMedia preModifyMedia(array $options = [])
 * @method PublishContactFlowVersion publishContactFlowVersion(array $options = [])
 * @method PublishSurvey publishSurvey(array $options = [])
 * @method QueryRedialIndicator queryRedialIndicator(array $options = [])
 * @method RefreshToken refreshToken(array $options = [])
 * @method RemoveNumberFromSkillGroup removeNumberFromSkillGroup(array $options = [])
 * @method RemovePhoneNumber removePhoneNumber(array $options = [])
 * @method RemoveUsers removeUsers(array $options = [])
 * @method RemoveUsersFromSkillGroup removeUsersFromSkillGroup(array $options = [])
 * @method RequestLoginInfo requestLoginInfo(array $options = [])
 * @method ResumeJobs resumeJobs(array $options = [])
 * @method SendPredefinedShortMessage sendPredefinedShortMessage(array $options = [])
 * @method SimpleDial simpleDial(array $options = [])
 * @method StartBack2BackCall startBack2BackCall(array $options = [])
 * @method StartJob startJob(array $options = [])
 * @method SubmitBatchJobs submitBatchJobs(array $options = [])
 * @method SuspendJobs suspendJobs(array $options = [])
 * @method TwoPartiesCall twoPartiesCall(array $options = [])
 */
class CCCApiResolver
{
    use ApiResolverTrait;
}
