<?php

namespace AlibabaCloud\CS\V20151215;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the CS based on the method name as the Api name.
 *
 * @package   AlibabaCloud\CS\V20151215
 *
 * @method AttachInstances attachInstances(array $options = [])
 * @method BatchUpdateSharedService batchUpdateSharedService(array $options = [])
 * @method BindSLB bindSLB(array $options = [])
 * @method CheckAliyunCSServiceRole checkAliyunCSServiceRole(array $options = [])
 * @method CheckSecurityGroup checkSecurityGroup(array $options = [])
 * @method CleanUpControllerEvent cleanUpControllerEvent(array $options = [])
 * @method CleanUpETCD cleanUpETCD(array $options = [])
 * @method CreateAutoScale createAutoScale(array $options = [])
 * @method CreateCluster createCluster(array $options = [])
 * @method CreateMonitoringUser createMonitoringUser(array $options = [])
 * @method CreateTrigger createTrigger(array $options = [])
 * @method CreateTriggerHook createTriggerHook(array $options = [])
 * @method DeleteAutoScale deleteAutoScale(array $options = [])
 * @method DeleteCluster deleteCluster(array $options = [])
 * @method DeleteClusterNode deleteClusterNode(array $options = [])
 * @method DeleteTrigger deleteTrigger(array $options = [])
 * @method DeployEMLSolution deployEMLSolution(array $options = [])
 * @method DeploySharedService deploySharedService(array $options = [])
 * @method DescribeAgentVersions describeAgentVersions(array $options = [])
 * @method DescribeApiVersion describeApiVersion(array $options = [])
 * @method DescribeClusterAutoScale describeClusterAutoScale(array $options = [])
 * @method DescribeClusterCRL describeClusterCRL(array $options = [])
 * @method DescribeClusterCerts describeClusterCerts(array $options = [])
 * @method DescribeClusterDetail describeClusterDetail(array $options = [])
 * @method DescribeClusterEndpoint describeClusterEndpoint(array $options = [])
 * @method DescribeClusterEndpoints describeClusterEndpoints(array $options = [])
 * @method DescribeClusterExtInfo describeClusterExtInfo(array $options = [])
 * @method DescribeClusterLogs describeClusterLogs(array $options = [])
 * @method DescribeClusterNodes describeClusterNodes(array $options = [])
 * @method DescribeClusterSharedServices describeClusterSharedServices(array $options = [])
 * @method DescribeClusterSnapshots describeClusterSnapshots(array $options = [])
 * @method DescribeClusterStatus describeClusterStatus(array $options = [])
 * @method DescribeClusterUserKubeconfig describeClusterUserKubeconfig(array $options = [])
 * @method DescribeClusterVxlanPortRule describeClusterVxlanPortRule(array $options = [])
 * @method DescribeClusters describeClusters(array $options = [])
 * @method DescribeRamUsers describeRamUsers(array $options = [])
 * @method DescribeRegionImages describeRegionImages(array $options = [])
 * @method DescribeRegionSharedServices describeRegionSharedServices(array $options = [])
 * @method DescribeTrigger describeTrigger(array $options = [])
 * @method DescribeTriggerHookStatus describeTriggerHookStatus(array $options = [])
 * @method DescribeUserInstances describeUserInstances(array $options = [])
 * @method DescribeUserIoOptimizedInstances describeUserIoOptimizedInstances(array $options = [])
 * @method DescribeUserQuota describeUserQuota(array $options = [])
 * @method DescribeUserResourceDomain describeUserResourceDomain(array $options = [])
 * @method DescribeUserResources describeUserResources(array $options = [])
 * @method DescribeUserServices describeUserServices(array $options = [])
 * @method DescribeVxlanPortsRules describeVxlanPortsRules(array $options = [])
 * @method DownloadClusterNodeCerts downloadClusterNodeCerts(array $options = [])
 * @method FixSecurityGroup fixSecurityGroup(array $options = [])
 * @method LoginAliyunHub loginAliyunHub(array $options = [])
 * @method ProbeTriggerHook probeTriggerHook(array $options = [])
 * @method PushMonitoringData pushMonitoringData(array $options = [])
 * @method ReDeploySharedService reDeploySharedService(array $options = [])
 * @method RecoverController recoverController(array $options = [])
 * @method RecoverControllers recoverControllers(array $options = [])
 * @method ResetClusterNode resetClusterNode(array $options = [])
 * @method RevokeClusterCerts revokeClusterCerts(array $options = [])
 * @method RevokeClusterToken revokeClusterToken(array $options = [])
 * @method RevokeTrigger revokeTrigger(array $options = [])
 * @method RevokeTriggerHook revokeTriggerHook(array $options = [])
 * @method ScaleCluster scaleCluster(array $options = [])
 * @method UnBindSLB unBindSLB(array $options = [])
 * @method UpdateAutoScale updateAutoScale(array $options = [])
 * @method UpdateClusterAgentVersion updateClusterAgentVersion(array $options = [])
 * @method UpdateClusterDockerVersion updateClusterDockerVersion(array $options = [])
 * @method UpdateClusterKubenetesVersion updateClusterKubenetesVersion(array $options = [])
 * @method UpdateController updateController(array $options = [])
 * @method UpdateControllers updateControllers(array $options = [])
 * @method UpdateRamPolicy updateRamPolicy(array $options = [])
 * @method UpdateSharedService updateSharedService(array $options = [])
 * @method UpdateSharedServices updateSharedServices(array $options = [])
 * @method UpgradeClusterAgent upgradeClusterAgent(array $options = [])
 */
class CSApiResolver
{
    use ApiResolverTrait;
}
