<?php

namespace AlibabaCloud\Cdn\V20141111;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the Cdn based on the method name as the Api name.
 *
 * @package   AlibabaCloud\Cdn\V20141111
 *
 * @method static AddCdnDomain addCdnDomain(array $options = [])
 * @method static AddFCTrigger addFCTrigger(array $options = [])
 * @method static AddLiveAppRecordConfig addLiveAppRecordConfig(array $options = [])
 * @method static AddLiveAppSnapshotConfig addLiveAppSnapshotConfig(array $options = [])
 * @method static AddLiveDomainMapping addLiveDomainMapping(array $options = [])
 * @method static AddLiveStreamTranscode addLiveStreamTranscode(array $options = [])
 * @method static BatchDeleteCdnDomainConfig batchDeleteCdnDomainConfig(array $options = [])
 * @method static BatchDescribeDomainCname batchDescribeDomainCname(array $options = [])
 * @method static BatchSetCdnDomainConfig batchSetCdnDomainConfig(array $options = [])
 * @method static CdnApiResolver cdnApiResolver(array $options = [])
 * @method static CreateLiveStreamRecordIndexFiles createLiveStreamRecordIndexFiles(array $options = [])
 * @method static DeleteCacheExpiredConfig deleteCacheExpiredConfig(array $options = [])
 * @method static DeleteCdnDomain deleteCdnDomain(array $options = [])
 * @method static DeleteCertificate deleteCertificate(array $options = [])
 * @method static DeleteFCTrigger deleteFCTrigger(array $options = [])
 * @method static DeleteHttpHeaderConfig deleteHttpHeaderConfig(array $options = [])
 * @method static DeleteLiveAppRecordConfig deleteLiveAppRecordConfig(array $options = [])
 * @method static DeleteLiveAppSnapshotConfig deleteLiveAppSnapshotConfig(array $options = [])
 * @method static DeleteLiveDomainMapping deleteLiveDomainMapping(array $options = [])
 * @method static DeleteLiveStreamTranscode deleteLiveStreamTranscode(array $options = [])
 * @method static DeleteSpecificConfig deleteSpecificConfig(array $options = [])
 * @method static DescribeCdnDomainConfigs describeCdnDomainConfigs(array $options = [])
 * @method static DescribeCdnDomainDetail describeCdnDomainDetail(array $options = [])
 * @method static DescribeCdnDomainLogs describeCdnDomainLogs(array $options = [])
 * @method static DescribeCdnMonitorData describeCdnMonitorData(array $options = [])
 * @method static DescribeCdnMonthSubscribe describeCdnMonthSubscribe(array $options = [])
 * @method static DescribeCdnRegionAndIsp describeCdnRegionAndIsp(array $options = [])
 * @method static DescribeCdnService describeCdnService(array $options = [])
 * @method static DescribeCdnUserBillInfo describeCdnUserBillInfo(array $options = [])
 * @method static DescribeCdnUserQuota describeCdnUserQuota(array $options = [])
 * @method static DescribeCdnUserSubscribe describeCdnUserSubscribe(array $options = [])
 * @method static DescribeCdnWeekSubscribe describeCdnWeekSubscribe(array $options = [])
 * @method static DescribeCustomLogConfig describeCustomLogConfig(array $options = [])
 * @method static DescribeDomainAverageResponseTime describeDomainAverageResponseTime(array $options = [])
 * @method static DescribeDomainBpsData describeDomainBpsData(array $options = [])
 * @method static DescribeDomainBpsDataByTimeStamp describeDomainBpsDataByTimeStamp(array $options = [])
 * @method static DescribeDomainCCData describeDomainCCData(array $options = [])
 * @method static DescribeDomainCertificateInfo describeDomainCertificateInfo(array $options = [])
 * @method static DescribeDomainCname describeDomainCname(array $options = [])
 * @method static DescribeDomainConfigs describeDomainConfigs(array $options = [])
 * @method static DescribeDomainCustomLogConfig describeDomainCustomLogConfig(array $options = [])
 * @method static DescribeDomainFileSizeProportionData describeDomainFileSizeProportionData(array $options = [])
 * @method static DescribeDomainFlowData describeDomainFlowData(array $options = [])
 * @method static DescribeDomainHitRateData describeDomainHitRateData(array $options = [])
 * @method static DescribeDomainHttpCodeData describeDomainHttpCodeData(array $options = [])
 * @method static DescribeDomainISPData describeDomainISPData(array $options = [])
 * @method static DescribeDomainMax95BpsData describeDomainMax95BpsData(array $options = [])
 * @method static DescribeDomainPathData describeDomainPathData(array $options = [])
 * @method static DescribeDomainPvData describeDomainPvData(array $options = [])
 * @method static DescribeDomainQpsData describeDomainQpsData(array $options = [])
 * @method static DescribeDomainRealTimeBpsData describeDomainRealTimeBpsData(array $options = [])
 * @method static DescribeDomainRealTimeByteHitRateData describeDomainRealTimeByteHitRateData(array $options = [])
 * @method static DescribeDomainRealTimeHttpCodeData describeDomainRealTimeHttpCodeData(array $options = [])
 * @method static DescribeDomainRealTimeQpsData describeDomainRealTimeQpsData(array $options = [])
 * @method static DescribeDomainRealTimeReqHitRateData describeDomainRealTimeReqHitRateData(array $options = [])
 * @method static DescribeDomainRealTimeSrcBpsData describeDomainRealTimeSrcBpsData(array $options = [])
 * @method static DescribeDomainRealTimeSrcTrafficData describeDomainRealTimeSrcTrafficData(array $options = [])
 * @method static DescribeDomainRegionData describeDomainRegionData(array $options = [])
 * @method static DescribeDomainReqHitRateData describeDomainReqHitRateData(array $options = [])
 * @method static DescribeDomainSlowRatio describeDomainSlowRatio(array $options = [])
 * @method static DescribeDomainSrcBpsData describeDomainSrcBpsData(array $options = [])
 * @method static DescribeDomainSrcFlowData describeDomainSrcFlowData(array $options = [])
 * @method static DescribeDomainTopReferVisit describeDomainTopReferVisit(array $options = [])
 * @method static DescribeDomainTopUrlVisit describeDomainTopUrlVisit(array $options = [])
 * @method static DescribeDomainUvData describeDomainUvData(array $options = [])
 * @method static DescribeDomainsBySource describeDomainsBySource(array $options = [])
 * @method static DescribeDomainsUsageByDay describeDomainsUsageByDay(array $options = [])
 * @method static DescribeFCTrigger describeFCTrigger(array $options = [])
 * @method static DescribeIpInfo describeIpInfo(array $options = [])
 * @method static DescribeL2VipsByDomain describeL2VipsByDomain(array $options = [])
 * @method static DescribeL2VipsByDynamicDomain describeL2VipsByDynamicDomain(array $options = [])
 * @method static DescribeLivePullStreamConfig describeLivePullStreamConfig(array $options = [])
 * @method static DescribeLiveRecordConfig describeLiveRecordConfig(array $options = [])
 * @method static DescribeLiveSnapshotConfig describeLiveSnapshotConfig(array $options = [])
 * @method static DescribeLiveStreamBitRateData describeLiveStreamBitRateData(array $options = [])
 * @method static DescribeLiveStreamHistoryUserNumber describeLiveStreamHistoryUserNumber(array $options = [])
 * @method static DescribeLiveStreamOnlineUserNum describeLiveStreamOnlineUserNum(array $options = [])
 * @method static DescribeLiveStreamRecordContent describeLiveStreamRecordContent(array $options = [])
 * @method static DescribeLiveStreamRecordIndexFile describeLiveStreamRecordIndexFile(array $options = [])
 * @method static DescribeLiveStreamRecordIndexFiles describeLiveStreamRecordIndexFiles(array $options = [])
 * @method static DescribeLiveStreamSnapshotInfo describeLiveStreamSnapshotInfo(array $options = [])
 * @method static DescribeLiveStreamTranscodeInfo describeLiveStreamTranscodeInfo(array $options = [])
 * @method static DescribeLiveStreamsBlockList describeLiveStreamsBlockList(array $options = [])
 * @method static DescribeLiveStreamsControlHistory describeLiveStreamsControlHistory(array $options = [])
 * @method static DescribeLiveStreamsFrameRateAndBitRateData describeLiveStreamsFrameRateAndBitRateData(array $options = [])
 * @method static DescribeLiveStreamsOnlineList describeLiveStreamsOnlineList(array $options = [])
 * @method static DescribeLiveStreamsPublishList describeLiveStreamsPublishList(array $options = [])
 * @method static DescribeRangeDataByLocateAndIspService describeRangeDataByLocateAndIspService(array $options = [])
 * @method static DescribeRefreshQuota describeRefreshQuota(array $options = [])
 * @method static DescribeRefreshTasks describeRefreshTasks(array $options = [])
 * @method static DescribeScdnService describeScdnService(array $options = [])
 * @method static DescribeTopDomainsByFlow describeTopDomainsByFlow(array $options = [])
 * @method static DescribeUserConfigs describeUserConfigs(array $options = [])
 * @method static DescribeUserCustomLogConfig describeUserCustomLogConfig(array $options = [])
 * @method static DescribeUserCustomerLabels describeUserCustomerLabels(array $options = [])
 * @method static DescribeUserDomains describeUserDomains(array $options = [])
 * @method static ForbidLiveStream forbidLiveStream(array $options = [])
 * @method static ListDomainsByLogConfigId listDomainsByLogConfigId(array $options = [])
 * @method static ListFCTrigger listFCTrigger(array $options = [])
 * @method static ModifyCdnDomain modifyCdnDomain(array $options = [])
 * @method static ModifyCdnService modifyCdnService(array $options = [])
 * @method static ModifyCdnSubscribeService modifyCdnSubscribeService(array $options = [])
 * @method static ModifyDomainCustomLogConfig modifyDomainCustomLogConfig(array $options = [])
 * @method static ModifyFileCacheExpiredConfig modifyFileCacheExpiredConfig(array $options = [])
 * @method static ModifyHttpHeaderConfig modifyHttpHeaderConfig(array $options = [])
 * @method static ModifyPathCacheExpiredConfig modifyPathCacheExpiredConfig(array $options = [])
 * @method static ModifyUserCustomLogConfig modifyUserCustomLogConfig(array $options = [])
 * @method static OpenCdnService openCdnService(array $options = [])
 * @method static OpenCdnSubscribeService openCdnSubscribeService(array $options = [])
 * @method static PushObjectCache pushObjectCache(array $options = [])
 * @method static RefreshObjectCaches refreshObjectCaches(array $options = [])
 * @method static ResumeLiveStream resumeLiveStream(array $options = [])
 * @method static SetBusinessFunctionConfig setBusinessFunctionConfig(array $options = [])
 * @method static SetCacheExpiredConfig setCacheExpiredConfig(array $options = [])
 * @method static SetCcConfig setCcConfig(array $options = [])
 * @method static SetDomainFiletypeForceTtlCodeConfig setDomainFiletypeForceTtlCodeConfig(array $options = [])
 * @method static SetDomainGreenManagerConfig setDomainGreenManagerConfig(array $options = [])
 * @method static SetDomainPathForceTtlCodeConfig setDomainPathForceTtlCodeConfig(array $options = [])
 * @method static SetDomainServerCertificate setDomainServerCertificate(array $options = [])
 * @method static SetDynamicConfig setDynamicConfig(array $options = [])
 * @method static SetErrorPageConfig setErrorPageConfig(array $options = [])
 * @method static SetFileCacheExpiredConfig setFileCacheExpiredConfig(array $options = [])
 * @method static SetForceRedirectConfig setForceRedirectConfig(array $options = [])
 * @method static SetForwardSchemeConfig setForwardSchemeConfig(array $options = [])
 * @method static SetHttpErrorPageConfig setHttpErrorPageConfig(array $options = [])
 * @method static SetHttpHeaderConfig setHttpHeaderConfig(array $options = [])
 * @method static SetHttpsOptionConfig setHttpsOptionConfig(array $options = [])
 * @method static SetIgnoreQueryStringConfig setIgnoreQueryStringConfig(array $options = [])
 * @method static SetIpAllowListConfig setIpAllowListConfig(array $options = [])
 * @method static SetIpBlackListConfig setIpBlackListConfig(array $options = [])
 * @method static SetIpWhiteListConfig setIpWhiteListConfig(array $options = [])
 * @method static SetL2OssKeyConfig setL2OssKeyConfig(array $options = [])
 * @method static SetLiveStreamsNotifyUrlConfig setLiveStreamsNotifyUrlConfig(array $options = [])
 * @method static SetOptimizeConfig setOptimizeConfig(array $options = [])
 * @method static SetPageCompressConfig setPageCompressConfig(array $options = [])
 * @method static SetPathCacheExpiredConfig setPathCacheExpiredConfig(array $options = [])
 * @method static SetRangeConfig setRangeConfig(array $options = [])
 * @method static SetRefererConfig setRefererConfig(array $options = [])
 * @method static SetRefererRegexConfig setRefererRegexConfig(array $options = [])
 * @method static SetRemoveQueryStringConfig setRemoveQueryStringConfig(array $options = [])
 * @method static SetReqAuthConfig setReqAuthConfig(array $options = [])
 * @method static SetReqHeaderConfig setReqHeaderConfig(array $options = [])
 * @method static SetSourceHostConfig setSourceHostConfig(array $options = [])
 * @method static SetUserGreenManagerConfig setUserGreenManagerConfig(array $options = [])
 * @method static SetVideoSeekConfig setVideoSeekConfig(array $options = [])
 * @method static SetWaitingRoomConfig setWaitingRoomConfig(array $options = [])
 * @method static StartCdnDomain startCdnDomain(array $options = [])
 * @method static StartMixStreamsService startMixStreamsService(array $options = [])
 * @method static StopCdnDomain stopCdnDomain(array $options = [])
 * @method static StopCdnSubscribeService stopCdnSubscribeService(array $options = [])
 * @method static StopMixStreamsService stopMixStreamsService(array $options = [])
 * @method static UpdateFCTrigger updateFCTrigger(array $options = [])
 * @method static UpdateLiveAppSnapshotConfig updateLiveAppSnapshotConfig(array $options = [])
 */
class Cdn
{
    use ApiResolverTrait;
}
