<?php

namespace AlibabaCloud\Cdn\V20180510;

use AlibabaCloud\Client\Request\RpcRequest;

/**
 * Request of BatchSetCdnDomainServerCertificate
 *
 * @method string getForceSet()
 * @method string getSecurityToken()
 * @method string getCertType()
 * @method string getSSLPub()
 * @method string getCertName()
 * @method string getSSLProtocol()
 * @method string getDomainName()
 * @method string getOwnerId()
 * @method string getRegion()
 * @method string getSSLPri()
 */
class BatchSetCdnDomainServerCertificate extends RpcRequest
{

    /**
     * @var string
     */
    public $product = 'Cdn';

    /**
     * @var string
     */
    public $version = '2018-05-10';

    /**
     * @var string
     */
    public $action = 'BatchSetCdnDomainServerCertificate';

    /**
     * @var string
     */
    public $method = 'POST';

    /**
     * @deprecated deprecated since version 2.0, Use withForceSet() instead.
     *
     * @param string $forceSet
     *
     * @return $this
     */
    public function setForceSet($forceSet)
    {
        return $this->withForceSet($forceSet);
    }

    /**
     * @param string $forceSet
     *
     * @return $this
     */
    public function withForceSet($forceSet)
    {
        $this->data['ForceSet'] = $forceSet;
        $this->options['query']['ForceSet'] = $forceSet;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withSecurityToken() instead.
     *
     * @param string $securityToken
     *
     * @return $this
     */
    public function setSecurityToken($securityToken)
    {
        return $this->withSecurityToken($securityToken);
    }

    /**
     * @param string $securityToken
     *
     * @return $this
     */
    public function withSecurityToken($securityToken)
    {
        $this->data['SecurityToken'] = $securityToken;
        $this->options['query']['SecurityToken'] = $securityToken;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withCertType() instead.
     *
     * @param string $certType
     *
     * @return $this
     */
    public function setCertType($certType)
    {
        return $this->withCertType($certType);
    }

    /**
     * @param string $certType
     *
     * @return $this
     */
    public function withCertType($certType)
    {
        $this->data['CertType'] = $certType;
        $this->options['query']['CertType'] = $certType;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withSSLPub() instead.
     *
     * @param string $sSLPub
     *
     * @return $this
     */
    public function setSSLPub($sSLPub)
    {
        return $this->withSSLPub($sSLPub);
    }

    /**
     * @param string $sSLPub
     *
     * @return $this
     */
    public function withSSLPub($sSLPub)
    {
        $this->data['SSLPub'] = $sSLPub;
        $this->options['query']['SSLPub'] = $sSLPub;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withCertName() instead.
     *
     * @param string $certName
     *
     * @return $this
     */
    public function setCertName($certName)
    {
        return $this->withCertName($certName);
    }

    /**
     * @param string $certName
     *
     * @return $this
     */
    public function withCertName($certName)
    {
        $this->data['CertName'] = $certName;
        $this->options['query']['CertName'] = $certName;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withSSLProtocol() instead.
     *
     * @param string $sSLProtocol
     *
     * @return $this
     */
    public function setSSLProtocol($sSLProtocol)
    {
        return $this->withSSLProtocol($sSLProtocol);
    }

    /**
     * @param string $sSLProtocol
     *
     * @return $this
     */
    public function withSSLProtocol($sSLProtocol)
    {
        $this->data['SSLProtocol'] = $sSLProtocol;
        $this->options['query']['SSLProtocol'] = $sSLProtocol;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withDomainName() instead.
     *
     * @param string $domainName
     *
     * @return $this
     */
    public function setDomainName($domainName)
    {
        return $this->withDomainName($domainName);
    }

    /**
     * @param string $domainName
     *
     * @return $this
     */
    public function withDomainName($domainName)
    {
        $this->data['DomainName'] = $domainName;
        $this->options['query']['DomainName'] = $domainName;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withOwnerId() instead.
     *
     * @param string $ownerId
     *
     * @return $this
     */
    public function setOwnerId($ownerId)
    {
        return $this->withOwnerId($ownerId);
    }

    /**
     * @param string $ownerId
     *
     * @return $this
     */
    public function withOwnerId($ownerId)
    {
        $this->data['OwnerId'] = $ownerId;
        $this->options['query']['OwnerId'] = $ownerId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withRegion() instead.
     *
     * @param string $region
     *
     * @return $this
     */
    public function setRegion($region)
    {
        return $this->withRegion($region);
    }

    /**
     * @param string $region
     *
     * @return $this
     */
    public function withRegion($region)
    {
        $this->data['Region'] = $region;
        $this->options['query']['Region'] = $region;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withSSLPri() instead.
     *
     * @param string $sSLPri
     *
     * @return $this
     */
    public function setSSLPri($sSLPri)
    {
        return $this->withSSLPri($sSLPri);
    }

    /**
     * @param string $sSLPri
     *
     * @return $this
     */
    public function withSSLPri($sSLPri)
    {
        $this->data['SSLPri'] = $sSLPri;
        $this->options['query']['SSLPri'] = $sSLPri;

        return $this;
    }
}
