<?php

namespace AlibabaCloud\Cdn\V20180510;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the Cdn based on the method name as the Api name.
 *
 * @package   AlibabaCloud\Cdn\V20180510
 *
 * @method static AddCdnDomain addCdnDomain(array $options = [])
 * @method static AddFCTrigger addFCTrigger(array $options = [])
 * @method static BatchAddCdnDomain batchAddCdnDomain(array $options = [])
 * @method static BatchDeleteCdnDomainConfig batchDeleteCdnDomainConfig(array $options = [])
 * @method static BatchSetCdnDomainConfig batchSetCdnDomainConfig(array $options = [])
 * @method static BatchSetCdnDomainServerCertificate batchSetCdnDomainServerCertificate(array $options = [])
 * @method static BatchUpdateCdnDomain batchUpdateCdnDomain(array $options = [])
 * @method static CdnApiResolver cdnApiResolver(array $options = [])
 * @method static CreateUsageDetailDataExportTask createUsageDetailDataExportTask(array $options = [])
 * @method static CreateUserUsageDataExportTask createUserUsageDataExportTask(array $options = [])
 * @method static DeleteCdnDomain deleteCdnDomain(array $options = [])
 * @method static DeleteFCTrigger deleteFCTrigger(array $options = [])
 * @method static DeleteUsageDetailDataExportTask deleteUsageDetailDataExportTask(array $options = [])
 * @method static DeleteUserUsageDataExportTask deleteUserUsageDataExportTask(array $options = [])
 * @method static DescribeCdnCertificateDetail describeCdnCertificateDetail(array $options = [])
 * @method static DescribeCdnCertificateList describeCdnCertificateList(array $options = [])
 * @method static DescribeCdnDomainBaseDetail describeCdnDomainBaseDetail(array $options = [])
 * @method static DescribeCdnDomainConfigs describeCdnDomainConfigs(array $options = [])
 * @method static DescribeCdnDomainDetail describeCdnDomainDetail(array $options = [])
 * @method static DescribeCdnDomainLogs describeCdnDomainLogs(array $options = [])
 * @method static DescribeCdnMonitorData describeCdnMonitorData(array $options = [])
 * @method static DescribeCdnRegionAndIsp describeCdnRegionAndIsp(array $options = [])
 * @method static DescribeCdnService describeCdnService(array $options = [])
 * @method static DescribeCdnUserQuota describeCdnUserQuota(array $options = [])
 * @method static DescribeCdnUserResourcePackage describeCdnUserResourcePackage(array $options = [])
 * @method static DescribeCustomLogConfig describeCustomLogConfig(array $options = [])
 * @method static DescribeDomainAverageResponseTime describeDomainAverageResponseTime(array $options = [])
 * @method static DescribeDomainBpsData describeDomainBpsData(array $options = [])
 * @method static DescribeDomainBpsDataByTimeStamp describeDomainBpsDataByTimeStamp(array $options = [])
 * @method static DescribeDomainCCAttackInfo describeDomainCCAttackInfo(array $options = [])
 * @method static DescribeDomainCCData describeDomainCCData(array $options = [])
 * @method static DescribeDomainCertificateInfo describeDomainCertificateInfo(array $options = [])
 * @method static DescribeDomainCname describeDomainCname(array $options = [])
 * @method static DescribeDomainConfigs describeDomainConfigs(array $options = [])
 * @method static DescribeDomainCustomLogConfig describeDomainCustomLogConfig(array $options = [])
 * @method static DescribeDomainDownstreamBpsOfEdge describeDomainDownstreamBpsOfEdge(array $options = [])
 * @method static DescribeDomainFileSizeProportionData describeDomainFileSizeProportionData(array $options = [])
 * @method static DescribeDomainHitRateData describeDomainHitRateData(array $options = [])
 * @method static DescribeDomainHttpCodeData describeDomainHttpCodeData(array $options = [])
 * @method static DescribeDomainISPData describeDomainISPData(array $options = [])
 * @method static DescribeDomainMax95BpsData describeDomainMax95BpsData(array $options = [])
 * @method static DescribeDomainMonthBillingBpsData describeDomainMonthBillingBpsData(array $options = [])
 * @method static DescribeDomainPathData describeDomainPathData(array $options = [])
 * @method static DescribeDomainPvData describeDomainPvData(array $options = [])
 * @method static DescribeDomainQpsData describeDomainQpsData(array $options = [])
 * @method static DescribeDomainRealTimeBpsData describeDomainRealTimeBpsData(array $options = [])
 * @method static DescribeDomainRealTimeByteHitRateData describeDomainRealTimeByteHitRateData(array $options = [])
 * @method static DescribeDomainRealTimeData describeDomainRealTimeData(array $options = [])
 * @method static DescribeDomainRealTimeHttpCodeData describeDomainRealTimeHttpCodeData(array $options = [])
 * @method static DescribeDomainRealTimeQpsData describeDomainRealTimeQpsData(array $options = [])
 * @method static DescribeDomainRealTimeReqHitRateData describeDomainRealTimeReqHitRateData(array $options = [])
 * @method static DescribeDomainRealTimeSrcBpsData describeDomainRealTimeSrcBpsData(array $options = [])
 * @method static DescribeDomainRealTimeSrcTrafficData describeDomainRealTimeSrcTrafficData(array $options = [])
 * @method static DescribeDomainRegionData describeDomainRegionData(array $options = [])
 * @method static DescribeDomainReqHitRateData describeDomainReqHitRateData(array $options = [])
 * @method static DescribeDomainSrcBpsData describeDomainSrcBpsData(array $options = [])
 * @method static DescribeDomainSrcHttpCodeData describeDomainSrcHttpCodeData(array $options = [])
 * @method static DescribeDomainSrcTrafficData describeDomainSrcTrafficData(array $options = [])
 * @method static DescribeDomainTopReferVisit describeDomainTopReferVisit(array $options = [])
 * @method static DescribeDomainTopUrlVisit describeDomainTopUrlVisit(array $options = [])
 * @method static DescribeDomainTrafficData describeDomainTrafficData(array $options = [])
 * @method static DescribeDomainUpstreamBpsOfEdge describeDomainUpstreamBpsOfEdge(array $options = [])
 * @method static DescribeDomainUpstreamOfCenter describeDomainUpstreamOfCenter(array $options = [])
 * @method static DescribeDomainUsageData describeDomainUsageData(array $options = [])
 * @method static DescribeDomainUvData describeDomainUvData(array $options = [])
 * @method static DescribeDomainsBySource describeDomainsBySource(array $options = [])
 * @method static DescribeDomainsUsageByDay describeDomainsUsageByDay(array $options = [])
 * @method static DescribeFCTrigger describeFCTrigger(array $options = [])
 * @method static DescribeIpInfo describeIpInfo(array $options = [])
 * @method static DescribeL2VipsByDomain describeL2VipsByDomain(array $options = [])
 * @method static DescribeOneMinuteData describeOneMinuteData(array $options = [])
 * @method static DescribeRangeDataByLocateAndIspService describeRangeDataByLocateAndIspService(array $options = [])
 * @method static DescribeRealtimeDeliveryAcc describeRealtimeDeliveryAcc(array $options = [])
 * @method static DescribeRefreshQuota describeRefreshQuota(array $options = [])
 * @method static DescribeRefreshTasks describeRefreshTasks(array $options = [])
 * @method static DescribeTopDomainsByFlow describeTopDomainsByFlow(array $options = [])
 * @method static DescribeUserConfigs describeUserConfigs(array $options = [])
 * @method static DescribeUserDomains describeUserDomains(array $options = [])
 * @method static DescribeUserUsageDataExportTask describeUserUsageDataExportTask(array $options = [])
 * @method static DescribeUserUsageDetailDataExportTask describeUserUsageDetailDataExportTask(array $options = [])
 * @method static GetUserDomainBlackList getUserDomainBlackList(array $options = [])
 * @method static ListDomainsByLogConfigId listDomainsByLogConfigId(array $options = [])
 * @method static ListFCTrigger listFCTrigger(array $options = [])
 * @method static ModifyCdnDomain modifyCdnDomain(array $options = [])
 * @method static ModifyCdnService modifyCdnService(array $options = [])
 * @method static ModifyCdnSubscribeService modifyCdnSubscribeService(array $options = [])
 * @method static ModifyDomainCustomLogConfig modifyDomainCustomLogConfig(array $options = [])
 * @method static ModifyFileCacheExpiredConfig modifyFileCacheExpiredConfig(array $options = [])
 * @method static ModifyHttpHeaderConfig modifyHttpHeaderConfig(array $options = [])
 * @method static ModifyUserCustomLogConfig modifyUserCustomLogConfig(array $options = [])
 * @method static OpenCdnService openCdnService(array $options = [])
 * @method static PushObjectCache pushObjectCache(array $options = [])
 * @method static RefreshObjectCaches refreshObjectCaches(array $options = [])
 * @method static SetBusinessFunctionConfig setBusinessFunctionConfig(array $options = [])
 * @method static SetCacheExpiredConfig setCacheExpiredConfig(array $options = [])
 * @method static SetCcConfig setCcConfig(array $options = [])
 * @method static SetDomainGreenManagerConfig setDomainGreenManagerConfig(array $options = [])
 * @method static SetDomainServerCertificate setDomainServerCertificate(array $options = [])
 * @method static SetErrorPageConfig setErrorPageConfig(array $options = [])
 * @method static SetFileCacheExpiredConfig setFileCacheExpiredConfig(array $options = [])
 * @method static SetForceRedirectConfig setForceRedirectConfig(array $options = [])
 * @method static SetForwardSchemeConfig setForwardSchemeConfig(array $options = [])
 * @method static SetHttpErrorPageConfig setHttpErrorPageConfig(array $options = [])
 * @method static SetHttpHeaderConfig setHttpHeaderConfig(array $options = [])
 * @method static SetHttpsOptionConfig setHttpsOptionConfig(array $options = [])
 * @method static SetIgnoreQueryStringConfig setIgnoreQueryStringConfig(array $options = [])
 * @method static SetIpAllowListConfig setIpAllowListConfig(array $options = [])
 * @method static SetIpBlackListConfig setIpBlackListConfig(array $options = [])
 * @method static SetL2OssKeyConfig setL2OssKeyConfig(array $options = [])
 * @method static SetLocationAccessRestriction setLocationAccessRestriction(array $options = [])
 * @method static SetOptimizeConfig setOptimizeConfig(array $options = [])
 * @method static SetPageCompressConfig setPageCompressConfig(array $options = [])
 * @method static SetPathCacheExpiredConfig setPathCacheExpiredConfig(array $options = [])
 * @method static SetRangeConfig setRangeConfig(array $options = [])
 * @method static SetRefererConfig setRefererConfig(array $options = [])
 * @method static SetRefererRegexConfig setRefererRegexConfig(array $options = [])
 * @method static SetRemoveQueryStringConfig setRemoveQueryStringConfig(array $options = [])
 * @method static SetReqAuthConfig setReqAuthConfig(array $options = [])
 * @method static SetReqHeaderConfig setReqHeaderConfig(array $options = [])
 * @method static SetSourceHostConfig setSourceHostConfig(array $options = [])
 * @method static SetVideoSeekConfig setVideoSeekConfig(array $options = [])
 * @method static SetWafConfig setWafConfig(array $options = [])
 * @method static SetWaitingRoomConfig setWaitingRoomConfig(array $options = [])
 * @method static StartCdnDomain startCdnDomain(array $options = [])
 * @method static StopCdnDomain stopCdnDomain(array $options = [])
 * @method static UpdateFCTrigger updateFCTrigger(array $options = [])
 */
class Cdn
{
    use ApiResolverTrait;
}
