<?php

namespace AlibabaCloud\CloudAPI\V20160714;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the CloudAPI based on the method name as the Api name.
 *
 * @package   AlibabaCloud\CloudAPI\V20160714
 *
 * @method static AbolishApi abolishApi(array $options = [])
 * @method static AddIpControlPolicyItem addIpControlPolicyItem(array $options = [])
 * @method static AddTrafficSpecialControl addTrafficSpecialControl(array $options = [])
 * @method static CloudAPIApiResolver cloudAPIApiResolver(array $options = [])
 * @method static CreateApi createApi(array $options = [])
 * @method static CreateApiGroup createApiGroup(array $options = [])
 * @method static CreateApiStageVariable createApiStageVariable(array $options = [])
 * @method static CreateApp createApp(array $options = [])
 * @method static CreateIntranetDomain createIntranetDomain(array $options = [])
 * @method static CreateIpControl createIpControl(array $options = [])
 * @method static CreateLogConfig createLogConfig(array $options = [])
 * @method static CreateSignature createSignature(array $options = [])
 * @method static CreateTrafficControl createTrafficControl(array $options = [])
 * @method static DeleteAllTrafficSpecialControl deleteAllTrafficSpecialControl(array $options = [])
 * @method static DeleteApi deleteApi(array $options = [])
 * @method static DeleteApiGroup deleteApiGroup(array $options = [])
 * @method static DeleteApiStageVariable deleteApiStageVariable(array $options = [])
 * @method static DeleteApp deleteApp(array $options = [])
 * @method static DeleteDomain deleteDomain(array $options = [])
 * @method static DeleteDomainCertificate deleteDomainCertificate(array $options = [])
 * @method static DeleteIpControl deleteIpControl(array $options = [])
 * @method static DeleteLogConfig deleteLogConfig(array $options = [])
 * @method static DeleteSignature deleteSignature(array $options = [])
 * @method static DeleteTrafficControl deleteTrafficControl(array $options = [])
 * @method static DeleteTrafficSpecialControl deleteTrafficSpecialControl(array $options = [])
 * @method static DeployApi deployApi(array $options = [])
 * @method static DescribeApi describeApi(array $options = [])
 * @method static DescribeApiDoc describeApiDoc(array $options = [])
 * @method static DescribeApiErrorData describeApiErrorData(array $options = [])
 * @method static DescribeApiGroup describeApiGroup(array $options = [])
 * @method static DescribeApiGroups describeApiGroups(array $options = [])
 * @method static DescribeApiHistories describeApiHistories(array $options = [])
 * @method static DescribeApiHistory describeApiHistory(array $options = [])
 * @method static DescribeApiIpControls describeApiIpControls(array $options = [])
 * @method static DescribeApiLatencyData describeApiLatencyData(array $options = [])
 * @method static DescribeApiQpsData describeApiQpsData(array $options = [])
 * @method static DescribeApiSignatures describeApiSignatures(array $options = [])
 * @method static DescribeApiStage describeApiStage(array $options = [])
 * @method static DescribeApiTrafficControls describeApiTrafficControls(array $options = [])
 * @method static DescribeApiTrafficData describeApiTrafficData(array $options = [])
 * @method static DescribeApis describeApis(array $options = [])
 * @method static DescribeApisByApp describeApisByApp(array $options = [])
 * @method static DescribeApisByIpControl describeApisByIpControl(array $options = [])
 * @method static DescribeApisBySignature describeApisBySignature(array $options = [])
 * @method static DescribeApisByTrafficControl describeApisByTrafficControl(array $options = [])
 * @method static DescribeApp describeApp(array $options = [])
 * @method static DescribeAppAttributes describeAppAttributes(array $options = [])
 * @method static DescribeAppSecurity describeAppSecurity(array $options = [])
 * @method static DescribeApps describeApps(array $options = [])
 * @method static DescribeAuthorizedApis describeAuthorizedApis(array $options = [])
 * @method static DescribeAuthorizedApps describeAuthorizedApps(array $options = [])
 * @method static DescribeDeployedApi describeDeployedApi(array $options = [])
 * @method static DescribeDeployedApis describeDeployedApis(array $options = [])
 * @method static DescribeDomain describeDomain(array $options = [])
 * @method static DescribeDomainsResolution describeDomainsResolution(array $options = [])
 * @method static DescribeHistoryApis describeHistoryApis(array $options = [])
 * @method static DescribeIpControlPolicyItems describeIpControlPolicyItems(array $options = [])
 * @method static DescribeIpControls describeIpControls(array $options = [])
 * @method static DescribeLogConfig describeLogConfig(array $options = [])
 * @method static DescribePurchasedApiGroup describePurchasedApiGroup(array $options = [])
 * @method static DescribePurchasedApiGroups describePurchasedApiGroups(array $options = [])
 * @method static DescribePurchasedApis describePurchasedApis(array $options = [])
 * @method static DescribeRegions describeRegions(array $options = [])
 * @method static DescribeSignatures describeSignatures(array $options = [])
 * @method static DescribeSignaturesByApi describeSignaturesByApi(array $options = [])
 * @method static DescribeSystemParameters describeSystemParameters(array $options = [])
 * @method static DescribeTrafficControls describeTrafficControls(array $options = [])
 * @method static DescribeTrafficControlsByApi describeTrafficControlsByApi(array $options = [])
 * @method static DescribeVpcAccesses describeVpcAccesses(array $options = [])
 * @method static ImportSwagger importSwagger(array $options = [])
 * @method static ModifyApi modifyApi(array $options = [])
 * @method static ModifyApiGroup modifyApiGroup(array $options = [])
 * @method static ModifyApp modifyApp(array $options = [])
 * @method static ModifyIpControl modifyIpControl(array $options = [])
 * @method static ModifyIpControlPolicyItem modifyIpControlPolicyItem(array $options = [])
 * @method static ModifyLogConfig modifyLogConfig(array $options = [])
 * @method static ModifySignature modifySignature(array $options = [])
 * @method static ModifyTrafficControl modifyTrafficControl(array $options = [])
 * @method static ReactivateDomain reactivateDomain(array $options = [])
 * @method static RemoveApisAuthorities removeApisAuthorities(array $options = [])
 * @method static RemoveAppsAuthorities removeAppsAuthorities(array $options = [])
 * @method static RemoveIpControlApis removeIpControlApis(array $options = [])
 * @method static RemoveIpControlPolicyItem removeIpControlPolicyItem(array $options = [])
 * @method static RemoveSignatureApis removeSignatureApis(array $options = [])
 * @method static RemoveTrafficControlApis removeTrafficControlApis(array $options = [])
 * @method static RemoveVpcAccess removeVpcAccess(array $options = [])
 * @method static ResetAppSecret resetAppSecret(array $options = [])
 * @method static SdkGenerate sdkGenerate(array $options = [])
 * @method static SdkGenerateByApp sdkGenerateByApp(array $options = [])
 * @method static SdkGenerateByGroup sdkGenerateByGroup(array $options = [])
 * @method static SetApisAuthorities setApisAuthorities(array $options = [])
 * @method static SetAppsAuthorities setAppsAuthorities(array $options = [])
 * @method static SetDomain setDomain(array $options = [])
 * @method static SetDomainCertificate setDomainCertificate(array $options = [])
 * @method static SetDomainWebSocketStatus setDomainWebSocketStatus(array $options = [])
 * @method static SetIpControlApis setIpControlApis(array $options = [])
 * @method static SetSignatureApis setSignatureApis(array $options = [])
 * @method static SetTrafficControlApis setTrafficControlApis(array $options = [])
 * @method static SetVpcAccess setVpcAccess(array $options = [])
 * @method static SwitchApi switchApi(array $options = [])
 */
class CloudAPI
{
    use ApiResolverTrait;
}
