<?php

namespace AlibabaCloud\CloudPhoto\V20170711;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the CloudPhoto based on the method name as the Api name.
 *
 * @package   AlibabaCloud\CloudPhoto\V20170711
 *
 * @method static ActivatePhotos activatePhotos(array $options = [])
 * @method static AddAlbumPhotos addAlbumPhotos(array $options = [])
 * @method static CloudPhotoApiResolver cloudPhotoApiResolver(array $options = [])
 * @method static CreateAlbum createAlbum(array $options = [])
 * @method static CreateEvent createEvent(array $options = [])
 * @method static CreatePhoto createPhoto(array $options = [])
 * @method static CreatePhotoStore createPhotoStore(array $options = [])
 * @method static CreateTransaction createTransaction(array $options = [])
 * @method static DeleteAlbums deleteAlbums(array $options = [])
 * @method static DeleteEvent deleteEvent(array $options = [])
 * @method static DeleteFaces deleteFaces(array $options = [])
 * @method static DeletePhotoStore deletePhotoStore(array $options = [])
 * @method static DeletePhotos deletePhotos(array $options = [])
 * @method static EditEvent editEvent(array $options = [])
 * @method static EditPhotoStore editPhotoStore(array $options = [])
 * @method static EditPhotos editPhotos(array $options = [])
 * @method static FetchAlbumTagPhotos fetchAlbumTagPhotos(array $options = [])
 * @method static FetchLibraries fetchLibraries(array $options = [])
 * @method static FetchMomentPhotos fetchMomentPhotos(array $options = [])
 * @method static FetchPhotos fetchPhotos(array $options = [])
 * @method static GetAlbumsByNames getAlbumsByNames(array $options = [])
 * @method static GetDownloadUrl getDownloadUrl(array $options = [])
 * @method static GetDownloadUrls getDownloadUrls(array $options = [])
 * @method static GetEvent getEvent(array $options = [])
 * @method static GetFramedPhotoUrls getFramedPhotoUrls(array $options = [])
 * @method static GetLibrary getLibrary(array $options = [])
 * @method static GetPhotoStore getPhotoStore(array $options = [])
 * @method static GetPhotos getPhotos(array $options = [])
 * @method static GetPhotosByMd5s getPhotosByMd5s(array $options = [])
 * @method static GetPrivateAccessUrls getPrivateAccessUrls(array $options = [])
 * @method static GetPublicAccessUrls getPublicAccessUrls(array $options = [])
 * @method static GetQuota getQuota(array $options = [])
 * @method static GetSimilarPhotos getSimilarPhotos(array $options = [])
 * @method static GetThumbnail getThumbnail(array $options = [])
 * @method static GetThumbnails getThumbnails(array $options = [])
 * @method static GetVideoCover getVideoCover(array $options = [])
 * @method static InactivatePhotos inactivatePhotos(array $options = [])
 * @method static LikePhoto likePhoto(array $options = [])
 * @method static ListAlbumPhotos listAlbumPhotos(array $options = [])
 * @method static ListAlbumTagPhotos listAlbumTagPhotos(array $options = [])
 * @method static ListAlbums listAlbums(array $options = [])
 * @method static ListEvents listEvents(array $options = [])
 * @method static ListFacePhotos listFacePhotos(array $options = [])
 * @method static ListFaces listFaces(array $options = [])
 * @method static ListMomentPhotos listMomentPhotos(array $options = [])
 * @method static ListMoments listMoments(array $options = [])
 * @method static ListPhotoFaces listPhotoFaces(array $options = [])
 * @method static ListPhotoStores listPhotoStores(array $options = [])
 * @method static ListPhotoTags listPhotoTags(array $options = [])
 * @method static ListPhotos listPhotos(array $options = [])
 * @method static ListRegisteredTags listRegisteredTags(array $options = [])
 * @method static ListTagPhotos listTagPhotos(array $options = [])
 * @method static ListTags listTags(array $options = [])
 * @method static ListTimeLinePhotos listTimeLinePhotos(array $options = [])
 * @method static ListTimeLines listTimeLines(array $options = [])
 * @method static MergeFaces mergeFaces(array $options = [])
 * @method static MoveAlbumPhotos moveAlbumPhotos(array $options = [])
 * @method static MoveFacePhotos moveFacePhotos(array $options = [])
 * @method static ReactivatePhotos reactivatePhotos(array $options = [])
 * @method static RegisterPhoto registerPhoto(array $options = [])
 * @method static RegisterTag registerTag(array $options = [])
 * @method static RemoveAlbumPhotos removeAlbumPhotos(array $options = [])
 * @method static RemoveFacePhotos removeFacePhotos(array $options = [])
 * @method static RenameAlbum renameAlbum(array $options = [])
 * @method static RenameFace renameFace(array $options = [])
 * @method static SearchPhotos searchPhotos(array $options = [])
 * @method static SetAlbumCover setAlbumCover(array $options = [])
 * @method static SetFaceCover setFaceCover(array $options = [])
 * @method static SetMe setMe(array $options = [])
 * @method static SetQuota setQuota(array $options = [])
 * @method static TagPhoto tagPhoto(array $options = [])
 * @method static ToggleFeatures toggleFeatures(array $options = [])
 */
class CloudPhoto
{
    use ApiResolverTrait;
}
