<?php

namespace AlibabaCloud\CloudPhoto\V20170711;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the CloudPhoto based on the method name as the Api name.
 *
 * @package   AlibabaCloud\CloudPhoto\V20170711
 *
 * @method ActivatePhotos activatePhotos(array $options = [])
 * @method AddAlbumPhotos addAlbumPhotos(array $options = [])
 * @method CreateAlbum createAlbum(array $options = [])
 * @method CreateEvent createEvent(array $options = [])
 * @method CreatePhoto createPhoto(array $options = [])
 * @method CreatePhotoStore createPhotoStore(array $options = [])
 * @method CreateTransaction createTransaction(array $options = [])
 * @method DeleteAlbums deleteAlbums(array $options = [])
 * @method DeleteEvent deleteEvent(array $options = [])
 * @method DeleteFaces deleteFaces(array $options = [])
 * @method DeletePhotoStore deletePhotoStore(array $options = [])
 * @method DeletePhotos deletePhotos(array $options = [])
 * @method EditEvent editEvent(array $options = [])
 * @method EditPhotoStore editPhotoStore(array $options = [])
 * @method EditPhotos editPhotos(array $options = [])
 * @method FetchAlbumTagPhotos fetchAlbumTagPhotos(array $options = [])
 * @method FetchLibraries fetchLibraries(array $options = [])
 * @method FetchMomentPhotos fetchMomentPhotos(array $options = [])
 * @method FetchPhotos fetchPhotos(array $options = [])
 * @method GetAlbumsByNames getAlbumsByNames(array $options = [])
 * @method GetDownloadUrl getDownloadUrl(array $options = [])
 * @method GetDownloadUrls getDownloadUrls(array $options = [])
 * @method GetEvent getEvent(array $options = [])
 * @method GetFramedPhotoUrls getFramedPhotoUrls(array $options = [])
 * @method GetLibrary getLibrary(array $options = [])
 * @method GetPhotoStore getPhotoStore(array $options = [])
 * @method GetPhotos getPhotos(array $options = [])
 * @method GetPhotosByMd5s getPhotosByMd5s(array $options = [])
 * @method GetPrivateAccessUrls getPrivateAccessUrls(array $options = [])
 * @method GetPublicAccessUrls getPublicAccessUrls(array $options = [])
 * @method GetQuota getQuota(array $options = [])
 * @method GetSimilarPhotos getSimilarPhotos(array $options = [])
 * @method GetThumbnail getThumbnail(array $options = [])
 * @method GetThumbnails getThumbnails(array $options = [])
 * @method GetVideoCover getVideoCover(array $options = [])
 * @method InactivatePhotos inactivatePhotos(array $options = [])
 * @method LikePhoto likePhoto(array $options = [])
 * @method ListAlbumPhotos listAlbumPhotos(array $options = [])
 * @method ListAlbumTagPhotos listAlbumTagPhotos(array $options = [])
 * @method ListAlbums listAlbums(array $options = [])
 * @method ListEvents listEvents(array $options = [])
 * @method ListFacePhotos listFacePhotos(array $options = [])
 * @method ListFaces listFaces(array $options = [])
 * @method ListMomentPhotos listMomentPhotos(array $options = [])
 * @method ListMoments listMoments(array $options = [])
 * @method ListPhotoFaces listPhotoFaces(array $options = [])
 * @method ListPhotoStores listPhotoStores(array $options = [])
 * @method ListPhotoTags listPhotoTags(array $options = [])
 * @method ListPhotos listPhotos(array $options = [])
 * @method ListRegisteredTags listRegisteredTags(array $options = [])
 * @method ListTagPhotos listTagPhotos(array $options = [])
 * @method ListTags listTags(array $options = [])
 * @method ListTimeLinePhotos listTimeLinePhotos(array $options = [])
 * @method ListTimeLines listTimeLines(array $options = [])
 * @method MergeFaces mergeFaces(array $options = [])
 * @method MoveAlbumPhotos moveAlbumPhotos(array $options = [])
 * @method MoveFacePhotos moveFacePhotos(array $options = [])
 * @method ReactivatePhotos reactivatePhotos(array $options = [])
 * @method RegisterPhoto registerPhoto(array $options = [])
 * @method RegisterTag registerTag(array $options = [])
 * @method RemoveAlbumPhotos removeAlbumPhotos(array $options = [])
 * @method RemoveFacePhotos removeFacePhotos(array $options = [])
 * @method RenameAlbum renameAlbum(array $options = [])
 * @method RenameFace renameFace(array $options = [])
 * @method SearchPhotos searchPhotos(array $options = [])
 * @method SetAlbumCover setAlbumCover(array $options = [])
 * @method SetFaceCover setFaceCover(array $options = [])
 * @method SetMe setMe(array $options = [])
 * @method SetQuota setQuota(array $options = [])
 * @method TagPhoto tagPhoto(array $options = [])
 * @method ToggleFeatures toggleFeatures(array $options = [])
 */
class CloudPhotoApiResolver
{
    use ApiResolverTrait;
}
