<?php

namespace AlibabaCloud\Dds\V20151201;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the Dds based on the method name as the Api name.
 *
 * @package   AlibabaCloud\Dds\V20151201
 *
 * @method static AddBindingTunnel addBindingTunnel(array $options = [])
 * @method static AddMonitorNode addMonitorNode(array $options = [])
 * @method static AllocatePublicNetworkAddress allocatePublicNetworkAddress(array $options = [])
 * @method static BindTunnel bindTunnel(array $options = [])
 * @method static CheckConnectivity checkConnectivity(array $options = [])
 * @method static CreateBackup createBackup(array $options = [])
 * @method static CreateDBInstance createDBInstance(array $options = [])
 * @method static CreateMonitorInstance createMonitorInstance(array $options = [])
 * @method static CreateNode createNode(array $options = [])
 * @method static CreateRecommendationTask createRecommendationTask(array $options = [])
 * @method static CreateReplicationGroup createReplicationGroup(array $options = [])
 * @method static CreateShardingDBInstance createShardingDBInstance(array $options = [])
 * @method static CreateStaticVerification createStaticVerification(array $options = [])
 * @method static DdsApiResolver ddsApiResolver(array $options = [])
 * @method static DeleteDBInstance deleteDBInstance(array $options = [])
 * @method static DeleteMonitorInstance deleteMonitorInstance(array $options = [])
 * @method static DeleteMonitorNode deleteMonitorNode(array $options = [])
 * @method static DeleteNode deleteNode(array $options = [])
 * @method static DeleteReplicationGroup deleteReplicationGroup(array $options = [])
 * @method static DescribeAccounts describeAccounts(array $options = [])
 * @method static DescribeActiveOperationTask describeActiveOperationTask(array $options = [])
 * @method static DescribeActiveOperationTaskCount describeActiveOperationTaskCount(array $options = [])
 * @method static DescribeActiveOperationTaskRegion describeActiveOperationTaskRegion(array $options = [])
 * @method static DescribeActiveOperationTaskType describeActiveOperationTaskType(array $options = [])
 * @method static DescribeAuditFiles describeAuditFiles(array $options = [])
 * @method static DescribeAuditLogFilter describeAuditLogFilter(array $options = [])
 * @method static DescribeAuditPolicy describeAuditPolicy(array $options = [])
 * @method static DescribeAuditRecords describeAuditRecords(array $options = [])
 * @method static DescribeAvailableEngineVersion describeAvailableEngineVersion(array $options = [])
 * @method static DescribeAvailableTimeRange describeAvailableTimeRange(array $options = [])
 * @method static DescribeAvaliableTimeRange describeAvaliableTimeRange(array $options = [])
 * @method static DescribeBackupPolicy describeBackupPolicy(array $options = [])
 * @method static DescribeBackups describeBackups(array $options = [])
 * @method static DescribeConnectionInfo describeConnectionInfo(array $options = [])
 * @method static DescribeDBInstanceAttribute describeDBInstanceAttribute(array $options = [])
 * @method static DescribeDBInstanceMonitor describeDBInstanceMonitor(array $options = [])
 * @method static DescribeDBInstancePerformance describeDBInstancePerformance(array $options = [])
 * @method static DescribeDBInstanceSSL describeDBInstanceSSL(array $options = [])
 * @method static DescribeDBInstances describeDBInstances(array $options = [])
 * @method static DescribeDynamicVerificationList describeDynamicVerificationList(array $options = [])
 * @method static DescribeErrorLogRecords describeErrorLogRecords(array $options = [])
 * @method static DescribeIndexRecommendation describeIndexRecommendation(array $options = [])
 * @method static DescribeInstanceAutoRenewalAttribute describeInstanceAutoRenewalAttribute(array $options = [])
 * @method static DescribeKernelReleaseNotes describeKernelReleaseNotes(array $options = [])
 * @method static DescribeMonitorAttribute describeMonitorAttribute(array $options = [])
 * @method static DescribeMonitorInstances describeMonitorInstances(array $options = [])
 * @method static DescribeParameterModificationHistory describeParameterModificationHistory(array $options = [])
 * @method static DescribeParameterTemplates describeParameterTemplates(array $options = [])
 * @method static DescribeParameters describeParameters(array $options = [])
 * @method static DescribePerformanceInfo describePerformanceInfo(array $options = [])
 * @method static DescribeRdsVSwitchs describeRdsVSwitchs(array $options = [])
 * @method static DescribeRdsVpcs describeRdsVpcs(array $options = [])
 * @method static DescribeRegions describeRegions(array $options = [])
 * @method static DescribeRenewalPrice describeRenewalPrice(array $options = [])
 * @method static DescribeReplicaConflictInfo describeReplicaConflictInfo(array $options = [])
 * @method static DescribeReplicaInitializeProgress describeReplicaInitializeProgress(array $options = [])
 * @method static DescribeReplicaPerformance describeReplicaPerformance(array $options = [])
 * @method static DescribeReplicaSetRole describeReplicaSetRole(array $options = [])
 * @method static DescribeReplicaUsage describeReplicaUsage(array $options = [])
 * @method static DescribeReplicas describeReplicas(array $options = [])
 * @method static DescribeReplicationGroup describeReplicationGroup(array $options = [])
 * @method static DescribeRunningLogRecords describeRunningLogRecords(array $options = [])
 * @method static DescribeSecurityIps describeSecurityIps(array $options = [])
 * @method static DescribeShardingNetworkAddress describeShardingNetworkAddress(array $options = [])
 * @method static DescribeSlowLogRecords describeSlowLogRecords(array $options = [])
 * @method static DescribeStaticVerificationList describeStaticVerificationList(array $options = [])
 * @method static DescribeStrategy describeStrategy(array $options = [])
 * @method static DescribeTargetAVZ describeTargetAVZ(array $options = [])
 * @method static DescribeVerificationList describeVerificationList(array $options = [])
 * @method static DestroyInstance destroyInstance(array $options = [])
 * @method static EvaluateFailOverSwitch evaluateFailOverSwitch(array $options = [])
 * @method static EvaluateResource evaluateResource(array $options = [])
 * @method static ListReplicationGroup listReplicationGroup(array $options = [])
 * @method static MigrateToOtherZone migrateToOtherZone(array $options = [])
 * @method static ModifyAccountDescription modifyAccountDescription(array $options = [])
 * @method static ModifyAccountInfo modifyAccountInfo(array $options = [])
 * @method static ModifyActiveOperationPendingTask modifyActiveOperationPendingTask(array $options = [])
 * @method static ModifyActiveOperationTask modifyActiveOperationTask(array $options = [])
 * @method static ModifyAuditLogFilter modifyAuditLogFilter(array $options = [])
 * @method static ModifyAuditPolicy modifyAuditPolicy(array $options = [])
 * @method static ModifyBackupPolicy modifyBackupPolicy(array $options = [])
 * @method static ModifyConnectionInfo modifyConnectionInfo(array $options = [])
 * @method static ModifyDBInstanceConnectionString modifyDBInstanceConnectionString(array $options = [])
 * @method static ModifyDBInstanceDescription modifyDBInstanceDescription(array $options = [])
 * @method static ModifyDBInstanceMaintainTime modifyDBInstanceMaintainTime(array $options = [])
 * @method static ModifyDBInstanceMonitor modifyDBInstanceMonitor(array $options = [])
 * @method static ModifyDBInstanceNetExpireTime modifyDBInstanceNetExpireTime(array $options = [])
 * @method static ModifyDBInstanceNetworkType modifyDBInstanceNetworkType(array $options = [])
 * @method static ModifyDBInstanceSSL modifyDBInstanceSSL(array $options = [])
 * @method static ModifyDBInstanceSpec modifyDBInstanceSpec(array $options = [])
 * @method static ModifyDescribetion modifyDescribetion(array $options = [])
 * @method static ModifyDynamicMode modifyDynamicMode(array $options = [])
 * @method static ModifyGuardDomainMode modifyGuardDomainMode(array $options = [])
 * @method static ModifyInstanceAutoRenewalAttribute modifyInstanceAutoRenewalAttribute(array $options = [])
 * @method static ModifyNodeSpec modifyNodeSpec(array $options = [])
 * @method static ModifyParameter modifyParameter(array $options = [])
 * @method static ModifyParameters modifyParameters(array $options = [])
 * @method static ModifyReplicaDescription modifyReplicaDescription(array $options = [])
 * @method static ModifyReplicaDynamicMode modifyReplicaDynamicMode(array $options = [])
 * @method static ModifyReplicaFilterMode modifyReplicaFilterMode(array $options = [])
 * @method static ModifyReplicaMode modifyReplicaMode(array $options = [])
 * @method static ModifyReplicaRecoverMode modifyReplicaRecoverMode(array $options = [])
 * @method static ModifyReplicaRecoveryMode modifyReplicaRecoveryMode(array $options = [])
 * @method static ModifyReplicaRelation modifyReplicaRelation(array $options = [])
 * @method static ModifyReplicaVerificationMode modifyReplicaVerificationMode(array $options = [])
 * @method static ModifyReplicationGroup modifyReplicationGroup(array $options = [])
 * @method static ModifySecurityIps modifySecurityIps(array $options = [])
 * @method static RebuildInstance rebuildInstance(array $options = [])
 * @method static ReleasePublicNetworkAddress releasePublicNetworkAddress(array $options = [])
 * @method static ReleaseReplica releaseReplica(array $options = [])
 * @method static RenewDBInstance renewDBInstance(array $options = [])
 * @method static ResetAccountPassword resetAccountPassword(array $options = [])
 * @method static RestartDBInstance restartDBInstance(array $options = [])
 * @method static RestoreDBInstance restoreDBInstance(array $options = [])
 * @method static Sample sample(array $options = [])
 * @method static SwitchDBInstanceHA switchDBInstanceHA(array $options = [])
 * @method static SwithcDBInstanceHA swithcDBInstanceHA(array $options = [])
 * @method static TransformToPrePaid transformToPrePaid(array $options = [])
 * @method static UnbindTunnel unbindTunnel(array $options = [])
 * @method static UpgradeDBInstanceEngineVersion upgradeDBInstanceEngineVersion(array $options = [])
 * @method static UpgradeDBInstanceKernelVersion upgradeDBInstanceKernelVersion(array $options = [])
 */
class Dds
{
    use ApiResolverTrait;
}
