<?php

namespace AlibabaCloud\Ecs\V20140526;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the Ecs based on the method name as the Api name.
 *
 * @package   AlibabaCloud\Ecs\V20140526
 *
 * @method static AcceptInquiredSystemEvent acceptInquiredSystemEvent(array $options = [])
 * @method static ActivateRouterInterface activateRouterInterface(array $options = [])
 * @method static AddBandwidthPackageIps addBandwidthPackageIps(array $options = [])
 * @method static AddTags addTags(array $options = [])
 * @method static AllocateDedicatedHosts allocateDedicatedHosts(array $options = [])
 * @method static AllocateEipAddress allocateEipAddress(array $options = [])
 * @method static AllocatePublicIpAddress allocatePublicIpAddress(array $options = [])
 * @method static ApplyAutoSnapshotPolicy applyAutoSnapshotPolicy(array $options = [])
 * @method static ArchiveInstance archiveInstance(array $options = [])
 * @method static AssignIpv6Addresses assignIpv6Addresses(array $options = [])
 * @method static AssignPrivateIpAddresses assignPrivateIpAddresses(array $options = [])
 * @method static AssociateEipAddress associateEipAddress(array $options = [])
 * @method static AssociateHaVip associateHaVip(array $options = [])
 * @method static AttachClassicLinkVpc attachClassicLinkVpc(array $options = [])
 * @method static AttachDisk attachDisk(array $options = [])
 * @method static AttachInstanceRamRole attachInstanceRamRole(array $options = [])
 * @method static AttachKeyPair attachKeyPair(array $options = [])
 * @method static AttachNetworkInterface attachNetworkInterface(array $options = [])
 * @method static AuthorizeSecurityGroup authorizeSecurityGroup(array $options = [])
 * @method static AuthorizeSecurityGroupEgress authorizeSecurityGroupEgress(array $options = [])
 * @method static CancelAutoSnapshotPolicy cancelAutoSnapshotPolicy(array $options = [])
 * @method static CancelCopyImage cancelCopyImage(array $options = [])
 * @method static CancelPhysicalConnection cancelPhysicalConnection(array $options = [])
 * @method static CancelSimulatedSystemEvents cancelSimulatedSystemEvents(array $options = [])
 * @method static CancelTask cancelTask(array $options = [])
 * @method static ConnectRouterInterface connectRouterInterface(array $options = [])
 * @method static ConvertNatPublicIpToEip convertNatPublicIpToEip(array $options = [])
 * @method static CopyImage copyImage(array $options = [])
 * @method static CreateAutoSnapshotPolicy createAutoSnapshotPolicy(array $options = [])
 * @method static CreateAxtCommand createAxtCommand(array $options = [])
 * @method static CreateAxtTask createAxtTask(array $options = [])
 * @method static CreateCommand createCommand(array $options = [])
 * @method static CreateContainerInstances createContainerInstances(array $options = [])
 * @method static CreateDeploymentSet createDeploymentSet(array $options = [])
 * @method static CreateDisk createDisk(array $options = [])
 * @method static CreateForwardEntry createForwardEntry(array $options = [])
 * @method static CreateHaVip createHaVip(array $options = [])
 * @method static CreateHpcCluster createHpcCluster(array $options = [])
 * @method static CreateImage createImage(array $options = [])
 * @method static CreateInstance createInstance(array $options = [])
 * @method static CreateInstancesSystemEvent createInstancesSystemEvent(array $options = [])
 * @method static CreateKeyPair createKeyPair(array $options = [])
 * @method static CreateLaunchTemplate createLaunchTemplate(array $options = [])
 * @method static CreateLaunchTemplateVersion createLaunchTemplateVersion(array $options = [])
 * @method static CreateNatGateway createNatGateway(array $options = [])
 * @method static CreateNetworkInterface createNetworkInterface(array $options = [])
 * @method static CreateNetworkInterfacePermission createNetworkInterfacePermission(array $options = [])
 * @method static CreatePhysicalConnection createPhysicalConnection(array $options = [])
 * @method static CreateRouteEntry createRouteEntry(array $options = [])
 * @method static CreateRouterInterface createRouterInterface(array $options = [])
 * @method static CreateSecurityGroup createSecurityGroup(array $options = [])
 * @method static CreateSimulatedSystemEvents createSimulatedSystemEvents(array $options = [])
 * @method static CreateSnapshot createSnapshot(array $options = [])
 * @method static CreateVSwitch createVSwitch(array $options = [])
 * @method static CreateVirtualBorderRouter createVirtualBorderRouter(array $options = [])
 * @method static CreateVpc createVpc(array $options = [])
 * @method static DeactivateRouterInterface deactivateRouterInterface(array $options = [])
 * @method static DeleteAutoSnapshotPolicy deleteAutoSnapshotPolicy(array $options = [])
 * @method static DeleteAxtCommand deleteAxtCommand(array $options = [])
 * @method static DeleteBandwidthPackage deleteBandwidthPackage(array $options = [])
 * @method static DeleteCommand deleteCommand(array $options = [])
 * @method static DeleteContainerInstance deleteContainerInstance(array $options = [])
 * @method static DeleteDeploymentSet deleteDeploymentSet(array $options = [])
 * @method static DeleteDisk deleteDisk(array $options = [])
 * @method static DeleteForwardEntry deleteForwardEntry(array $options = [])
 * @method static DeleteHaVip deleteHaVip(array $options = [])
 * @method static DeleteHpcCluster deleteHpcCluster(array $options = [])
 * @method static DeleteImage deleteImage(array $options = [])
 * @method static DeleteInstance deleteInstance(array $options = [])
 * @method static DeleteKeyPairs deleteKeyPairs(array $options = [])
 * @method static DeleteLaunchTemplate deleteLaunchTemplate(array $options = [])
 * @method static DeleteLaunchTemplateVersion deleteLaunchTemplateVersion(array $options = [])
 * @method static DeleteNatGateway deleteNatGateway(array $options = [])
 * @method static DeleteNetworkInterface deleteNetworkInterface(array $options = [])
 * @method static DeleteNetworkInterfacePermission deleteNetworkInterfacePermission(array $options = [])
 * @method static DeletePhysicalConnection deletePhysicalConnection(array $options = [])
 * @method static DeleteRouteEntry deleteRouteEntry(array $options = [])
 * @method static DeleteRouterInterface deleteRouterInterface(array $options = [])
 * @method static DeleteSecurityGroup deleteSecurityGroup(array $options = [])
 * @method static DeleteSnapshot deleteSnapshot(array $options = [])
 * @method static DeleteVSwitch deleteVSwitch(array $options = [])
 * @method static DeleteVirtualBorderRouter deleteVirtualBorderRouter(array $options = [])
 * @method static DeleteVpc deleteVpc(array $options = [])
 * @method static DescribeAccessPoints describeAccessPoints(array $options = [])
 * @method static DescribeAccountAttributes describeAccountAttributes(array $options = [])
 * @method static DescribeAutoSnapshotPolicyEx describeAutoSnapshotPolicyEx(array $options = [])
 * @method static DescribeAvailableResource describeAvailableResource(array $options = [])
 * @method static DescribeAvailableZones describeAvailableZones(array $options = [])
 * @method static DescribeAxtCommand describeAxtCommand(array $options = [])
 * @method static DescribeAxtTask describeAxtTask(array $options = [])
 * @method static DescribeAxtTaskResult describeAxtTaskResult(array $options = [])
 * @method static DescribeBandwidthLimitation describeBandwidthLimitation(array $options = [])
 * @method static DescribeBandwidthPackages describeBandwidthPackages(array $options = [])
 * @method static DescribeBandwidthSpec describeBandwidthSpec(array $options = [])
 * @method static DescribeClassicLinkInstances describeClassicLinkInstances(array $options = [])
 * @method static DescribeCloudAssistantStatus describeCloudAssistantStatus(array $options = [])
 * @method static DescribeClusters describeClusters(array $options = [])
 * @method static DescribeCommands describeCommands(array $options = [])
 * @method static DescribeDedicatedHostAutoRenew describeDedicatedHostAutoRenew(array $options = [])
 * @method static DescribeDedicatedHostTypes describeDedicatedHostTypes(array $options = [])
 * @method static DescribeDedicatedHosts describeDedicatedHosts(array $options = [])
 * @method static DescribeDeploymentSets describeDeploymentSets(array $options = [])
 * @method static DescribeDiskMonitorData describeDiskMonitorData(array $options = [])
 * @method static DescribeDisks describeDisks(array $options = [])
 * @method static DescribeDisksFullStatus describeDisksFullStatus(array $options = [])
 * @method static DescribeEipAddresses describeEipAddresses(array $options = [])
 * @method static DescribeEipMonitorData describeEipMonitorData(array $options = [])
 * @method static DescribeEniMonitorData describeEniMonitorData(array $options = [])
 * @method static DescribeForwardTableEntries describeForwardTableEntries(array $options = [])
 * @method static DescribeForwardTables describeForwardTables(array $options = [])
 * @method static DescribeGroupReferences describeGroupReferences(array $options = [])
 * @method static DescribeHaVips describeHaVips(array $options = [])
 * @method static DescribeHpcClusters describeHpcClusters(array $options = [])
 * @method static DescribeImageSharePermission describeImageSharePermission(array $options = [])
 * @method static DescribeImageSupportInstanceTypes describeImageSupportInstanceTypes(array $options = [])
 * @method static DescribeImages describeImages(array $options = [])
 * @method static DescribeInstanceAttribute describeInstanceAttribute(array $options = [])
 * @method static DescribeInstanceAutoRenewAttribute describeInstanceAutoRenewAttribute(array $options = [])
 * @method static DescribeInstanceAutoRenewList describeInstanceAutoRenewList(array $options = [])
 * @method static DescribeInstanceBusinessMonitorData describeInstanceBusinessMonitorData(array $options = [])
 * @method static DescribeInstanceHistoryEvents describeInstanceHistoryEvents(array $options = [])
 * @method static DescribeInstanceKeyPairInfo describeInstanceKeyPairInfo(array $options = [])
 * @method static DescribeInstanceMonitorData describeInstanceMonitorData(array $options = [])
 * @method static DescribeInstancePhysicalAttribute describeInstancePhysicalAttribute(array $options = [])
 * @method static DescribeInstanceRamRole describeInstanceRamRole(array $options = [])
 * @method static DescribeInstanceStatus describeInstanceStatus(array $options = [])
 * @method static DescribeInstanceTopology describeInstanceTopology(array $options = [])
 * @method static DescribeInstanceTypeFamilies describeInstanceTypeFamilies(array $options = [])
 * @method static DescribeInstanceTypes describeInstanceTypes(array $options = [])
 * @method static DescribeInstanceVncPasswd describeInstanceVncPasswd(array $options = [])
 * @method static DescribeInstanceVncUrl describeInstanceVncUrl(array $options = [])
 * @method static DescribeInstances describeInstances(array $options = [])
 * @method static DescribeInstancesFullStatus describeInstancesFullStatus(array $options = [])
 * @method static DescribeInvocationResults describeInvocationResults(array $options = [])
 * @method static DescribeInvocations describeInvocations(array $options = [])
 * @method static DescribeKeyPairs describeKeyPairs(array $options = [])
 * @method static DescribeLaunchTemplateVersions describeLaunchTemplateVersions(array $options = [])
 * @method static DescribeLaunchTemplates describeLaunchTemplates(array $options = [])
 * @method static DescribeNatGateways describeNatGateways(array $options = [])
 * @method static DescribeNetworkInterfaceMonitorData describeNetworkInterfaceMonitorData(array $options = [])
 * @method static DescribeNetworkInterfacePermissions describeNetworkInterfacePermissions(array $options = [])
 * @method static DescribeNetworkInterfaces describeNetworkInterfaces(array $options = [])
 * @method static DescribeNewProjectEipMonitorData describeNewProjectEipMonitorData(array $options = [])
 * @method static DescribePhysicalConnections describePhysicalConnections(array $options = [])
 * @method static DescribePrice describePrice(array $options = [])
 * @method static DescribeRecommendInstanceType describeRecommendInstanceType(array $options = [])
 * @method static DescribeRegions describeRegions(array $options = [])
 * @method static DescribeRenewalPrice describeRenewalPrice(array $options = [])
 * @method static DescribeResourceByTags describeResourceByTags(array $options = [])
 * @method static DescribeResourcesModification describeResourcesModification(array $options = [])
 * @method static DescribeRouteTables describeRouteTables(array $options = [])
 * @method static DescribeRouterInterfaces describeRouterInterfaces(array $options = [])
 * @method static DescribeSecurityGroupAttribute describeSecurityGroupAttribute(array $options = [])
 * @method static DescribeSecurityGroupReferences describeSecurityGroupReferences(array $options = [])
 * @method static DescribeSecurityGroups describeSecurityGroups(array $options = [])
 * @method static DescribeSnapshotLinks describeSnapshotLinks(array $options = [])
 * @method static DescribeSnapshotMonitorData describeSnapshotMonitorData(array $options = [])
 * @method static DescribeSnapshotPackage describeSnapshotPackage(array $options = [])
 * @method static DescribeSnapshots describeSnapshots(array $options = [])
 * @method static DescribeSnapshotsUsage describeSnapshotsUsage(array $options = [])
 * @method static DescribeSpotPriceHistory describeSpotPriceHistory(array $options = [])
 * @method static DescribeTags describeTags(array $options = [])
 * @method static DescribeTaskAttribute describeTaskAttribute(array $options = [])
 * @method static DescribeTasks describeTasks(array $options = [])
 * @method static DescribeUserBusinessBehavior describeUserBusinessBehavior(array $options = [])
 * @method static DescribeUserData describeUserData(array $options = [])
 * @method static DescribeUserEventDetail describeUserEventDetail(array $options = [])
 * @method static DescribeVRouters describeVRouters(array $options = [])
 * @method static DescribeVSwitches describeVSwitches(array $options = [])
 * @method static DescribeVirtualBorderRouters describeVirtualBorderRouters(array $options = [])
 * @method static DescribeVirtualBorderRoutersForPhysicalConnection describeVirtualBorderRoutersForPhysicalConnection(array $options = [])
 * @method static DescribeVpcs describeVpcs(array $options = [])
 * @method static DescribeZones describeZones(array $options = [])
 * @method static DetachClassicLinkVpc detachClassicLinkVpc(array $options = [])
 * @method static DetachDisk detachDisk(array $options = [])
 * @method static DetachInstanceRamRole detachInstanceRamRole(array $options = [])
 * @method static DetachKeyPair detachKeyPair(array $options = [])
 * @method static DetachNetworkInterface detachNetworkInterface(array $options = [])
 * @method static EcsApiResolver ecsApiResolver(array $options = [])
 * @method static EipFillParams eipFillParams(array $options = [])
 * @method static EipFillProduct eipFillProduct(array $options = [])
 * @method static EipNotifyPaid eipNotifyPaid(array $options = [])
 * @method static EnablePhysicalConnection enablePhysicalConnection(array $options = [])
 * @method static ExportImage exportImage(array $options = [])
 * @method static ExportSnapshot exportSnapshot(array $options = [])
 * @method static GetInstanceConsoleOutput getInstanceConsoleOutput(array $options = [])
 * @method static GetInstanceScreenshot getInstanceScreenshot(array $options = [])
 * @method static GetLaunchTemplateData getLaunchTemplateData(array $options = [])
 * @method static ImportImage importImage(array $options = [])
 * @method static ImportKeyPair importKeyPair(array $options = [])
 * @method static ImportSnapshot importSnapshot(array $options = [])
 * @method static InstallCloudAssistant installCloudAssistant(array $options = [])
 * @method static InvokeCommand invokeCommand(array $options = [])
 * @method static JoinResourceGroup joinResourceGroup(array $options = [])
 * @method static JoinSecurityGroup joinSecurityGroup(array $options = [])
 * @method static LeaveSecurityGroup leaveSecurityGroup(array $options = [])
 * @method static ModifyAutoSnapshotPolicy modifyAutoSnapshotPolicy(array $options = [])
 * @method static ModifyAutoSnapshotPolicyEx modifyAutoSnapshotPolicyEx(array $options = [])
 * @method static ModifyAxtCommand modifyAxtCommand(array $options = [])
 * @method static ModifyBandwidthPackageSpec modifyBandwidthPackageSpec(array $options = [])
 * @method static ModifyCommand modifyCommand(array $options = [])
 * @method static ModifyDedicatedHostAttribute modifyDedicatedHostAttribute(array $options = [])
 * @method static ModifyDedicatedHostAutoReleaseTime modifyDedicatedHostAutoReleaseTime(array $options = [])
 * @method static ModifyDedicatedHostAutoRenewAttribute modifyDedicatedHostAutoRenewAttribute(array $options = [])
 * @method static ModifyDeploymentSetAttribute modifyDeploymentSetAttribute(array $options = [])
 * @method static ModifyDiskAttribute modifyDiskAttribute(array $options = [])
 * @method static ModifyDiskChargeType modifyDiskChargeType(array $options = [])
 * @method static ModifyEipAddressAttribute modifyEipAddressAttribute(array $options = [])
 * @method static ModifyForwardEntry modifyForwardEntry(array $options = [])
 * @method static ModifyHaVipAttribute modifyHaVipAttribute(array $options = [])
 * @method static ModifyHpcClusterAttribute modifyHpcClusterAttribute(array $options = [])
 * @method static ModifyImageAttribute modifyImageAttribute(array $options = [])
 * @method static ModifyImageShareGroupPermission modifyImageShareGroupPermission(array $options = [])
 * @method static ModifyImageSharePermission modifyImageSharePermission(array $options = [])
 * @method static ModifyInstanceAttribute modifyInstanceAttribute(array $options = [])
 * @method static ModifyInstanceAutoReleaseTime modifyInstanceAutoReleaseTime(array $options = [])
 * @method static ModifyInstanceAutoRenewAttribute modifyInstanceAutoRenewAttribute(array $options = [])
 * @method static ModifyInstanceChargeType modifyInstanceChargeType(array $options = [])
 * @method static ModifyInstanceDeployment modifyInstanceDeployment(array $options = [])
 * @method static ModifyInstanceNetworkSpec modifyInstanceNetworkSpec(array $options = [])
 * @method static ModifyInstanceSpec modifyInstanceSpec(array $options = [])
 * @method static ModifyInstanceVncPasswd modifyInstanceVncPasswd(array $options = [])
 * @method static ModifyInstanceVpcAttribute modifyInstanceVpcAttribute(array $options = [])
 * @method static ModifyLaunchTemplateDefaultVersion modifyLaunchTemplateDefaultVersion(array $options = [])
 * @method static ModifyNetworkInterfaceAttribute modifyNetworkInterfaceAttribute(array $options = [])
 * @method static ModifyPhysicalConnectionAttribute modifyPhysicalConnectionAttribute(array $options = [])
 * @method static ModifyPrepayInstanceSpec modifyPrepayInstanceSpec(array $options = [])
 * @method static ModifyRouterInterfaceAttribute modifyRouterInterfaceAttribute(array $options = [])
 * @method static ModifyRouterInterfaceSpec modifyRouterInterfaceSpec(array $options = [])
 * @method static ModifySecurityGroupAttribute modifySecurityGroupAttribute(array $options = [])
 * @method static ModifySecurityGroupEgressRule modifySecurityGroupEgressRule(array $options = [])
 * @method static ModifySecurityGroupPolicy modifySecurityGroupPolicy(array $options = [])
 * @method static ModifySecurityGroupRule modifySecurityGroupRule(array $options = [])
 * @method static ModifySnapshotAttribute modifySnapshotAttribute(array $options = [])
 * @method static ModifyUserBusinessBehavior modifyUserBusinessBehavior(array $options = [])
 * @method static ModifyUserEventPlanTime modifyUserEventPlanTime(array $options = [])
 * @method static ModifyVRouterAttribute modifyVRouterAttribute(array $options = [])
 * @method static ModifyVSwitchAttribute modifyVSwitchAttribute(array $options = [])
 * @method static ModifyVirtualBorderRouterAttribute modifyVirtualBorderRouterAttribute(array $options = [])
 * @method static ModifyVpcAttribute modifyVpcAttribute(array $options = [])
 * @method static ReActivateInstances reActivateInstances(array $options = [])
 * @method static ReInitDisk reInitDisk(array $options = [])
 * @method static ReInitDisks reInitDisks(array $options = [])
 * @method static RebootInstance rebootInstance(array $options = [])
 * @method static RecallInstancesSystemEvent recallInstancesSystemEvent(array $options = [])
 * @method static RecoverVirtualBorderRouter recoverVirtualBorderRouter(array $options = [])
 * @method static RedeployInstance redeployInstance(array $options = [])
 * @method static ReleaseDedicatedHost releaseDedicatedHost(array $options = [])
 * @method static ReleaseEipAddress releaseEipAddress(array $options = [])
 * @method static ReleasePublicIpAddress releasePublicIpAddress(array $options = [])
 * @method static RemoveBandwidthPackageIps removeBandwidthPackageIps(array $options = [])
 * @method static RemoveTags removeTags(array $options = [])
 * @method static RenewDedicatedHosts renewDedicatedHosts(array $options = [])
 * @method static RenewInstance renewInstance(array $options = [])
 * @method static ReplaceSystemDisk replaceSystemDisk(array $options = [])
 * @method static ResetDisk resetDisk(array $options = [])
 * @method static ResizeDisk resizeDisk(array $options = [])
 * @method static RevokeSecurityGroup revokeSecurityGroup(array $options = [])
 * @method static RevokeSecurityGroupEgress revokeSecurityGroupEgress(array $options = [])
 * @method static RunInstances runInstances(array $options = [])
 * @method static RunPodInstances runPodInstances(array $options = [])
 * @method static SetInstancesSystemEvent setInstancesSystemEvent(array $options = [])
 * @method static StartInstance startInstance(array $options = [])
 * @method static StaticEipFillParams staticEipFillParams(array $options = [])
 * @method static StaticEipNotifyPaid staticEipNotifyPaid(array $options = [])
 * @method static StopAxtTask stopAxtTask(array $options = [])
 * @method static StopInstance stopInstance(array $options = [])
 * @method static StopInvocation stopInvocation(array $options = [])
 * @method static TerminatePhysicalConnection terminatePhysicalConnection(array $options = [])
 * @method static TerminateVirtualBorderRouter terminateVirtualBorderRouter(array $options = [])
 * @method static UnassignIpv6Addresses unassignIpv6Addresses(array $options = [])
 * @method static UnassignPrivateIpAddresses unassignPrivateIpAddresses(array $options = [])
 * @method static UnassociateEipAddress unassociateEipAddress(array $options = [])
 * @method static UnassociateHaVip unassociateHaVip(array $options = [])
 */
class Ecs
{
    use ApiResolverTrait;
}
