<?php

namespace AlibabaCloud\Imm\V20170906;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the Imm based on the method name as the Api name.
 *
 * @package   AlibabaCloud\Imm\V20170906
 *
 * @method static CompareFace compareFace(array $options = [])
 * @method static CompareImageFaces compareImageFaces(array $options = [])
 * @method static ConvertOfficeFormat convertOfficeFormat(array $options = [])
 * @method static CreateCADConversionTask createCADConversionTask(array $options = [])
 * @method static CreateDeleteFaceSetJob createDeleteFaceSetJob(array $options = [])
 * @method static CreateDocIndexTask createDocIndexTask(array $options = [])
 * @method static CreateFaceJob createFaceJob(array $options = [])
 * @method static CreateFaceSet createFaceSet(array $options = [])
 * @method static CreateGroupFacesJob createGroupFacesJob(array $options = [])
 * @method static CreateIndexFaceJob createIndexFaceJob(array $options = [])
 * @method static CreateOfficeConversionTask createOfficeConversionTask(array $options = [])
 * @method static CreatePornBatchDetectJob createPornBatchDetectJob(array $options = [])
 * @method static CreateSet createSet(array $options = [])
 * @method static CreateTagJob createTagJob(array $options = [])
 * @method static CreateTagSet createTagSet(array $options = [])
 * @method static CreateVideoAnalyseTask createVideoAnalyseTask(array $options = [])
 * @method static DeleteDocIndex deleteDocIndex(array $options = [])
 * @method static DeleteFaceById deleteFaceById(array $options = [])
 * @method static DeleteFaceByUrl deleteFaceByUrl(array $options = [])
 * @method static DeleteFaceJob deleteFaceJob(array $options = [])
 * @method static DeleteFaceSearchGroup deleteFaceSearchGroup(array $options = [])
 * @method static DeleteFaceSearchImageById deleteFaceSearchImageById(array $options = [])
 * @method static DeleteFaceSearchUser deleteFaceSearchUser(array $options = [])
 * @method static DeleteFaceSet deleteFaceSet(array $options = [])
 * @method static DeleteImage deleteImage(array $options = [])
 * @method static DeleteImageJob deleteImageJob(array $options = [])
 * @method static DeleteOfficeConversionTask deleteOfficeConversionTask(array $options = [])
 * @method static DeletePhotoProcessTask deletePhotoProcessTask(array $options = [])
 * @method static DeletePornBatchDetectJob deletePornBatchDetectJob(array $options = [])
 * @method static DeleteProject deleteProject(array $options = [])
 * @method static DeleteSet deleteSet(array $options = [])
 * @method static DeleteTagByName deleteTagByName(array $options = [])
 * @method static DeleteTagByUrl deleteTagByUrl(array $options = [])
 * @method static DeleteTagJob deleteTagJob(array $options = [])
 * @method static DeleteTagSet deleteTagSet(array $options = [])
 * @method static DeleteVideo deleteVideo(array $options = [])
 * @method static DeleteVideoTask deleteVideoTask(array $options = [])
 * @method static DescribeRegions describeRegions(array $options = [])
 * @method static DetectClothes detectClothes(array $options = [])
 * @method static DetectFace detectFace(array $options = [])
 * @method static DetectImageCelebrity detectImageCelebrity(array $options = [])
 * @method static DetectImageFaces detectImageFaces(array $options = [])
 * @method static DetectImageTags detectImageTags(array $options = [])
 * @method static DetectImageTexts detectImageTexts(array $options = [])
 * @method static DetectLogo detectLogo(array $options = [])
 * @method static DetectQRCodes detectQRCodes(array $options = [])
 * @method static DetectTag detectTag(array $options = [])
 * @method static FindImages findImages(array $options = [])
 * @method static FindImagesByTagNames findImagesByTagNames(array $options = [])
 * @method static FindSimilarFaces findSimilarFaces(array $options = [])
 * @method static GetDocIndex getDocIndex(array $options = [])
 * @method static GetDocIndexTask getDocIndexTask(array $options = [])
 * @method static GetFaceDetail getFaceDetail(array $options = [])
 * @method static GetFaceJob getFaceJob(array $options = [])
 * @method static GetFaceSearchGroup getFaceSearchGroup(array $options = [])
 * @method static GetFaceSearchImage getFaceSearchImage(array $options = [])
 * @method static GetFaceSearchUser getFaceSearchUser(array $options = [])
 * @method static GetFaceSet getFaceSet(array $options = [])
 * @method static GetFaceSetDetail getFaceSetDetail(array $options = [])
 * @method static GetImage getImage(array $options = [])
 * @method static GetImageJob getImageJob(array $options = [])
 * @method static GetOfficeConversionTask getOfficeConversionTask(array $options = [])
 * @method static GetPhotoProcessTask getPhotoProcessTask(array $options = [])
 * @method static GetPornBatchDetectJob getPornBatchDetectJob(array $options = [])
 * @method static GetProject getProject(array $options = [])
 * @method static GetSet getSet(array $options = [])
 * @method static GetTagJob getTagJob(array $options = [])
 * @method static GetTagSet getTagSet(array $options = [])
 * @method static GetVideo getVideo(array $options = [])
 * @method static GetVideoTask getVideoTask(array $options = [])
 * @method static GroupFaces groupFaces(array $options = [])
 * @method static ImmApiResolver immApiResolver(array $options = [])
 * @method static IndexFace indexFace(array $options = [])
 * @method static IndexImage indexImage(array $options = [])
 * @method static IndexTag indexTag(array $options = [])
 * @method static IndexVideo indexVideo(array $options = [])
 * @method static ListFaceGroupPhotos listFaceGroupPhotos(array $options = [])
 * @method static ListFaceGroups listFaceGroups(array $options = [])
 * @method static ListFaceJobs listFaceJobs(array $options = [])
 * @method static ListFaceSearchGroupImages listFaceSearchGroupImages(array $options = [])
 * @method static ListFaceSearchGroupUsers listFaceSearchGroupUsers(array $options = [])
 * @method static ListFaceSearchGroups listFaceSearchGroups(array $options = [])
 * @method static ListFaceSets listFaceSets(array $options = [])
 * @method static ListImageFaces listImageFaces(array $options = [])
 * @method static ListImageJobs listImageJobs(array $options = [])
 * @method static ListImages listImages(array $options = [])
 * @method static ListOfficeConversionTask listOfficeConversionTask(array $options = [])
 * @method static ListPhotoProcessTasks listPhotoProcessTasks(array $options = [])
 * @method static ListPornBatchDetectJobs listPornBatchDetectJobs(array $options = [])
 * @method static ListProjects listProjects(array $options = [])
 * @method static ListSetTags listSetTags(array $options = [])
 * @method static ListSets listSets(array $options = [])
 * @method static ListTagJobs listTagJobs(array $options = [])
 * @method static ListTagNames listTagNames(array $options = [])
 * @method static ListTagPhotos listTagPhotos(array $options = [])
 * @method static ListTagSets listTagSets(array $options = [])
 * @method static ListVideoAudios listVideoAudios(array $options = [])
 * @method static ListVideoFrames listVideoFrames(array $options = [])
 * @method static ListVideoTasks listVideoTasks(array $options = [])
 * @method static ListVideos listVideos(array $options = [])
 * @method static PhotoProcess photoProcess(array $options = [])
 * @method static PutProject putProject(array $options = [])
 * @method static RegistFace registFace(array $options = [])
 * @method static SearchDocIndex searchDocIndex(array $options = [])
 * @method static SearchFace searchFace(array $options = [])
 * @method static SearchImages searchImages(array $options = [])
 * @method static SearchImagesByTagNames searchImagesByTagNames(array $options = [])
 * @method static UpdateDocIndexMeta updateDocIndexMeta(array $options = [])
 * @method static UpdateFaceGroupById updateFaceGroupById(array $options = [])
 * @method static UpdateImage updateImage(array $options = [])
 * @method static UpdateProject updateProject(array $options = [])
 * @method static UpdateSet updateSet(array $options = [])
 */
class Imm
{
    use ApiResolverTrait;
}
