<?php

namespace AlibabaCloud\Imm\V20170906;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the Imm based on the method name as the Api name.
 *
 * @package   AlibabaCloud\Imm\V20170906
 *
 * @method CompareFace compareFace(array $options = [])
 * @method CompareImageFaces compareImageFaces(array $options = [])
 * @method ConvertOfficeFormat convertOfficeFormat(array $options = [])
 * @method CreateCADConversionTask createCADConversionTask(array $options = [])
 * @method CreateDeleteFaceSetJob createDeleteFaceSetJob(array $options = [])
 * @method CreateDocIndexTask createDocIndexTask(array $options = [])
 * @method CreateFaceJob createFaceJob(array $options = [])
 * @method CreateFaceSet createFaceSet(array $options = [])
 * @method CreateGroupFacesJob createGroupFacesJob(array $options = [])
 * @method CreateIndexFaceJob createIndexFaceJob(array $options = [])
 * @method CreateOfficeConversionTask createOfficeConversionTask(array $options = [])
 * @method CreatePornBatchDetectJob createPornBatchDetectJob(array $options = [])
 * @method CreateSet createSet(array $options = [])
 * @method CreateTagJob createTagJob(array $options = [])
 * @method CreateTagSet createTagSet(array $options = [])
 * @method CreateVideoAnalyseTask createVideoAnalyseTask(array $options = [])
 * @method DeleteDocIndex deleteDocIndex(array $options = [])
 * @method DeleteFaceById deleteFaceById(array $options = [])
 * @method DeleteFaceByUrl deleteFaceByUrl(array $options = [])
 * @method DeleteFaceJob deleteFaceJob(array $options = [])
 * @method DeleteFaceSearchGroup deleteFaceSearchGroup(array $options = [])
 * @method DeleteFaceSearchImageById deleteFaceSearchImageById(array $options = [])
 * @method DeleteFaceSearchUser deleteFaceSearchUser(array $options = [])
 * @method DeleteFaceSet deleteFaceSet(array $options = [])
 * @method DeleteImage deleteImage(array $options = [])
 * @method DeleteImageJob deleteImageJob(array $options = [])
 * @method DeleteOfficeConversionTask deleteOfficeConversionTask(array $options = [])
 * @method DeletePhotoProcessTask deletePhotoProcessTask(array $options = [])
 * @method DeletePornBatchDetectJob deletePornBatchDetectJob(array $options = [])
 * @method DeleteProject deleteProject(array $options = [])
 * @method DeleteSet deleteSet(array $options = [])
 * @method DeleteTagByName deleteTagByName(array $options = [])
 * @method DeleteTagByUrl deleteTagByUrl(array $options = [])
 * @method DeleteTagJob deleteTagJob(array $options = [])
 * @method DeleteTagSet deleteTagSet(array $options = [])
 * @method DeleteVideo deleteVideo(array $options = [])
 * @method DeleteVideoTask deleteVideoTask(array $options = [])
 * @method DescribeRegions describeRegions(array $options = [])
 * @method DetectClothes detectClothes(array $options = [])
 * @method DetectFace detectFace(array $options = [])
 * @method DetectImageCelebrity detectImageCelebrity(array $options = [])
 * @method DetectImageFaces detectImageFaces(array $options = [])
 * @method DetectImageTags detectImageTags(array $options = [])
 * @method DetectImageTexts detectImageTexts(array $options = [])
 * @method DetectLogo detectLogo(array $options = [])
 * @method DetectQRCodes detectQRCodes(array $options = [])
 * @method DetectTag detectTag(array $options = [])
 * @method FindImages findImages(array $options = [])
 * @method FindImagesByTagNames findImagesByTagNames(array $options = [])
 * @method FindSimilarFaces findSimilarFaces(array $options = [])
 * @method GetDocIndex getDocIndex(array $options = [])
 * @method GetDocIndexTask getDocIndexTask(array $options = [])
 * @method GetFaceDetail getFaceDetail(array $options = [])
 * @method GetFaceJob getFaceJob(array $options = [])
 * @method GetFaceSearchGroup getFaceSearchGroup(array $options = [])
 * @method GetFaceSearchImage getFaceSearchImage(array $options = [])
 * @method GetFaceSearchUser getFaceSearchUser(array $options = [])
 * @method GetFaceSet getFaceSet(array $options = [])
 * @method GetFaceSetDetail getFaceSetDetail(array $options = [])
 * @method GetImage getImage(array $options = [])
 * @method GetImageJob getImageJob(array $options = [])
 * @method GetOfficeConversionTask getOfficeConversionTask(array $options = [])
 * @method GetPhotoProcessTask getPhotoProcessTask(array $options = [])
 * @method GetPornBatchDetectJob getPornBatchDetectJob(array $options = [])
 * @method GetProject getProject(array $options = [])
 * @method GetSet getSet(array $options = [])
 * @method GetTagJob getTagJob(array $options = [])
 * @method GetTagSet getTagSet(array $options = [])
 * @method GetVideo getVideo(array $options = [])
 * @method GetVideoTask getVideoTask(array $options = [])
 * @method GroupFaces groupFaces(array $options = [])
 * @method IndexFace indexFace(array $options = [])
 * @method IndexImage indexImage(array $options = [])
 * @method IndexTag indexTag(array $options = [])
 * @method IndexVideo indexVideo(array $options = [])
 * @method ListFaceGroupPhotos listFaceGroupPhotos(array $options = [])
 * @method ListFaceGroups listFaceGroups(array $options = [])
 * @method ListFaceJobs listFaceJobs(array $options = [])
 * @method ListFaceSearchGroupImages listFaceSearchGroupImages(array $options = [])
 * @method ListFaceSearchGroupUsers listFaceSearchGroupUsers(array $options = [])
 * @method ListFaceSearchGroups listFaceSearchGroups(array $options = [])
 * @method ListFaceSets listFaceSets(array $options = [])
 * @method ListImageFaces listImageFaces(array $options = [])
 * @method ListImageJobs listImageJobs(array $options = [])
 * @method ListImages listImages(array $options = [])
 * @method ListOfficeConversionTask listOfficeConversionTask(array $options = [])
 * @method ListPhotoProcessTasks listPhotoProcessTasks(array $options = [])
 * @method ListPornBatchDetectJobs listPornBatchDetectJobs(array $options = [])
 * @method ListProjects listProjects(array $options = [])
 * @method ListSetTags listSetTags(array $options = [])
 * @method ListSets listSets(array $options = [])
 * @method ListTagJobs listTagJobs(array $options = [])
 * @method ListTagNames listTagNames(array $options = [])
 * @method ListTagPhotos listTagPhotos(array $options = [])
 * @method ListTagSets listTagSets(array $options = [])
 * @method ListVideoAudios listVideoAudios(array $options = [])
 * @method ListVideoFrames listVideoFrames(array $options = [])
 * @method ListVideoTasks listVideoTasks(array $options = [])
 * @method ListVideos listVideos(array $options = [])
 * @method PhotoProcess photoProcess(array $options = [])
 * @method PutProject putProject(array $options = [])
 * @method RegistFace registFace(array $options = [])
 * @method SearchDocIndex searchDocIndex(array $options = [])
 * @method SearchFace searchFace(array $options = [])
 * @method SearchImages searchImages(array $options = [])
 * @method SearchImagesByTagNames searchImagesByTagNames(array $options = [])
 * @method UpdateDocIndexMeta updateDocIndexMeta(array $options = [])
 * @method UpdateFaceGroupById updateFaceGroupById(array $options = [])
 * @method UpdateImage updateImage(array $options = [])
 * @method UpdateProject updateProject(array $options = [])
 * @method UpdateSet updateSet(array $options = [])
 */
class ImmApiResolver
{
    use ApiResolverTrait;
}
