<?php

namespace AlibabaCloud\Live\V20161101;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the Live based on the method name as the Api name.
 *
 * @package   AlibabaCloud\Live\V20161101
 *
 * @method static AddCasterComponent addCasterComponent(array $options = [])
 * @method static AddCasterEpisode addCasterEpisode(array $options = [])
 * @method static AddCasterEpisodeGroup addCasterEpisodeGroup(array $options = [])
 * @method static AddCasterEpisodeGroupContent addCasterEpisodeGroupContent(array $options = [])
 * @method static AddCasterLayout addCasterLayout(array $options = [])
 * @method static AddCasterProgram addCasterProgram(array $options = [])
 * @method static AddCasterVideoResource addCasterVideoResource(array $options = [])
 * @method static AddCustomLiveStreamTranscode addCustomLiveStreamTranscode(array $options = [])
 * @method static AddLiveAppRecordConfig addLiveAppRecordConfig(array $options = [])
 * @method static AddLiveAppSnapshotConfig addLiveAppSnapshotConfig(array $options = [])
 * @method static AddLiveDetectNotifyConfig addLiveDetectNotifyConfig(array $options = [])
 * @method static AddLiveDomain addLiveDomain(array $options = [])
 * @method static AddLiveDomainMapping addLiveDomainMapping(array $options = [])
 * @method static AddLiveMixConfig addLiveMixConfig(array $options = [])
 * @method static AddLiveMixNotifyConfig addLiveMixNotifyConfig(array $options = [])
 * @method static AddLivePullStreamInfoConfig addLivePullStreamInfoConfig(array $options = [])
 * @method static AddLiveRecordNotifyConfig addLiveRecordNotifyConfig(array $options = [])
 * @method static AddLiveRecordVodConfig addLiveRecordVodConfig(array $options = [])
 * @method static AddLiveSnapshotDetectPornConfig addLiveSnapshotDetectPornConfig(array $options = [])
 * @method static AddLiveStreamTranscode addLiveStreamTranscode(array $options = [])
 * @method static AddMultipleStreamMixService addMultipleStreamMixService(array $options = [])
 * @method static AddTrancodeSEI addTrancodeSEI(array $options = [])
 * @method static AllowPushStream allowPushStream(array $options = [])
 * @method static ApplyBoardToken applyBoardToken(array $options = [])
 * @method static ApplyRecordToken applyRecordToken(array $options = [])
 * @method static BatchDeleteLiveDomainConfigs batchDeleteLiveDomainConfigs(array $options = [])
 * @method static BatchSetLiveDomainConfigs batchSetLiveDomainConfigs(array $options = [])
 * @method static CompleteBoard completeBoard(array $options = [])
 * @method static CompleteBoardRecord completeBoardRecord(array $options = [])
 * @method static CopyCaster copyCaster(array $options = [])
 * @method static CopyCasterSceneConfig copyCasterSceneConfig(array $options = [])
 * @method static CreateBoard createBoard(array $options = [])
 * @method static CreateCaster createCaster(array $options = [])
 * @method static CreateLiveStreamRecordIndexFiles createLiveStreamRecordIndexFiles(array $options = [])
 * @method static CreateRoom createRoom(array $options = [])
 * @method static DeleteBoard deleteBoard(array $options = [])
 * @method static DeleteCaster deleteCaster(array $options = [])
 * @method static DeleteCasterComponent deleteCasterComponent(array $options = [])
 * @method static DeleteCasterEpisode deleteCasterEpisode(array $options = [])
 * @method static DeleteCasterEpisodeGroup deleteCasterEpisodeGroup(array $options = [])
 * @method static DeleteCasterLayout deleteCasterLayout(array $options = [])
 * @method static DeleteCasterProgram deleteCasterProgram(array $options = [])
 * @method static DeleteCasterSceneConfig deleteCasterSceneConfig(array $options = [])
 * @method static DeleteCasterVideoResource deleteCasterVideoResource(array $options = [])
 * @method static DeleteLiveAppRecordConfig deleteLiveAppRecordConfig(array $options = [])
 * @method static DeleteLiveAppSnapshotConfig deleteLiveAppSnapshotConfig(array $options = [])
 * @method static DeleteLiveDetectNotifyConfig deleteLiveDetectNotifyConfig(array $options = [])
 * @method static DeleteLiveDomain deleteLiveDomain(array $options = [])
 * @method static DeleteLiveDomainMapping deleteLiveDomainMapping(array $options = [])
 * @method static DeleteLiveLazyPullStreamInfoConfig deleteLiveLazyPullStreamInfoConfig(array $options = [])
 * @method static DeleteLiveMixConfig deleteLiveMixConfig(array $options = [])
 * @method static DeleteLiveMixNotifyConfig deleteLiveMixNotifyConfig(array $options = [])
 * @method static DeleteLivePullStreamInfoConfig deleteLivePullStreamInfoConfig(array $options = [])
 * @method static DeleteLiveRecordNotifyConfig deleteLiveRecordNotifyConfig(array $options = [])
 * @method static DeleteLiveRecordVodConfig deleteLiveRecordVodConfig(array $options = [])
 * @method static DeleteLiveSnapshotDetectPornConfig deleteLiveSnapshotDetectPornConfig(array $options = [])
 * @method static DeleteLiveSpecificConfig deleteLiveSpecificConfig(array $options = [])
 * @method static DeleteLiveStreamTranscode deleteLiveStreamTranscode(array $options = [])
 * @method static DeleteLiveStreamsNotifyUrlConfig deleteLiveStreamsNotifyUrlConfig(array $options = [])
 * @method static DeleteRoom deleteRoom(array $options = [])
 * @method static DescribeBoardEvents describeBoardEvents(array $options = [])
 * @method static DescribeBoardSnapshot describeBoardSnapshot(array $options = [])
 * @method static DescribeBoards describeBoards(array $options = [])
 * @method static DescribeCasterChannels describeCasterChannels(array $options = [])
 * @method static DescribeCasterComponents describeCasterComponents(array $options = [])
 * @method static DescribeCasterConfig describeCasterConfig(array $options = [])
 * @method static DescribeCasterLayouts describeCasterLayouts(array $options = [])
 * @method static DescribeCasterProgram describeCasterProgram(array $options = [])
 * @method static DescribeCasterRtcInfo describeCasterRtcInfo(array $options = [])
 * @method static DescribeCasterSceneAudio describeCasterSceneAudio(array $options = [])
 * @method static DescribeCasterScenes describeCasterScenes(array $options = [])
 * @method static DescribeCasterStreamUrl describeCasterStreamUrl(array $options = [])
 * @method static DescribeCasterVideoResources describeCasterVideoResources(array $options = [])
 * @method static DescribeCasters describeCasters(array $options = [])
 * @method static DescribeDomainConfigs describeDomainConfigs(array $options = [])
 * @method static DescribeForbidPushStreamRoomList describeForbidPushStreamRoomList(array $options = [])
 * @method static DescribeHlsLiveStreamRealTimeBpsData describeHlsLiveStreamRealTimeBpsData(array $options = [])
 * @method static DescribeLiveCertificateDetail describeLiveCertificateDetail(array $options = [])
 * @method static DescribeLiveCertificateList describeLiveCertificateList(array $options = [])
 * @method static DescribeLiveDetectNotifyConfig describeLiveDetectNotifyConfig(array $options = [])
 * @method static DescribeLiveDomainBpsData describeLiveDomainBpsData(array $options = [])
 * @method static DescribeLiveDomainConfigs describeLiveDomainConfigs(array $options = [])
 * @method static DescribeLiveDomainDetail describeLiveDomainDetail(array $options = [])
 * @method static DescribeLiveDomainHttpsData describeLiveDomainHttpsData(array $options = [])
 * @method static DescribeLiveDomainMapping describeLiveDomainMapping(array $options = [])
 * @method static DescribeLiveDomainRealTimeBpsData describeLiveDomainRealTimeBpsData(array $options = [])
 * @method static DescribeLiveDomainRealTimeHttpCodeData describeLiveDomainRealTimeHttpCodeData(array $options = [])
 * @method static DescribeLiveDomainRealTimeTrafficData describeLiveDomainRealTimeTrafficData(array $options = [])
 * @method static DescribeLiveDomainRecordData describeLiveDomainRecordData(array $options = [])
 * @method static DescribeLiveDomainSnapshotData describeLiveDomainSnapshotData(array $options = [])
 * @method static DescribeLiveDomainSrcHttpCodeData describeLiveDomainSrcHttpCodeData(array $options = [])
 * @method static DescribeLiveDomainTrafficData describeLiveDomainTrafficData(array $options = [])
 * @method static DescribeLiveDomainTrancodeData describeLiveDomainTrancodeData(array $options = [])
 * @method static DescribeLiveDomainTranscodeData describeLiveDomainTranscodeData(array $options = [])
 * @method static DescribeLiveDomainUvData describeLiveDomainUvData(array $options = [])
 * @method static DescribeLiveLazyPullStreamConfig describeLiveLazyPullStreamConfig(array $options = [])
 * @method static DescribeLiveMixConfig describeLiveMixConfig(array $options = [])
 * @method static DescribeLiveMixNotifyConfig describeLiveMixNotifyConfig(array $options = [])
 * @method static DescribeLivePullStreamConfig describeLivePullStreamConfig(array $options = [])
 * @method static DescribeLiveRecordConfig describeLiveRecordConfig(array $options = [])
 * @method static DescribeLiveRecordNotifyConfig describeLiveRecordNotifyConfig(array $options = [])
 * @method static DescribeLiveRecordVodConfigs describeLiveRecordVodConfigs(array $options = [])
 * @method static DescribeLiveSnapshotConfig describeLiveSnapshotConfig(array $options = [])
 * @method static DescribeLiveSnapshotDetectPornConfig describeLiveSnapshotDetectPornConfig(array $options = [])
 * @method static DescribeLiveStreamBitRateData describeLiveStreamBitRateData(array $options = [])
 * @method static DescribeLiveStreamCount describeLiveStreamCount(array $options = [])
 * @method static DescribeLiveStreamHistoryUserNum describeLiveStreamHistoryUserNum(array $options = [])
 * @method static DescribeLiveStreamOnlineUserNum describeLiveStreamOnlineUserNum(array $options = [])
 * @method static DescribeLiveStreamRecordContent describeLiveStreamRecordContent(array $options = [])
 * @method static DescribeLiveStreamRecordIndexFile describeLiveStreamRecordIndexFile(array $options = [])
 * @method static DescribeLiveStreamRecordIndexFiles describeLiveStreamRecordIndexFiles(array $options = [])
 * @method static DescribeLiveStreamSnapshotInfo describeLiveStreamSnapshotInfo(array $options = [])
 * @method static DescribeLiveStreamTranscodeInfo describeLiveStreamTranscodeInfo(array $options = [])
 * @method static DescribeLiveStreamsBlockList describeLiveStreamsBlockList(array $options = [])
 * @method static DescribeLiveStreamsControlHistory describeLiveStreamsControlHistory(array $options = [])
 * @method static DescribeLiveStreamsFrameRateAndBitRateData describeLiveStreamsFrameRateAndBitRateData(array $options = [])
 * @method static DescribeLiveStreamsNotifyUrlConfig describeLiveStreamsNotifyUrlConfig(array $options = [])
 * @method static DescribeLiveStreamsOnlineList describeLiveStreamsOnlineList(array $options = [])
 * @method static DescribeLiveStreamsPublishList describeLiveStreamsPublishList(array $options = [])
 * @method static DescribeLiveTopDomainsByFlow describeLiveTopDomainsByFlow(array $options = [])
 * @method static DescribeLiveTranscodeInfo describeLiveTranscodeInfo(array $options = [])
 * @method static DescribeLiveUserDomains describeLiveUserDomains(array $options = [])
 * @method static DescribeRecord describeRecord(array $options = [])
 * @method static DescribeRecords describeRecords(array $options = [])
 * @method static DescribeRoomKickoutUserList describeRoomKickoutUserList(array $options = [])
 * @method static DescribeRoomList describeRoomList(array $options = [])
 * @method static DescribeRoomStatus describeRoomStatus(array $options = [])
 * @method static DescribeUpBpsPeakData describeUpBpsPeakData(array $options = [])
 * @method static DescribeUpBpsPeakOfLine describeUpBpsPeakOfLine(array $options = [])
 * @method static DescribeUpPeakPublishStreamData describeUpPeakPublishStreamData(array $options = [])
 * @method static DescribeUserLiveDomains describeUserLiveDomains(array $options = [])
 * @method static EffectCasterUrgent effectCasterUrgent(array $options = [])
 * @method static EffectCasterVideoResource effectCasterVideoResource(array $options = [])
 * @method static ForbidLiveStream forbidLiveStream(array $options = [])
 * @method static ForbidPushStream forbidPushStream(array $options = [])
 * @method static JoinBoard joinBoard(array $options = [])
 * @method static LiveApiResolver liveApiResolver(array $options = [])
 * @method static ModifyCasterComponent modifyCasterComponent(array $options = [])
 * @method static ModifyCasterEpisode modifyCasterEpisode(array $options = [])
 * @method static ModifyCasterLayout modifyCasterLayout(array $options = [])
 * @method static ModifyCasterProgram modifyCasterProgram(array $options = [])
 * @method static ModifyCasterVideoResource modifyCasterVideoResource(array $options = [])
 * @method static RealTimeRecordCommand realTimeRecordCommand(array $options = [])
 * @method static RealTimeSnapshotCommand realTimeSnapshotCommand(array $options = [])
 * @method static RemoveMultipleStreamMixService removeMultipleStreamMixService(array $options = [])
 * @method static ResumeLiveStream resumeLiveStream(array $options = [])
 * @method static SendRoomNotification sendRoomNotification(array $options = [])
 * @method static SendRoomUserNotification sendRoomUserNotification(array $options = [])
 * @method static SetCasterChannel setCasterChannel(array $options = [])
 * @method static SetCasterConfig setCasterConfig(array $options = [])
 * @method static SetCasterSceneConfig setCasterSceneConfig(array $options = [])
 * @method static SetLiveDomainCertificate setLiveDomainCertificate(array $options = [])
 * @method static SetLiveLazyPullStreamInfoConfig setLiveLazyPullStreamInfoConfig(array $options = [])
 * @method static SetLiveStreamsNotifyUrlConfig setLiveStreamsNotifyUrlConfig(array $options = [])
 * @method static StartBoardRecord startBoardRecord(array $options = [])
 * @method static StartCaster startCaster(array $options = [])
 * @method static StartCasterScene startCasterScene(array $options = [])
 * @method static StartLiveDomain startLiveDomain(array $options = [])
 * @method static StartLiveIndex startLiveIndex(array $options = [])
 * @method static StartMixStreamsService startMixStreamsService(array $options = [])
 * @method static StartMultipleStreamMixService startMultipleStreamMixService(array $options = [])
 * @method static StopCaster stopCaster(array $options = [])
 * @method static StopCasterScene stopCasterScene(array $options = [])
 * @method static StopLiveDomain stopLiveDomain(array $options = [])
 * @method static StopLiveIndex stopLiveIndex(array $options = [])
 * @method static StopMixStreamsService stopMixStreamsService(array $options = [])
 * @method static StopMultipleStreamMixService stopMultipleStreamMixService(array $options = [])
 * @method static UpdateBoard updateBoard(array $options = [])
 * @method static UpdateCasterSceneAudio updateCasterSceneAudio(array $options = [])
 * @method static UpdateCasterSceneConfig updateCasterSceneConfig(array $options = [])
 * @method static UpdateLiveAppSnapshotConfig updateLiveAppSnapshotConfig(array $options = [])
 * @method static UpdateLiveDetectNotifyConfig updateLiveDetectNotifyConfig(array $options = [])
 * @method static UpdateLiveMixNotifyConfig updateLiveMixNotifyConfig(array $options = [])
 * @method static UpdateLiveRecordNotifyConfig updateLiveRecordNotifyConfig(array $options = [])
 * @method static UpdateLiveSnapshotDetectPornConfig updateLiveSnapshotDetectPornConfig(array $options = [])
 */
class Live
{
    use ApiResolverTrait;
}
