<?php

namespace AlibabaCloud\Mts\V20140618;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the Mts based on the method name as the Api name.
 *
 * @package   AlibabaCloud\Mts\V20140618
 *
 * @method ActivateMediaWorkflow activateMediaWorkflow(array $options = [])
 * @method AddAsrPipeline addAsrPipeline(array $options = [])
 * @method AddCategory addCategory(array $options = [])
 * @method AddCensorPipeline addCensorPipeline(array $options = [])
 * @method AddCoverPipeline addCoverPipeline(array $options = [])
 * @method AddKwsPipeline addKwsPipeline(array $options = [])
 * @method AddMedia addMedia(array $options = [])
 * @method AddMediaTag addMediaTag(array $options = [])
 * @method AddMediaWorkflow addMediaWorkflow(array $options = [])
 * @method AddPipeline addPipeline(array $options = [])
 * @method AddPornPipeline addPornPipeline(array $options = [])
 * @method AddTemplate addTemplate(array $options = [])
 * @method AddTerrorismPipeline addTerrorismPipeline(array $options = [])
 * @method AddVideoSummaryPipeline addVideoSummaryPipeline(array $options = [])
 * @method AddWaterMarkTemplate addWaterMarkTemplate(array $options = [])
 * @method BindInputBucket bindInputBucket(array $options = [])
 * @method BindOutputBucket bindOutputBucket(array $options = [])
 * @method CancelJob cancelJob(array $options = [])
 * @method CategoryTree categoryTree(array $options = [])
 * @method CheckResource checkResource(array $options = [])
 * @method CreateKwsDictionary createKwsDictionary(array $options = [])
 * @method CreateMcuTemplate createMcuTemplate(array $options = [])
 * @method CreateSession createSession(array $options = [])
 * @method DeactivateMediaWorkflow deactivateMediaWorkflow(array $options = [])
 * @method DecryptKey decryptKey(array $options = [])
 * @method DeleteCategory deleteCategory(array $options = [])
 * @method DeleteKwsDictionary deleteKwsDictionary(array $options = [])
 * @method DeleteMcuJob deleteMcuJob(array $options = [])
 * @method DeleteMcuTemplate deleteMcuTemplate(array $options = [])
 * @method DeleteMedia deleteMedia(array $options = [])
 * @method DeleteMediaTag deleteMediaTag(array $options = [])
 * @method DeleteMediaWorkflow deleteMediaWorkflow(array $options = [])
 * @method DeletePipeline deletePipeline(array $options = [])
 * @method DeleteTemplate deleteTemplate(array $options = [])
 * @method DeleteWaterMarkTemplate deleteWaterMarkTemplate(array $options = [])
 * @method DescribeMtsUserResourcePackage describeMtsUserResourcePackage(array $options = [])
 * @method GetLicense getLicense(array $options = [])
 * @method GetPackage getPackage(array $options = [])
 * @method ListAllCategory listAllCategory(array $options = [])
 * @method ListAllMediaBucket listAllMediaBucket(array $options = [])
 * @method ListAllMediaStorage listAllMediaStorage(array $options = [])
 * @method ListAsrPipeline listAsrPipeline(array $options = [])
 * @method ListCensorPipeline listCensorPipeline(array $options = [])
 * @method ListCoverPipeline listCoverPipeline(array $options = [])
 * @method ListFpShotJob listFpShotJob(array $options = [])
 * @method ListJob listJob(array $options = [])
 * @method ListKwsPipeline listKwsPipeline(array $options = [])
 * @method ListMedia listMedia(array $options = [])
 * @method ListMediaCensorJob listMediaCensorJob(array $options = [])
 * @method ListMediaWorkflowExecutions listMediaWorkflowExecutions(array $options = [])
 * @method ListPornPipeline listPornPipeline(array $options = [])
 * @method ListTerrorismPipeline listTerrorismPipeline(array $options = [])
 * @method ListVideoSummaryPipeline listVideoSummaryPipeline(array $options = [])
 * @method LogicalDeleteResource logicalDeleteResource(array $options = [])
 * @method PhysicalDeleteResource physicalDeleteResource(array $options = [])
 * @method PlayInfo playInfo(array $options = [])
 * @method PlayerAuth playerAuth(array $options = [])
 * @method QueryAnalysisJobList queryAnalysisJobList(array $options = [])
 * @method QueryAnnotationJobList queryAnnotationJobList(array $options = [])
 * @method QueryAsrJobList queryAsrJobList(array $options = [])
 * @method QueryAsrPipelineList queryAsrPipelineList(array $options = [])
 * @method QueryAuthConfig queryAuthConfig(array $options = [])
 * @method QueryCensorJobList queryCensorJobList(array $options = [])
 * @method QueryCensorPipelineList queryCensorPipelineList(array $options = [])
 * @method QueryComplexJobList queryComplexJobList(array $options = [])
 * @method QueryCoverJobList queryCoverJobList(array $options = [])
 * @method QueryCoverPipelineList queryCoverPipelineList(array $options = [])
 * @method QueryEditingJobList queryEditingJobList(array $options = [])
 * @method QueryFacerecogJobList queryFacerecogJobList(array $options = [])
 * @method QueryFpImportResult queryFpImportResult(array $options = [])
 * @method QueryFpShotJobList queryFpShotJobList(array $options = [])
 * @method QueryImageSearchJobList queryImageSearchJobList(array $options = [])
 * @method QueryJobList queryJobList(array $options = [])
 * @method QueryKwsDictionary queryKwsDictionary(array $options = [])
 * @method QueryKwsJobList queryKwsJobList(array $options = [])
 * @method QueryKwsPipelineList queryKwsPipelineList(array $options = [])
 * @method QueryMcuJob queryMcuJob(array $options = [])
 * @method QueryMcuTemplate queryMcuTemplate(array $options = [])
 * @method QueryMediaCensorJobDetail queryMediaCensorJobDetail(array $options = [])
 * @method QueryMediaCensorJobList queryMediaCensorJobList(array $options = [])
 * @method QueryMediaDetailJobList queryMediaDetailJobList(array $options = [])
 * @method QueryMediaInfoJobList queryMediaInfoJobList(array $options = [])
 * @method QueryMediaList queryMediaList(array $options = [])
 * @method QueryMediaListByURL queryMediaListByURL(array $options = [])
 * @method QueryMediaWorkflowExecutionList queryMediaWorkflowExecutionList(array $options = [])
 * @method QueryMediaWorkflowList queryMediaWorkflowList(array $options = [])
 * @method QueryPipelineList queryPipelineList(array $options = [])
 * @method QueryPornJobList queryPornJobList(array $options = [])
 * @method QueryPornPipelineList queryPornPipelineList(array $options = [])
 * @method QuerySnapshotJobList querySnapshotJobList(array $options = [])
 * @method QuerySubtitleJobList querySubtitleJobList(array $options = [])
 * @method QueryTagJobList queryTagJobList(array $options = [])
 * @method QueryTemplateList queryTemplateList(array $options = [])
 * @method QueryTerrorismJobList queryTerrorismJobList(array $options = [])
 * @method QueryTerrorismPipelineList queryTerrorismPipelineList(array $options = [])
 * @method QueryVideoGifJobList queryVideoGifJobList(array $options = [])
 * @method QueryVideoPoseJobList queryVideoPoseJobList(array $options = [])
 * @method QueryVideoSplitJobList queryVideoSplitJobList(array $options = [])
 * @method QueryVideoSummaryJobList queryVideoSummaryJobList(array $options = [])
 * @method QueryVideoSummaryPipelineList queryVideoSummaryPipelineList(array $options = [])
 * @method QueryWaterMarkTemplateList queryWaterMarkTemplateList(array $options = [])
 * @method RefreshCdnDomainConfigsCache refreshCdnDomainConfigsCache(array $options = [])
 * @method RegisterMediaDetailPerson registerMediaDetailPerson(array $options = [])
 * @method RegisterMediaDetailScenario registerMediaDetailScenario(array $options = [])
 * @method ReportAnnotationJobResult reportAnnotationJobResult(array $options = [])
 * @method ReportAsrJobResult reportAsrJobResult(array $options = [])
 * @method ReportCensorJobResult reportCensorJobResult(array $options = [])
 * @method ReportCoverJobResult reportCoverJobResult(array $options = [])
 * @method ReportFacerecogJobResult reportFacerecogJobResult(array $options = [])
 * @method ReportFpShotJobResult reportFpShotJobResult(array $options = [])
 * @method ReportMediaDetailJobResult reportMediaDetailJobResult(array $options = [])
 * @method ReportPornJobResult reportPornJobResult(array $options = [])
 * @method ReportTagJobResult reportTagJobResult(array $options = [])
 * @method ReportTerrorismJobResult reportTerrorismJobResult(array $options = [])
 * @method ReportVideoSplitJobResult reportVideoSplitJobResult(array $options = [])
 * @method SearchMedia searchMedia(array $options = [])
 * @method SearchMediaWorkflow searchMediaWorkflow(array $options = [])
 * @method SearchPipeline searchPipeline(array $options = [])
 * @method SearchTemplate searchTemplate(array $options = [])
 * @method SearchWaterMarkTemplate searchWaterMarkTemplate(array $options = [])
 * @method SetAuthConfig setAuthConfig(array $options = [])
 * @method SubmitAnalysisJob submitAnalysisJob(array $options = [])
 * @method SubmitAnnotationJob submitAnnotationJob(array $options = [])
 * @method SubmitAsrJob submitAsrJob(array $options = [])
 * @method SubmitComplexJob submitComplexJob(array $options = [])
 * @method SubmitCoverJob submitCoverJob(array $options = [])
 * @method SubmitEditingJobs submitEditingJobs(array $options = [])
 * @method SubmitFacerecogJob submitFacerecogJob(array $options = [])
 * @method SubmitFpShotJob submitFpShotJob(array $options = [])
 * @method SubmitImageQuality submitImageQuality(array $options = [])
 * @method SubmitImageQualityJob submitImageQualityJob(array $options = [])
 * @method SubmitImageSearchJob submitImageSearchJob(array $options = [])
 * @method SubmitJobs submitJobs(array $options = [])
 * @method SubmitKwsJob submitKwsJob(array $options = [])
 * @method SubmitMcuJob submitMcuJob(array $options = [])
 * @method SubmitMediaCensorJob submitMediaCensorJob(array $options = [])
 * @method SubmitMediaDetailJob submitMediaDetailJob(array $options = [])
 * @method SubmitMediaInfoJob submitMediaInfoJob(array $options = [])
 * @method SubmitPornJob submitPornJob(array $options = [])
 * @method SubmitSnapshotJob submitSnapshotJob(array $options = [])
 * @method SubmitSubtitleJob submitSubtitleJob(array $options = [])
 * @method SubmitTagJob submitTagJob(array $options = [])
 * @method SubmitTerrorismJob submitTerrorismJob(array $options = [])
 * @method SubmitVideoGifJob submitVideoGifJob(array $options = [])
 * @method SubmitVideoPoseJob submitVideoPoseJob(array $options = [])
 * @method SubmitVideoSplitJob submitVideoSplitJob(array $options = [])
 * @method SubmitVideoSummaryJob submitVideoSummaryJob(array $options = [])
 * @method UnbindInputBucket unbindInputBucket(array $options = [])
 * @method UnbindOutputBucket unbindOutputBucket(array $options = [])
 * @method UnindInputBucket unindInputBucket(array $options = [])
 * @method UpdateAsrPipeline updateAsrPipeline(array $options = [])
 * @method UpdateCategoryName updateCategoryName(array $options = [])
 * @method UpdateCensorPipeline updateCensorPipeline(array $options = [])
 * @method UpdateCoverPipeline updateCoverPipeline(array $options = [])
 * @method UpdateKwsDictionary updateKwsDictionary(array $options = [])
 * @method UpdateKwsPipeline updateKwsPipeline(array $options = [])
 * @method UpdateMcuTemplate updateMcuTemplate(array $options = [])
 * @method UpdateMedia updateMedia(array $options = [])
 * @method UpdateMediaCategory updateMediaCategory(array $options = [])
 * @method UpdateMediaCover updateMediaCover(array $options = [])
 * @method UpdateMediaPublishState updateMediaPublishState(array $options = [])
 * @method UpdateMediaWorkflow updateMediaWorkflow(array $options = [])
 * @method UpdateMediaWorkflowTriggerMode updateMediaWorkflowTriggerMode(array $options = [])
 * @method UpdatePipeline updatePipeline(array $options = [])
 * @method UpdatePornPipeline updatePornPipeline(array $options = [])
 * @method UpdateTemplate updateTemplate(array $options = [])
 * @method UpdateTerrorismPipeline updateTerrorismPipeline(array $options = [])
 * @method UpdateVideoSummaryPipeline updateVideoSummaryPipeline(array $options = [])
 * @method UpdateWaterMarkTemplate updateWaterMarkTemplate(array $options = [])
 */
class MtsApiResolver
{
    use ApiResolverTrait;
}
