<?php

namespace AlibabaCloud\RKvstore\V20150101;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the RKvstore based on the method name as the Api name.
 *
 * @package   AlibabaCloud\RKvstore\V20150101
 *
 * @method static AddBindingTunnel addBindingTunnel(array $options = [])
 * @method static AllocateInstancePublicConnection allocateInstancePublicConnection(array $options = [])
 * @method static BindTunnel bindTunnel(array $options = [])
 * @method static CreateAccount createAccount(array $options = [])
 * @method static CreateBackup createBackup(array $options = [])
 * @method static CreateCacheAnalysisTask createCacheAnalysisTask(array $options = [])
 * @method static CreateInstance createInstance(array $options = [])
 * @method static CreateReplicationGroup createReplicationGroup(array $options = [])
 * @method static CreateSnapshot createSnapshot(array $options = [])
 * @method static CreateStaticVerification createStaticVerification(array $options = [])
 * @method static CreateTempInstance createTempInstance(array $options = [])
 * @method static DeleteAccount deleteAccount(array $options = [])
 * @method static DeleteInstance deleteInstance(array $options = [])
 * @method static DeleteReplicationGroup deleteReplicationGroup(array $options = [])
 * @method static DeleteSnapshot deleteSnapshot(array $options = [])
 * @method static DeleteSnapshotSettings deleteSnapshotSettings(array $options = [])
 * @method static DeleteTempInstance deleteTempInstance(array $options = [])
 * @method static DescribeAccounts describeAccounts(array $options = [])
 * @method static DescribeActiveOperationTask describeActiveOperationTask(array $options = [])
 * @method static DescribeActiveOperationTaskCount describeActiveOperationTaskCount(array $options = [])
 * @method static DescribeActiveOperationTaskRegion describeActiveOperationTaskRegion(array $options = [])
 * @method static DescribeActiveOperationTaskType describeActiveOperationTaskType(array $options = [])
 * @method static DescribeAuditRecords describeAuditRecords(array $options = [])
 * @method static DescribeBackupPolicy describeBackupPolicy(array $options = [])
 * @method static DescribeBackups describeBackups(array $options = [])
 * @method static DescribeCacheAnalysisReport describeCacheAnalysisReport(array $options = [])
 * @method static DescribeCacheAnalysisReportList describeCacheAnalysisReportList(array $options = [])
 * @method static DescribeCertification describeCertification(array $options = [])
 * @method static DescribeDBInstanceMonitor describeDBInstanceMonitor(array $options = [])
 * @method static DescribeDBInstanceNetInfo describeDBInstanceNetInfo(array $options = [])
 * @method static DescribeDynamicVerificationList describeDynamicVerificationList(array $options = [])
 * @method static DescribeErrorLogRecords describeErrorLogRecords(array $options = [])
 * @method static DescribeHistoryMonitorValues describeHistoryMonitorValues(array $options = [])
 * @method static DescribeInstanceAttribute describeInstanceAttribute(array $options = [])
 * @method static DescribeInstanceAutoRenewalAttribute describeInstanceAutoRenewalAttribute(array $options = [])
 * @method static DescribeInstanceConfig describeInstanceConfig(array $options = [])
 * @method static DescribeInstancePerformanceUsage describeInstancePerformanceUsage(array $options = [])
 * @method static DescribeInstanceSSL describeInstanceSSL(array $options = [])
 * @method static DescribeInstances describeInstances(array $options = [])
 * @method static DescribeInstancesByExpireTime describeInstancesByExpireTime(array $options = [])
 * @method static DescribeIntranetAttribute describeIntranetAttribute(array $options = [])
 * @method static DescribeLogicInstanceTopology describeLogicInstanceTopology(array $options = [])
 * @method static DescribeMonitorItems describeMonitorItems(array $options = [])
 * @method static DescribeMonthlyServiceStatus describeMonthlyServiceStatus(array $options = [])
 * @method static DescribeMonthlyServiceStatusDetail describeMonthlyServiceStatusDetail(array $options = [])
 * @method static DescribeParameterModificationHistory describeParameterModificationHistory(array $options = [])
 * @method static DescribeParameterTemplates describeParameterTemplates(array $options = [])
 * @method static DescribeParameters describeParameters(array $options = [])
 * @method static DescribeRdsVSwitchs describeRdsVSwitchs(array $options = [])
 * @method static DescribeRdsVpcs describeRdsVpcs(array $options = [])
 * @method static DescribeRegions describeRegions(array $options = [])
 * @method static DescribeReplicaConflictInfo describeReplicaConflictInfo(array $options = [])
 * @method static DescribeReplicaInitializeProgress describeReplicaInitializeProgress(array $options = [])
 * @method static DescribeReplicaPerformance describeReplicaPerformance(array $options = [])
 * @method static DescribeReplicaUsage describeReplicaUsage(array $options = [])
 * @method static DescribeReplicas describeReplicas(array $options = [])
 * @method static DescribeReplicationGroup describeReplicationGroup(array $options = [])
 * @method static DescribeRunningLogRecords describeRunningLogRecords(array $options = [])
 * @method static DescribeSecurityIps describeSecurityIps(array $options = [])
 * @method static DescribeSlowLogRecords describeSlowLogRecords(array $options = [])
 * @method static DescribeSnapshots describeSnapshots(array $options = [])
 * @method static DescribeStaticVerificationList describeStaticVerificationList(array $options = [])
 * @method static DescribeStrategy describeStrategy(array $options = [])
 * @method static DescribeTargetAVZ describeTargetAVZ(array $options = [])
 * @method static DescribeTempInstance describeTempInstance(array $options = [])
 * @method static DescribeVerificationList describeVerificationList(array $options = [])
 * @method static DescribeZones describeZones(array $options = [])
 * @method static DestroyInstance destroyInstance(array $options = [])
 * @method static EvaluateFailOverSwitch evaluateFailOverSwitch(array $options = [])
 * @method static EvaluateResource evaluateResource(array $options = [])
 * @method static FlushExpireKeys flushExpireKeys(array $options = [])
 * @method static FlushInstance flushInstance(array $options = [])
 * @method static GetSnapshotSettings getSnapshotSettings(array $options = [])
 * @method static GrantAccountPrivilege grantAccountPrivilege(array $options = [])
 * @method static ListReplicationGroup listReplicationGroup(array $options = [])
 * @method static ListTagResources listTagResources(array $options = [])
 * @method static MigrateToOtherZone migrateToOtherZone(array $options = [])
 * @method static ModifyAccountDescription modifyAccountDescription(array $options = [])
 * @method static ModifyActiveOperationPendingTask modifyActiveOperationPendingTask(array $options = [])
 * @method static ModifyActiveOperationTask modifyActiveOperationTask(array $options = [])
 * @method static ModifyAuditLogConfig modifyAuditLogConfig(array $options = [])
 * @method static ModifyBackupPolicy modifyBackupPolicy(array $options = [])
 * @method static ModifyCertification modifyCertification(array $options = [])
 * @method static ModifyDBInstanceConnectionString modifyDBInstanceConnectionString(array $options = [])
 * @method static ModifyDBInstanceMonitor modifyDBInstanceMonitor(array $options = [])
 * @method static ModifyDynamicMode modifyDynamicMode(array $options = [])
 * @method static ModifyGuardDomainMode modifyGuardDomainMode(array $options = [])
 * @method static ModifyInstanceAttribute modifyInstanceAttribute(array $options = [])
 * @method static ModifyInstanceAutoRenewalAttribute modifyInstanceAutoRenewalAttribute(array $options = [])
 * @method static ModifyInstanceConfig modifyInstanceConfig(array $options = [])
 * @method static ModifyInstanceMaintainTime modifyInstanceMaintainTime(array $options = [])
 * @method static ModifyInstanceMajorVersion modifyInstanceMajorVersion(array $options = [])
 * @method static ModifyInstanceMinorVersion modifyInstanceMinorVersion(array $options = [])
 * @method static ModifyInstanceNetExpireTime modifyInstanceNetExpireTime(array $options = [])
 * @method static ModifyInstanceSSL modifyInstanceSSL(array $options = [])
 * @method static ModifyInstanceSpec modifyInstanceSpec(array $options = [])
 * @method static ModifyInstanceSpecPreCheck modifyInstanceSpecPreCheck(array $options = [])
 * @method static ModifyInstanceVpcAuthMode modifyInstanceVpcAuthMode(array $options = [])
 * @method static ModifyIntranetAttribute modifyIntranetAttribute(array $options = [])
 * @method static ModifyReplicaDescription modifyReplicaDescription(array $options = [])
 * @method static ModifyReplicaDynamicMode modifyReplicaDynamicMode(array $options = [])
 * @method static ModifyReplicaFilterMode modifyReplicaFilterMode(array $options = [])
 * @method static ModifyReplicaMode modifyReplicaMode(array $options = [])
 * @method static ModifyReplicaRecoverMode modifyReplicaRecoverMode(array $options = [])
 * @method static ModifyReplicaRecoveryMode modifyReplicaRecoveryMode(array $options = [])
 * @method static ModifyReplicaRelation modifyReplicaRelation(array $options = [])
 * @method static ModifyReplicaVerificationMode modifyReplicaVerificationMode(array $options = [])
 * @method static ModifyReplicationGroup modifyReplicationGroup(array $options = [])
 * @method static ModifySecurityIps modifySecurityIps(array $options = [])
 * @method static QueryTask queryTask(array $options = [])
 * @method static RKvstoreApiResolver rKvstoreApiResolver(array $options = [])
 * @method static RebuildInstance rebuildInstance(array $options = [])
 * @method static ReleaseInstancePublicConnection releaseInstancePublicConnection(array $options = [])
 * @method static ReleaseReplica releaseReplica(array $options = [])
 * @method static RenewInstance renewInstance(array $options = [])
 * @method static RenewMultiInstance renewMultiInstance(array $options = [])
 * @method static ResetAccount resetAccount(array $options = [])
 * @method static ResetAccountPassword resetAccountPassword(array $options = [])
 * @method static RestartDBInstance restartDBInstance(array $options = [])
 * @method static RestartInstance restartInstance(array $options = [])
 * @method static RestoreInstance restoreInstance(array $options = [])
 * @method static RestoreSnapshot restoreSnapshot(array $options = [])
 * @method static RevokeAccountPrivilege revokeAccountPrivilege(array $options = [])
 * @method static SetSnapshotSettings setSnapshotSettings(array $options = [])
 * @method static SwitchNetwork switchNetwork(array $options = [])
 * @method static SwitchTempInstance switchTempInstance(array $options = [])
 * @method static TagResources tagResources(array $options = [])
 * @method static TransformToPrePaid transformToPrePaid(array $options = [])
 * @method static UnbindTunnel unbindTunnel(array $options = [])
 * @method static UnlinkReplicaInstance unlinkReplicaInstance(array $options = [])
 * @method static UntagResources untagResources(array $options = [])
 * @method static VerifyPassword verifyPassword(array $options = [])
 */
class RKvstore
{
    use ApiResolverTrait;
}
