<?php

namespace AlibabaCloud\Rds\V20140815;

use AlibabaCloud\Client\Request\RpcRequest;

/**
 * Request of CopyDatabaseBetweenInstances
 *
 * @method string getResourceOwnerId()
 * @method string getRestoreTime()
 * @method string getResourceOwnerAccount()
 * @method string getClientToken()
 * @method string getBackupId()
 * @method string getOwnerAccount()
 * @method string getOwnerId()
 * @method string getSyncUserPrivilege()
 * @method string getDbNames()
 * @method string getResourceGroupId()
 * @method string getTargetDBInstanceId()
 * @method string getDBInstanceId()
 * @method string getPayType()
 */
class CopyDatabaseBetweenInstances extends RpcRequest
{

    /**
     * @var string
     */
    public $product = 'Rds';

    /**
     * @var string
     */
    public $version = '2014-08-15';

    /**
     * @var string
     */
    public $action = 'CopyDatabaseBetweenInstances';

    /**
     * @var string
     */
    public $method = 'POST';

    /**
     * @var string
     */
    public $serviceCode = 'rds';

    /**
     * @deprecated deprecated since version 2.0, Use withResourceOwnerId() instead.
     *
     * @param string $resourceOwnerId
     *
     * @return $this
     */
    public function setResourceOwnerId($resourceOwnerId)
    {
        return $this->withResourceOwnerId($resourceOwnerId);
    }

    /**
     * @param string $resourceOwnerId
     *
     * @return $this
     */
    public function withResourceOwnerId($resourceOwnerId)
    {
        $this->data['ResourceOwnerId'] = $resourceOwnerId;
        $this->options['query']['ResourceOwnerId'] = $resourceOwnerId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withRestoreTime() instead.
     *
     * @param string $restoreTime
     *
     * @return $this
     */
    public function setRestoreTime($restoreTime)
    {
        return $this->withRestoreTime($restoreTime);
    }

    /**
     * @param string $restoreTime
     *
     * @return $this
     */
    public function withRestoreTime($restoreTime)
    {
        $this->data['RestoreTime'] = $restoreTime;
        $this->options['query']['RestoreTime'] = $restoreTime;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withResourceOwnerAccount() instead.
     *
     * @param string $resourceOwnerAccount
     *
     * @return $this
     */
    public function setResourceOwnerAccount($resourceOwnerAccount)
    {
        return $this->withResourceOwnerAccount($resourceOwnerAccount);
    }

    /**
     * @param string $resourceOwnerAccount
     *
     * @return $this
     */
    public function withResourceOwnerAccount($resourceOwnerAccount)
    {
        $this->data['ResourceOwnerAccount'] = $resourceOwnerAccount;
        $this->options['query']['ResourceOwnerAccount'] = $resourceOwnerAccount;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withClientToken() instead.
     *
     * @param string $clientToken
     *
     * @return $this
     */
    public function setClientToken($clientToken)
    {
        return $this->withClientToken($clientToken);
    }

    /**
     * @param string $clientToken
     *
     * @return $this
     */
    public function withClientToken($clientToken)
    {
        $this->data['ClientToken'] = $clientToken;
        $this->options['query']['ClientToken'] = $clientToken;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withBackupId() instead.
     *
     * @param string $backupId
     *
     * @return $this
     */
    public function setBackupId($backupId)
    {
        return $this->withBackupId($backupId);
    }

    /**
     * @param string $backupId
     *
     * @return $this
     */
    public function withBackupId($backupId)
    {
        $this->data['BackupId'] = $backupId;
        $this->options['query']['BackupId'] = $backupId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withOwnerAccount() instead.
     *
     * @param string $ownerAccount
     *
     * @return $this
     */
    public function setOwnerAccount($ownerAccount)
    {
        return $this->withOwnerAccount($ownerAccount);
    }

    /**
     * @param string $ownerAccount
     *
     * @return $this
     */
    public function withOwnerAccount($ownerAccount)
    {
        $this->data['OwnerAccount'] = $ownerAccount;
        $this->options['query']['OwnerAccount'] = $ownerAccount;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withOwnerId() instead.
     *
     * @param string $ownerId
     *
     * @return $this
     */
    public function setOwnerId($ownerId)
    {
        return $this->withOwnerId($ownerId);
    }

    /**
     * @param string $ownerId
     *
     * @return $this
     */
    public function withOwnerId($ownerId)
    {
        $this->data['OwnerId'] = $ownerId;
        $this->options['query']['OwnerId'] = $ownerId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withSyncUserPrivilege() instead.
     *
     * @param string $syncUserPrivilege
     *
     * @return $this
     */
    public function setSyncUserPrivilege($syncUserPrivilege)
    {
        return $this->withSyncUserPrivilege($syncUserPrivilege);
    }

    /**
     * @param string $syncUserPrivilege
     *
     * @return $this
     */
    public function withSyncUserPrivilege($syncUserPrivilege)
    {
        $this->data['SyncUserPrivilege'] = $syncUserPrivilege;
        $this->options['query']['SyncUserPrivilege'] = $syncUserPrivilege;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withDbNames() instead.
     *
     * @param string $dbNames
     *
     * @return $this
     */
    public function setDbNames($dbNames)
    {
        return $this->withDbNames($dbNames);
    }

    /**
     * @param string $dbNames
     *
     * @return $this
     */
    public function withDbNames($dbNames)
    {
        $this->data['DbNames'] = $dbNames;
        $this->options['query']['DbNames'] = $dbNames;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withResourceGroupId() instead.
     *
     * @param string $resourceGroupId
     *
     * @return $this
     */
    public function setResourceGroupId($resourceGroupId)
    {
        return $this->withResourceGroupId($resourceGroupId);
    }

    /**
     * @param string $resourceGroupId
     *
     * @return $this
     */
    public function withResourceGroupId($resourceGroupId)
    {
        $this->data['ResourceGroupId'] = $resourceGroupId;
        $this->options['query']['ResourceGroupId'] = $resourceGroupId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withTargetDBInstanceId() instead.
     *
     * @param string $targetDBInstanceId
     *
     * @return $this
     */
    public function setTargetDBInstanceId($targetDBInstanceId)
    {
        return $this->withTargetDBInstanceId($targetDBInstanceId);
    }

    /**
     * @param string $targetDBInstanceId
     *
     * @return $this
     */
    public function withTargetDBInstanceId($targetDBInstanceId)
    {
        $this->data['TargetDBInstanceId'] = $targetDBInstanceId;
        $this->options['query']['TargetDBInstanceId'] = $targetDBInstanceId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withDBInstanceId() instead.
     *
     * @param string $dBInstanceId
     *
     * @return $this
     */
    public function setDBInstanceId($dBInstanceId)
    {
        return $this->withDBInstanceId($dBInstanceId);
    }

    /**
     * @param string $dBInstanceId
     *
     * @return $this
     */
    public function withDBInstanceId($dBInstanceId)
    {
        $this->data['DBInstanceId'] = $dBInstanceId;
        $this->options['query']['DBInstanceId'] = $dBInstanceId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withPayType() instead.
     *
     * @param string $payType
     *
     * @return $this
     */
    public function setPayType($payType)
    {
        return $this->withPayType($payType);
    }

    /**
     * @param string $payType
     *
     * @return $this
     */
    public function withPayType($payType)
    {
        $this->data['PayType'] = $payType;
        $this->options['query']['PayType'] = $payType;

        return $this;
    }
}
