<?php

namespace AlibabaCloud\Slb\V20140515;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the Slb based on the method name as the Api name.
 *
 * @package   AlibabaCloud\Slb\V20140515
 *
 * @method static AddAccessControlListEntry addAccessControlListEntry(array $options = [])
 * @method static AddBackendServers addBackendServers(array $options = [])
 * @method static AddBackendServersAsyn addBackendServersAsyn(array $options = [])
 * @method static AddListenerWhiteListItem addListenerWhiteListItem(array $options = [])
 * @method static AddTags addTags(array $options = [])
 * @method static AddVServerGroupBackendServers addVServerGroupBackendServers(array $options = [])
 * @method static AddVServerGroupBackendServersAsyn addVServerGroupBackendServersAsyn(array $options = [])
 * @method static CreateAccessControlList createAccessControlList(array $options = [])
 * @method static CreateDomainExtension createDomainExtension(array $options = [])
 * @method static CreateLoadBalancer createLoadBalancer(array $options = [])
 * @method static CreateLoadBalancerHTTPListener createLoadBalancerHTTPListener(array $options = [])
 * @method static CreateLoadBalancerHTTPListenerAsyn createLoadBalancerHTTPListenerAsyn(array $options = [])
 * @method static CreateLoadBalancerHTTPSListener createLoadBalancerHTTPSListener(array $options = [])
 * @method static CreateLoadBalancerHTTPSListenerAsyn createLoadBalancerHTTPSListenerAsyn(array $options = [])
 * @method static CreateLoadBalancerOld createLoadBalancerOld(array $options = [])
 * @method static CreateLoadBalancerTCPListener createLoadBalancerTCPListener(array $options = [])
 * @method static CreateLoadBalancerTCPListenerAsyn createLoadBalancerTCPListenerAsyn(array $options = [])
 * @method static CreateLoadBalancerUDPListener createLoadBalancerUDPListener(array $options = [])
 * @method static CreateLoadBalancerUDPListenerAsyn createLoadBalancerUDPListenerAsyn(array $options = [])
 * @method static CreateMasterSlaveServerGroup createMasterSlaveServerGroup(array $options = [])
 * @method static CreateMasterSlaveVServerGroup createMasterSlaveVServerGroup(array $options = [])
 * @method static CreateRule createRule(array $options = [])
 * @method static CreateRules createRules(array $options = [])
 * @method static CreateVServerGroup createVServerGroup(array $options = [])
 * @method static DeleteAccessControlList deleteAccessControlList(array $options = [])
 * @method static DeleteCACertificate deleteCACertificate(array $options = [])
 * @method static DeleteDomainExtension deleteDomainExtension(array $options = [])
 * @method static DeleteLoadBalancer deleteLoadBalancer(array $options = [])
 * @method static DeleteLoadBalancerListener deleteLoadBalancerListener(array $options = [])
 * @method static DeleteMasterSlaveServerGroup deleteMasterSlaveServerGroup(array $options = [])
 * @method static DeleteMasterSlaveVServerGroup deleteMasterSlaveVServerGroup(array $options = [])
 * @method static DeleteRule deleteRule(array $options = [])
 * @method static DeleteRules deleteRules(array $options = [])
 * @method static DeleteServerCertificate deleteServerCertificate(array $options = [])
 * @method static DeleteVServerGroup deleteVServerGroup(array $options = [])
 * @method static DescribeAccessControlListAttribute describeAccessControlListAttribute(array $options = [])
 * @method static DescribeAccessControlLists describeAccessControlLists(array $options = [])
 * @method static DescribeAutoRenewStatus describeAutoRenewStatus(array $options = [])
 * @method static DescribeCACertificates describeCACertificates(array $options = [])
 * @method static DescribeCertificateRelatedListenersAndRules describeCertificateRelatedListenersAndRules(array $options = [])
 * @method static DescribeDomainExtensions describeDomainExtensions(array $options = [])
 * @method static DescribeHealthStatus describeHealthStatus(array $options = [])
 * @method static DescribeIdleInstances describeIdleInstances(array $options = [])
 * @method static DescribeListenerAccessControlAttribute describeListenerAccessControlAttribute(array $options = [])
 * @method static DescribeLoadBalancerAttribute describeLoadBalancerAttribute(array $options = [])
 * @method static DescribeLoadBalancerAutoReleaseTime describeLoadBalancerAutoReleaseTime(array $options = [])
 * @method static DescribeLoadBalancerBackendServers describeLoadBalancerBackendServers(array $options = [])
 * @method static DescribeLoadBalancerHTTPListenerAttribute describeLoadBalancerHTTPListenerAttribute(array $options = [])
 * @method static DescribeLoadBalancerHTTPSListenerAttribute describeLoadBalancerHTTPSListenerAttribute(array $options = [])
 * @method static DescribeLoadBalancerTCPListenerAttribute describeLoadBalancerTCPListenerAttribute(array $options = [])
 * @method static DescribeLoadBalancerUDPListenerAttribute describeLoadBalancerUDPListenerAttribute(array $options = [])
 * @method static DescribeLoadBalancers describeLoadBalancers(array $options = [])
 * @method static DescribeLoadBalancersPro describeLoadBalancersPro(array $options = [])
 * @method static DescribeLoadBalancersRelatedEcs describeLoadBalancersRelatedEcs(array $options = [])
 * @method static DescribeMasterSlaveServerGroupAttribute describeMasterSlaveServerGroupAttribute(array $options = [])
 * @method static DescribeMasterSlaveServerGroups describeMasterSlaveServerGroups(array $options = [])
 * @method static DescribeMasterSlaveVServerGroupAttribute describeMasterSlaveVServerGroupAttribute(array $options = [])
 * @method static DescribeMasterSlaveVServerGroups describeMasterSlaveVServerGroups(array $options = [])
 * @method static DescribeRegions describeRegions(array $options = [])
 * @method static DescribeRuleAttribute describeRuleAttribute(array $options = [])
 * @method static DescribeRuleAttributes describeRuleAttributes(array $options = [])
 * @method static DescribeRules describeRules(array $options = [])
 * @method static DescribeServerCertificates describeServerCertificates(array $options = [])
 * @method static DescribeSlbQuotas describeSlbQuotas(array $options = [])
 * @method static DescribeTags describeTags(array $options = [])
 * @method static DescribeVServerGroupAttribute describeVServerGroupAttribute(array $options = [])
 * @method static DescribeVServerGroupAttributes describeVServerGroupAttributes(array $options = [])
 * @method static DescribeVServerGroups describeVServerGroups(array $options = [])
 * @method static DescribeZones describeZones(array $options = [])
 * @method static InnerQueryQuotaConfig innerQueryQuotaConfig(array $options = [])
 * @method static ListTagResources listTagResources(array $options = [])
 * @method static ModifyLoadBalancerInstanceSpec modifyLoadBalancerInstanceSpec(array $options = [])
 * @method static ModifyLoadBalancerInternetSpec modifyLoadBalancerInternetSpec(array $options = [])
 * @method static ModifyLoadBalancerPayType modifyLoadBalancerPayType(array $options = [])
 * @method static ModifyLoadBalancerResourceGroup modifyLoadBalancerResourceGroup(array $options = [])
 * @method static ModifyLoadBalancerVPCAddress modifyLoadBalancerVPCAddress(array $options = [])
 * @method static ModifyVServerGroupBackendServers modifyVServerGroupBackendServers(array $options = [])
 * @method static ModifyVServerGroupBackendServersAsyn modifyVServerGroupBackendServersAsyn(array $options = [])
 * @method static MoveResourceGroup moveResourceGroup(array $options = [])
 * @method static RemoveAccessControlListEntry removeAccessControlListEntry(array $options = [])
 * @method static RemoveBackendServers removeBackendServers(array $options = [])
 * @method static RemoveBackendServersAsyn removeBackendServersAsyn(array $options = [])
 * @method static RemoveListenerWhiteListItem removeListenerWhiteListItem(array $options = [])
 * @method static RemoveTags removeTags(array $options = [])
 * @method static RemoveVServerGroupBackendServer removeVServerGroupBackendServer(array $options = [])
 * @method static RemoveVServerGroupBackendServers removeVServerGroupBackendServers(array $options = [])
 * @method static RemoveVServerGroupBackendServersAsyn removeVServerGroupBackendServersAsyn(array $options = [])
 * @method static SetAccessControlListAttribute setAccessControlListAttribute(array $options = [])
 * @method static SetAccessControlListAttributeImpl setAccessControlListAttributeImpl(array $options = [])
 * @method static SetAutoRenewStatus setAutoRenewStatus(array $options = [])
 * @method static SetBackendServers setBackendServers(array $options = [])
 * @method static SetBackendServersAsyn setBackendServersAsyn(array $options = [])
 * @method static SetCACertificateName setCACertificateName(array $options = [])
 * @method static SetDomainExtensionAttribute setDomainExtensionAttribute(array $options = [])
 * @method static SetListenerAccessControlStatus setListenerAccessControlStatus(array $options = [])
 * @method static SetLoadBalancerAutoReleaseTime setLoadBalancerAutoReleaseTime(array $options = [])
 * @method static SetLoadBalancerHTTPListenerAttribute setLoadBalancerHTTPListenerAttribute(array $options = [])
 * @method static SetLoadBalancerHTTPSListenerAttribute setLoadBalancerHTTPSListenerAttribute(array $options = [])
 * @method static SetLoadBalancerName setLoadBalancerName(array $options = [])
 * @method static SetLoadBalancerStatus setLoadBalancerStatus(array $options = [])
 * @method static SetLoadBalancerTCPListenerAttribute setLoadBalancerTCPListenerAttribute(array $options = [])
 * @method static SetLoadBalancerUDPListenerAttribute setLoadBalancerUDPListenerAttribute(array $options = [])
 * @method static SetRule setRule(array $options = [])
 * @method static SetServerCertificateName setServerCertificateName(array $options = [])
 * @method static SetVServerGroup setVServerGroup(array $options = [])
 * @method static SetVServerGroupAttribute setVServerGroupAttribute(array $options = [])
 * @method static SetVServerGroupAttributeAsyn setVServerGroupAttributeAsyn(array $options = [])
 * @method static SlbApiResolver slbApiResolver(array $options = [])
 * @method static StartLoadBalancerListener startLoadBalancerListener(array $options = [])
 * @method static StopLoadBalancerListener stopLoadBalancerListener(array $options = [])
 * @method static TagResources tagResources(array $options = [])
 * @method static UntagResources untagResources(array $options = [])
 * @method static UploadCACertificate uploadCACertificate(array $options = [])
 * @method static UploadServerCertificate uploadServerCertificate(array $options = [])
 */
class Slb
{
    use ApiResolverTrait;
}
