<?php

namespace AlibabaCloud\Vod\V20170321;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the Vod based on the method name as the Api name.
 *
 * @package   AlibabaCloud\Vod\V20170321
 *
 * @method static AddCategory addCategory(array $options = [])
 * @method static AddEditingProject addEditingProject(array $options = [])
 * @method static AddFaceRegistration addFaceRegistration(array $options = [])
 * @method static AddMediaSequences addMediaSequences(array $options = [])
 * @method static AddStorage addStorage(array $options = [])
 * @method static AddVodDomain addVodDomain(array $options = [])
 * @method static AddVodTemplate addVodTemplate(array $options = [])
 * @method static AddWatermark addWatermark(array $options = [])
 * @method static AddWorkFlow addWorkFlow(array $options = [])
 * @method static CreateAudit createAudit(array $options = [])
 * @method static CreateUploadAttachedMedia createUploadAttachedMedia(array $options = [])
 * @method static CreateUploadImage createUploadImage(array $options = [])
 * @method static CreateUploadVideo createUploadVideo(array $options = [])
 * @method static DeleteCategory deleteCategory(array $options = [])
 * @method static DeleteEditingProject deleteEditingProject(array $options = [])
 * @method static DeleteImage deleteImage(array $options = [])
 * @method static DeleteMezzanines deleteMezzanines(array $options = [])
 * @method static DeleteStream deleteStream(array $options = [])
 * @method static DeleteVideo deleteVideo(array $options = [])
 * @method static DeleteVodDomain deleteVodDomain(array $options = [])
 * @method static DeleteVodTemplate deleteVodTemplate(array $options = [])
 * @method static DeleteWatermark deleteWatermark(array $options = [])
 * @method static DeleteWorkFlow deleteWorkFlow(array $options = [])
 * @method static DescribeCdnDomainLogs describeCdnDomainLogs(array $options = [])
 * @method static DescribeDomainBpsData describeDomainBpsData(array $options = [])
 * @method static DescribeDomainFlowData describeDomainFlowData(array $options = [])
 * @method static DescribePlayTopVideos describePlayTopVideos(array $options = [])
 * @method static DescribePlayUserAvg describePlayUserAvg(array $options = [])
 * @method static DescribePlayUserTotal describePlayUserTotal(array $options = [])
 * @method static DescribePlayVideoStatis describePlayVideoStatis(array $options = [])
 * @method static DescribeRefreshQuota describeRefreshQuota(array $options = [])
 * @method static DescribeRefreshTasks describeRefreshTasks(array $options = [])
 * @method static DescribeUserVodStatus describeUserVodStatus(array $options = [])
 * @method static DescribeVodCertificateList describeVodCertificateList(array $options = [])
 * @method static DescribeVodDomainCertificateInfo describeVodDomainCertificateInfo(array $options = [])
 * @method static DescribeVodDomainConfigs describeVodDomainConfigs(array $options = [])
 * @method static DescribeVodDomainDetail describeVodDomainDetail(array $options = [])
 * @method static DescribeVodService describeVodService(array $options = [])
 * @method static DescribeVodUserDomains describeVodUserDomains(array $options = [])
 * @method static DescribeVodUserResourcePackage describeVodUserResourcePackage(array $options = [])
 * @method static EditLiveRecordVideo editLiveRecordVideo(array $options = [])
 * @method static GetAuditHistory getAuditHistory(array $options = [])
 * @method static GetAuditResult getAuditResult(array $options = [])
 * @method static GetCDNStatisSum getCDNStatisSum(array $options = [])
 * @method static GetCategories getCategories(array $options = [])
 * @method static GetEditingProject getEditingProject(array $options = [])
 * @method static GetEditingProjectMaterials getEditingProjectMaterials(array $options = [])
 * @method static GetFileInfo getFileInfo(array $options = [])
 * @method static GetImageInfo getImageInfo(array $options = [])
 * @method static GetMediaDNAResult getMediaDNAResult(array $options = [])
 * @method static GetMessageCallback getMessageCallback(array $options = [])
 * @method static GetMezzanineInfo getMezzanineInfo(array $options = [])
 * @method static GetOSSStatis getOSSStatis(array $options = [])
 * @method static GetPlayInfo getPlayInfo(array $options = [])
 * @method static GetVideoConfig getVideoConfig(array $options = [])
 * @method static GetVideoInfo getVideoInfo(array $options = [])
 * @method static GetVideoInfos getVideoInfos(array $options = [])
 * @method static GetVideoList getVideoList(array $options = [])
 * @method static GetVideoPlayAuth getVideoPlayAuth(array $options = [])
 * @method static GetVideoPlayInfo getVideoPlayInfo(array $options = [])
 * @method static GetVodTemplate getVodTemplate(array $options = [])
 * @method static GetWatermark getWatermark(array $options = [])
 * @method static GetWorkFlow getWorkFlow(array $options = [])
 * @method static ListAIASRJob listAIASRJob(array $options = [])
 * @method static ListAIJob listAIJob(array $options = [])
 * @method static ListAIVideoCategoryJob listAIVideoCategoryJob(array $options = [])
 * @method static ListAIVideoCensorJob listAIVideoCensorJob(array $options = [])
 * @method static ListAIVideoCoverJob listAIVideoCoverJob(array $options = [])
 * @method static ListAIVideoPornRecogJob listAIVideoPornRecogJob(array $options = [])
 * @method static ListAIVideoSummaryJob listAIVideoSummaryJob(array $options = [])
 * @method static ListAIVideoTerrorismRecogJob listAIVideoTerrorismRecogJob(array $options = [])
 * @method static ListAuditSecurityIp listAuditSecurityIp(array $options = [])
 * @method static ListLiveRecordVideo listLiveRecordVideo(array $options = [])
 * @method static ListSnapshots listSnapshots(array $options = [])
 * @method static ListVodTemplate listVodTemplate(array $options = [])
 * @method static ListWatermark listWatermark(array $options = [])
 * @method static ListWorkFlow listWorkFlow(array $options = [])
 * @method static OpenVodService openVodService(array $options = [])
 * @method static ProduceEditingProjectVideo produceEditingProjectVideo(array $options = [])
 * @method static PushObjectCache pushObjectCache(array $options = [])
 * @method static RefreshObjectCaches refreshObjectCaches(array $options = [])
 * @method static RefreshUploadVideo refreshUploadVideo(array $options = [])
 * @method static RegisterMedia registerMedia(array $options = [])
 * @method static SearchEditingProject searchEditingProject(array $options = [])
 * @method static SearchMedia searchMedia(array $options = [])
 * @method static SetAuditSecurityIp setAuditSecurityIp(array $options = [])
 * @method static SetDefaultVodTemplate setDefaultVodTemplate(array $options = [])
 * @method static SetDefaultWatermark setDefaultWatermark(array $options = [])
 * @method static SetEditingProjectMaterials setEditingProjectMaterials(array $options = [])
 * @method static SetMessageCallback setMessageCallback(array $options = [])
 * @method static SetVodDomainCertificate setVodDomainCertificate(array $options = [])
 * @method static StartVodDomain startVodDomain(array $options = [])
 * @method static StopVodDomain stopVodDomain(array $options = [])
 * @method static SubmitAIASRJob submitAIASRJob(array $options = [])
 * @method static SubmitAIJob submitAIJob(array $options = [])
 * @method static SubmitAIVideoCategoryJob submitAIVideoCategoryJob(array $options = [])
 * @method static SubmitAIVideoCensorJob submitAIVideoCensorJob(array $options = [])
 * @method static SubmitAIVideoCoverJob submitAIVideoCoverJob(array $options = [])
 * @method static SubmitAIVideoPornRecogJob submitAIVideoPornRecogJob(array $options = [])
 * @method static SubmitAIVideoSummaryJob submitAIVideoSummaryJob(array $options = [])
 * @method static SubmitAIVideoTerrorismRecogJob submitAIVideoTerrorismRecogJob(array $options = [])
 * @method static SubmitPreprocessJobs submitPreprocessJobs(array $options = [])
 * @method static SubmitSnapshotJob submitSnapshotJob(array $options = [])
 * @method static SubmitTranscodeJobs submitTranscodeJobs(array $options = [])
 * @method static UpdateCategory updateCategory(array $options = [])
 * @method static UpdateEditingProject updateEditingProject(array $options = [])
 * @method static UpdateImageInfos updateImageInfos(array $options = [])
 * @method static UpdateVideoInfo updateVideoInfo(array $options = [])
 * @method static UpdateVideoInfos updateVideoInfos(array $options = [])
 * @method static UpdateVodTemplate updateVodTemplate(array $options = [])
 * @method static UpdateWatermark updateWatermark(array $options = [])
 * @method static UpdateWorkFlow updateWorkFlow(array $options = [])
 * @method static UploadMediaByURL uploadMediaByURL(array $options = [])
 * @method static VodApiResolver vodApiResolver(array $options = [])
 */
class Vod
{
    use ApiResolverTrait;
}
