<?php

namespace AlibabaCloud\Vpc\V20160428;

use AlibabaCloud\Client\Request\RpcRequest;

/**
 * Request of DescribeIpv6Addresses
 *
 * @method string getResourceOwnerId()
 * @method string getIpv6InternetBandwidthId()
 * @method string getNetworkType()
 * @method string getPageNumber()
 * @method string getAssociatedInstanceType()
 * @method string getPageSize()
 * @method string getResourceOwnerAccount()
 * @method string getOwnerAccount()
 * @method string getOwnerId()
 * @method string getVSwitchId()
 * @method string getIpv6AddressId()
 * @method string getVpcId()
 * @method string getName()
 * @method string getIpv6Address()
 * @method string getAssociatedInstanceId()
 */
class DescribeIpv6Addresses extends RpcRequest
{

    /**
     * @var string
     */
    public $product = 'Vpc';

    /**
     * @var string
     */
    public $version = '2016-04-28';

    /**
     * @var string
     */
    public $action = 'DescribeIpv6Addresses';

    /**
     * @var string
     */
    public $method = 'POST';

    /**
     * @var string
     */
    public $serviceCode = 'vpc';

    /**
     * @deprecated deprecated since version 2.0, Use withResourceOwnerId() instead.
     *
     * @param string $resourceOwnerId
     *
     * @return $this
     */
    public function setResourceOwnerId($resourceOwnerId)
    {
        return $this->withResourceOwnerId($resourceOwnerId);
    }

    /**
     * @param string $resourceOwnerId
     *
     * @return $this
     */
    public function withResourceOwnerId($resourceOwnerId)
    {
        $this->data['ResourceOwnerId'] = $resourceOwnerId;
        $this->options['query']['ResourceOwnerId'] = $resourceOwnerId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withIpv6InternetBandwidthId() instead.
     *
     * @param string $ipv6InternetBandwidthId
     *
     * @return $this
     */
    public function setIpv6InternetBandwidthId($ipv6InternetBandwidthId)
    {
        return $this->withIpv6InternetBandwidthId($ipv6InternetBandwidthId);
    }

    /**
     * @param string $ipv6InternetBandwidthId
     *
     * @return $this
     */
    public function withIpv6InternetBandwidthId($ipv6InternetBandwidthId)
    {
        $this->data['Ipv6InternetBandwidthId'] = $ipv6InternetBandwidthId;
        $this->options['query']['Ipv6InternetBandwidthId'] = $ipv6InternetBandwidthId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withNetworkType() instead.
     *
     * @param string $networkType
     *
     * @return $this
     */
    public function setNetworkType($networkType)
    {
        return $this->withNetworkType($networkType);
    }

    /**
     * @param string $networkType
     *
     * @return $this
     */
    public function withNetworkType($networkType)
    {
        $this->data['NetworkType'] = $networkType;
        $this->options['query']['NetworkType'] = $networkType;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withPageNumber() instead.
     *
     * @param string $pageNumber
     *
     * @return $this
     */
    public function setPageNumber($pageNumber)
    {
        return $this->withPageNumber($pageNumber);
    }

    /**
     * @param string $pageNumber
     *
     * @return $this
     */
    public function withPageNumber($pageNumber)
    {
        $this->data['PageNumber'] = $pageNumber;
        $this->options['query']['PageNumber'] = $pageNumber;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withAssociatedInstanceType() instead.
     *
     * @param string $associatedInstanceType
     *
     * @return $this
     */
    public function setAssociatedInstanceType($associatedInstanceType)
    {
        return $this->withAssociatedInstanceType($associatedInstanceType);
    }

    /**
     * @param string $associatedInstanceType
     *
     * @return $this
     */
    public function withAssociatedInstanceType($associatedInstanceType)
    {
        $this->data['AssociatedInstanceType'] = $associatedInstanceType;
        $this->options['query']['AssociatedInstanceType'] = $associatedInstanceType;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withPageSize() instead.
     *
     * @param string $pageSize
     *
     * @return $this
     */
    public function setPageSize($pageSize)
    {
        return $this->withPageSize($pageSize);
    }

    /**
     * @param string $pageSize
     *
     * @return $this
     */
    public function withPageSize($pageSize)
    {
        $this->data['PageSize'] = $pageSize;
        $this->options['query']['PageSize'] = $pageSize;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withResourceOwnerAccount() instead.
     *
     * @param string $resourceOwnerAccount
     *
     * @return $this
     */
    public function setResourceOwnerAccount($resourceOwnerAccount)
    {
        return $this->withResourceOwnerAccount($resourceOwnerAccount);
    }

    /**
     * @param string $resourceOwnerAccount
     *
     * @return $this
     */
    public function withResourceOwnerAccount($resourceOwnerAccount)
    {
        $this->data['ResourceOwnerAccount'] = $resourceOwnerAccount;
        $this->options['query']['ResourceOwnerAccount'] = $resourceOwnerAccount;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withOwnerAccount() instead.
     *
     * @param string $ownerAccount
     *
     * @return $this
     */
    public function setOwnerAccount($ownerAccount)
    {
        return $this->withOwnerAccount($ownerAccount);
    }

    /**
     * @param string $ownerAccount
     *
     * @return $this
     */
    public function withOwnerAccount($ownerAccount)
    {
        $this->data['OwnerAccount'] = $ownerAccount;
        $this->options['query']['OwnerAccount'] = $ownerAccount;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withOwnerId() instead.
     *
     * @param string $ownerId
     *
     * @return $this
     */
    public function setOwnerId($ownerId)
    {
        return $this->withOwnerId($ownerId);
    }

    /**
     * @param string $ownerId
     *
     * @return $this
     */
    public function withOwnerId($ownerId)
    {
        $this->data['OwnerId'] = $ownerId;
        $this->options['query']['OwnerId'] = $ownerId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withVSwitchId() instead.
     *
     * @param string $vSwitchId
     *
     * @return $this
     */
    public function setVSwitchId($vSwitchId)
    {
        return $this->withVSwitchId($vSwitchId);
    }

    /**
     * @param string $vSwitchId
     *
     * @return $this
     */
    public function withVSwitchId($vSwitchId)
    {
        $this->data['VSwitchId'] = $vSwitchId;
        $this->options['query']['VSwitchId'] = $vSwitchId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withIpv6AddressId() instead.
     *
     * @param string $ipv6AddressId
     *
     * @return $this
     */
    public function setIpv6AddressId($ipv6AddressId)
    {
        return $this->withIpv6AddressId($ipv6AddressId);
    }

    /**
     * @param string $ipv6AddressId
     *
     * @return $this
     */
    public function withIpv6AddressId($ipv6AddressId)
    {
        $this->data['Ipv6AddressId'] = $ipv6AddressId;
        $this->options['query']['Ipv6AddressId'] = $ipv6AddressId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withVpcId() instead.
     *
     * @param string $vpcId
     *
     * @return $this
     */
    public function setVpcId($vpcId)
    {
        return $this->withVpcId($vpcId);
    }

    /**
     * @param string $vpcId
     *
     * @return $this
     */
    public function withVpcId($vpcId)
    {
        $this->data['VpcId'] = $vpcId;
        $this->options['query']['VpcId'] = $vpcId;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withName() instead.
     *
     * @param string $name
     *
     * @return $this
     */
    public function setName($name)
    {
        return $this->withName($name);
    }

    /**
     * @param string $name
     *
     * @return $this
     */
    public function withName($name)
    {
        $this->data['Name'] = $name;
        $this->options['query']['Name'] = $name;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withIpv6Address() instead.
     *
     * @param string $ipv6Address
     *
     * @return $this
     */
    public function setIpv6Address($ipv6Address)
    {
        return $this->withIpv6Address($ipv6Address);
    }

    /**
     * @param string $ipv6Address
     *
     * @return $this
     */
    public function withIpv6Address($ipv6Address)
    {
        $this->data['Ipv6Address'] = $ipv6Address;
        $this->options['query']['Ipv6Address'] = $ipv6Address;

        return $this;
    }

    /**
     * @deprecated deprecated since version 2.0, Use withAssociatedInstanceId() instead.
     *
     * @param string $associatedInstanceId
     *
     * @return $this
     */
    public function setAssociatedInstanceId($associatedInstanceId)
    {
        return $this->withAssociatedInstanceId($associatedInstanceId);
    }

    /**
     * @param string $associatedInstanceId
     *
     * @return $this
     */
    public function withAssociatedInstanceId($associatedInstanceId)
    {
        $this->data['AssociatedInstanceId'] = $associatedInstanceId;
        $this->options['query']['AssociatedInstanceId'] = $associatedInstanceId;

        return $this;
    }
}
