<?php

namespace AlibabaCloud\Vpc\V20160428;

use AlibabaCloud\ApiResolverTrait;

/**
 * Find the specified Api of the Vpc based on the method name as the Api name.
 *
 * @package   AlibabaCloud\Vpc\V20160428
 *
 * @method static ActivateRouterInterface activateRouterInterface(array $options = [])
 * @method static ActiveFlowLog activeFlowLog(array $options = [])
 * @method static AddBandwidthPackageIps addBandwidthPackageIps(array $options = [])
 * @method static AddBgpNetwork addBgpNetwork(array $options = [])
 * @method static AddCommonBandwidthPackageIp addCommonBandwidthPackageIp(array $options = [])
 * @method static AddGlobalAccelerationInstanceIp addGlobalAccelerationInstanceIp(array $options = [])
 * @method static AddIPv6TranslatorAclListEntry addIPv6TranslatorAclListEntry(array $options = [])
 * @method static AllocateEipAddress allocateEipAddress(array $options = [])
 * @method static AllocateEipAddresses allocateEipAddresses(array $options = [])
 * @method static AllocateIpv6InternetBandwidth allocateIpv6InternetBandwidth(array $options = [])
 * @method static AssociateEipAddress associateEipAddress(array $options = [])
 * @method static AssociateGlobalAccelerationInstance associateGlobalAccelerationInstance(array $options = [])
 * @method static AssociateHaVip associateHaVip(array $options = [])
 * @method static AssociatePhysicalConnectionToVirtualBorderRouter associatePhysicalConnectionToVirtualBorderRouter(array $options = [])
 * @method static AssociateRouteTable associateRouteTable(array $options = [])
 * @method static CancelPhysicalConnection cancelPhysicalConnection(array $options = [])
 * @method static ConnectRouterInterface connectRouterInterface(array $options = [])
 * @method static ConvertBandwidthPackage convertBandwidthPackage(array $options = [])
 * @method static CreateBandwidthPackage createBandwidthPackage(array $options = [])
 * @method static CreateBgpGroup createBgpGroup(array $options = [])
 * @method static CreateBgpPeer createBgpPeer(array $options = [])
 * @method static CreateCommonBandwidthPackage createCommonBandwidthPackage(array $options = [])
 * @method static CreateCustomerGateway createCustomerGateway(array $options = [])
 * @method static CreateFlowLog createFlowLog(array $options = [])
 * @method static CreateForwardEntry createForwardEntry(array $options = [])
 * @method static CreateGlobalAccelerationInstance createGlobalAccelerationInstance(array $options = [])
 * @method static CreateHaVip createHaVip(array $options = [])
 * @method static CreateIPv6Translator createIPv6Translator(array $options = [])
 * @method static CreateIPv6TranslatorAclList createIPv6TranslatorAclList(array $options = [])
 * @method static CreateIPv6TranslatorEntry createIPv6TranslatorEntry(array $options = [])
 * @method static CreateIpv6EgressOnlyRule createIpv6EgressOnlyRule(array $options = [])
 * @method static CreateIpv6Gateway createIpv6Gateway(array $options = [])
 * @method static CreateIpv6InternetEgressOnlyRule createIpv6InternetEgressOnlyRule(array $options = [])
 * @method static CreateNatGateway createNatGateway(array $options = [])
 * @method static CreateNqa createNqa(array $options = [])
 * @method static CreatePhysicalConnection createPhysicalConnection(array $options = [])
 * @method static CreatePhysicalConnectionNew createPhysicalConnectionNew(array $options = [])
 * @method static CreatePrivateDNatEntry createPrivateDNatEntry(array $options = [])
 * @method static CreatePrivateNatGateway createPrivateNatGateway(array $options = [])
 * @method static CreatePrivateSNatEntry createPrivateSNatEntry(array $options = [])
 * @method static CreateRouteEntry createRouteEntry(array $options = [])
 * @method static CreateRouteTable createRouteTable(array $options = [])
 * @method static CreateRouterInterface createRouterInterface(array $options = [])
 * @method static CreateSnatEntry createSnatEntry(array $options = [])
 * @method static CreateSslVpnClientCert createSslVpnClientCert(array $options = [])
 * @method static CreateSslVpnServer createSslVpnServer(array $options = [])
 * @method static CreateVSwitch createVSwitch(array $options = [])
 * @method static CreateVirtualBorderRouter createVirtualBorderRouter(array $options = [])
 * @method static CreateVpc createVpc(array $options = [])
 * @method static CreateVpnConnection createVpnConnection(array $options = [])
 * @method static CreateVpnGateway createVpnGateway(array $options = [])
 * @method static DeactivateRouterInterface deactivateRouterInterface(array $options = [])
 * @method static DeactiveFlowLog deactiveFlowLog(array $options = [])
 * @method static DeleteBandwidthPackage deleteBandwidthPackage(array $options = [])
 * @method static DeleteBgpGroup deleteBgpGroup(array $options = [])
 * @method static DeleteBgpNetwork deleteBgpNetwork(array $options = [])
 * @method static DeleteBgpPeer deleteBgpPeer(array $options = [])
 * @method static DeleteCommonBandwidthPackage deleteCommonBandwidthPackage(array $options = [])
 * @method static DeleteCustomerGateway deleteCustomerGateway(array $options = [])
 * @method static DeleteFlowLog deleteFlowLog(array $options = [])
 * @method static DeleteForwardEntry deleteForwardEntry(array $options = [])
 * @method static DeleteGlobalAccelerationInstance deleteGlobalAccelerationInstance(array $options = [])
 * @method static DeleteHaVip deleteHaVip(array $options = [])
 * @method static DeleteIPv6Translator deleteIPv6Translator(array $options = [])
 * @method static DeleteIPv6TranslatorAclList deleteIPv6TranslatorAclList(array $options = [])
 * @method static DeleteIPv6TranslatorEntry deleteIPv6TranslatorEntry(array $options = [])
 * @method static DeleteIpv6EgressOnlyRule deleteIpv6EgressOnlyRule(array $options = [])
 * @method static DeleteIpv6Gateway deleteIpv6Gateway(array $options = [])
 * @method static DeleteIpv6InternetBandwidth deleteIpv6InternetBandwidth(array $options = [])
 * @method static DeleteIpv6InternetEgressOnlyRule deleteIpv6InternetEgressOnlyRule(array $options = [])
 * @method static DeleteLogCollectionAttribute deleteLogCollectionAttribute(array $options = [])
 * @method static DeleteNatGateway deleteNatGateway(array $options = [])
 * @method static DeleteNqa deleteNqa(array $options = [])
 * @method static DeletePhysicalConnection deletePhysicalConnection(array $options = [])
 * @method static DeletePrivateDNatEntry deletePrivateDNatEntry(array $options = [])
 * @method static DeletePrivateNatGateway deletePrivateNatGateway(array $options = [])
 * @method static DeletePrivateSNatEntry deletePrivateSNatEntry(array $options = [])
 * @method static DeleteRouteEntry deleteRouteEntry(array $options = [])
 * @method static DeleteRouteTable deleteRouteTable(array $options = [])
 * @method static DeleteRouterInterface deleteRouterInterface(array $options = [])
 * @method static DeleteSnatEntry deleteSnatEntry(array $options = [])
 * @method static DeleteSslVpnClientCert deleteSslVpnClientCert(array $options = [])
 * @method static DeleteSslVpnServer deleteSslVpnServer(array $options = [])
 * @method static DeleteVSwitch deleteVSwitch(array $options = [])
 * @method static DeleteVirtualBorderRouter deleteVirtualBorderRouter(array $options = [])
 * @method static DeleteVpc deleteVpc(array $options = [])
 * @method static DeleteVpnConnection deleteVpnConnection(array $options = [])
 * @method static DeleteVpnGateway deleteVpnGateway(array $options = [])
 * @method static DescribeAccessPoints describeAccessPoints(array $options = [])
 * @method static DescribeBandwidthPackagePublicIpMonitorData describeBandwidthPackagePublicIpMonitorData(array $options = [])
 * @method static DescribeBandwidthPackages describeBandwidthPackages(array $options = [])
 * @method static DescribeBgpGroups describeBgpGroups(array $options = [])
 * @method static DescribeBgpPeers describeBgpPeers(array $options = [])
 * @method static DescribeCommonBandwidthPackages describeCommonBandwidthPackages(array $options = [])
 * @method static DescribeCustomerGateway describeCustomerGateway(array $options = [])
 * @method static DescribeCustomerGateways describeCustomerGateways(array $options = [])
 * @method static DescribeEipAddresses describeEipAddresses(array $options = [])
 * @method static DescribeEipMonitorData describeEipMonitorData(array $options = [])
 * @method static DescribeFlowLogs describeFlowLogs(array $options = [])
 * @method static DescribeForwardTableEntries describeForwardTableEntries(array $options = [])
 * @method static DescribeGlobalAccelerationInstances describeGlobalAccelerationInstances(array $options = [])
 * @method static DescribeHaVips describeHaVips(array $options = [])
 * @method static DescribeIPv6TranslatorAclListAttributes describeIPv6TranslatorAclListAttributes(array $options = [])
 * @method static DescribeIPv6TranslatorAclLists describeIPv6TranslatorAclLists(array $options = [])
 * @method static DescribeIPv6TranslatorEntries describeIPv6TranslatorEntries(array $options = [])
 * @method static DescribeIPv6Translators describeIPv6Translators(array $options = [])
 * @method static DescribeIpv6Addresses describeIpv6Addresses(array $options = [])
 * @method static DescribeIpv6EgressOnlyRules describeIpv6EgressOnlyRules(array $options = [])
 * @method static DescribeIpv6GatewayAttribute describeIpv6GatewayAttribute(array $options = [])
 * @method static DescribeIpv6Gateways describeIpv6Gateways(array $options = [])
 * @method static DescribeNatGateways describeNatGateways(array $options = [])
 * @method static DescribeNetworkQuotas describeNetworkQuotas(array $options = [])
 * @method static DescribeNqas describeNqas(array $options = [])
 * @method static DescribePhysicalConnectionOrder describePhysicalConnectionOrder(array $options = [])
 * @method static DescribePhysicalConnections describePhysicalConnections(array $options = [])
 * @method static DescribePrivateDNatEntries describePrivateDNatEntries(array $options = [])
 * @method static DescribePrivateNatGateways describePrivateNatGateways(array $options = [])
 * @method static DescribePrivateSNatEntries describePrivateSNatEntries(array $options = [])
 * @method static DescribePublicIpTrafficAuditLogAttribute describePublicIpTrafficAuditLogAttribute(array $options = [])
 * @method static DescribeRegionPublicIpAddress describeRegionPublicIpAddress(array $options = [])
 * @method static DescribeRegions describeRegions(array $options = [])
 * @method static DescribeRouteEntryList describeRouteEntryList(array $options = [])
 * @method static DescribeRouteTableList describeRouteTableList(array $options = [])
 * @method static DescribeRouteTables describeRouteTables(array $options = [])
 * @method static DescribeRouterInterfaces describeRouterInterfaces(array $options = [])
 * @method static DescribeRouterInterfacesForGlobal describeRouterInterfacesForGlobal(array $options = [])
 * @method static DescribeServerRelatedGlobalAccelerationInstances describeServerRelatedGlobalAccelerationInstances(array $options = [])
 * @method static DescribeSnatTableEntries describeSnatTableEntries(array $options = [])
 * @method static DescribeSslVpnClientCert describeSslVpnClientCert(array $options = [])
 * @method static DescribeSslVpnClientCerts describeSslVpnClientCerts(array $options = [])
 * @method static DescribeSslVpnServers describeSslVpnServers(array $options = [])
 * @method static DescribeTrafficAuditLogAttribute describeTrafficAuditLogAttribute(array $options = [])
 * @method static DescribeVRouterByVpcId describeVRouterByVpcId(array $options = [])
 * @method static DescribeVRouters describeVRouters(array $options = [])
 * @method static DescribeVSwitchAttributes describeVSwitchAttributes(array $options = [])
 * @method static DescribeVSwitches describeVSwitches(array $options = [])
 * @method static DescribeVirtualBorderRouters describeVirtualBorderRouters(array $options = [])
 * @method static DescribeVirtualBorderRoutersForPhysicalConnection describeVirtualBorderRoutersForPhysicalConnection(array $options = [])
 * @method static DescribeVpcAttribute describeVpcAttribute(array $options = [])
 * @method static DescribeVpcs describeVpcs(array $options = [])
 * @method static DescribeVpnConnection describeVpnConnection(array $options = [])
 * @method static DescribeVpnConnectionLogs describeVpnConnectionLogs(array $options = [])
 * @method static DescribeVpnConnections describeVpnConnections(array $options = [])
 * @method static DescribeVpnGateway describeVpnGateway(array $options = [])
 * @method static DescribeVpnGateways describeVpnGateways(array $options = [])
 * @method static DescribeZones describeZones(array $options = [])
 * @method static DisableVpcClassicLink disableVpcClassicLink(array $options = [])
 * @method static DownloadVpnConnectionConfig downloadVpnConnectionConfig(array $options = [])
 * @method static EnablePhysicalConnection enablePhysicalConnection(array $options = [])
 * @method static EnableVpcClassicLink enableVpcClassicLink(array $options = [])
 * @method static ModifyBandwidthPackageAttribute modifyBandwidthPackageAttribute(array $options = [])
 * @method static ModifyBandwidthPackageSpec modifyBandwidthPackageSpec(array $options = [])
 * @method static ModifyBgpGroupAttribute modifyBgpGroupAttribute(array $options = [])
 * @method static ModifyCommonBandwidthPackageAttribute modifyCommonBandwidthPackageAttribute(array $options = [])
 * @method static ModifyCommonBandwidthPackagePayType modifyCommonBandwidthPackagePayType(array $options = [])
 * @method static ModifyCommonBandwidthPackageSpec modifyCommonBandwidthPackageSpec(array $options = [])
 * @method static ModifyCustomerGatewayAttribute modifyCustomerGatewayAttribute(array $options = [])
 * @method static ModifyEipAddressAttribute modifyEipAddressAttribute(array $options = [])
 * @method static ModifyEipPayType modifyEipPayType(array $options = [])
 * @method static ModifyFlowLogAttribute modifyFlowLogAttribute(array $options = [])
 * @method static ModifyForwardEntry modifyForwardEntry(array $options = [])
 * @method static ModifyGlobalAccelerationInstanceAttributes modifyGlobalAccelerationInstanceAttributes(array $options = [])
 * @method static ModifyGlobalAccelerationInstanceSpec modifyGlobalAccelerationInstanceSpec(array $options = [])
 * @method static ModifyHaVipAttribute modifyHaVipAttribute(array $options = [])
 * @method static ModifyIPv6TranslatorAclAttribute modifyIPv6TranslatorAclAttribute(array $options = [])
 * @method static ModifyIPv6TranslatorAclListEntry modifyIPv6TranslatorAclListEntry(array $options = [])
 * @method static ModifyIPv6TranslatorAttribute modifyIPv6TranslatorAttribute(array $options = [])
 * @method static ModifyIPv6TranslatorBandwidth modifyIPv6TranslatorBandwidth(array $options = [])
 * @method static ModifyIPv6TranslatorEntry modifyIPv6TranslatorEntry(array $options = [])
 * @method static ModifyIpv6AddressAttribute modifyIpv6AddressAttribute(array $options = [])
 * @method static ModifyIpv6GatewayAttribute modifyIpv6GatewayAttribute(array $options = [])
 * @method static ModifyIpv6GatewayAttributes modifyIpv6GatewayAttributes(array $options = [])
 * @method static ModifyIpv6GatewaySpec modifyIpv6GatewaySpec(array $options = [])
 * @method static ModifyIpv6InternetBandwidth modifyIpv6InternetBandwidth(array $options = [])
 * @method static ModifyNatGatewayAttribute modifyNatGatewayAttribute(array $options = [])
 * @method static ModifyNatGatewaySpec modifyNatGatewaySpec(array $options = [])
 * @method static ModifyNqa modifyNqa(array $options = [])
 * @method static ModifyPhysicalConnectionAttribute modifyPhysicalConnectionAttribute(array $options = [])
 * @method static ModifyPrivateDNatEntry modifyPrivateDNatEntry(array $options = [])
 * @method static ModifyPrivateNatGateway modifyPrivateNatGateway(array $options = [])
 * @method static ModifyPrivateSNatEntry modifyPrivateSNatEntry(array $options = [])
 * @method static ModifyRouteEntry modifyRouteEntry(array $options = [])
 * @method static ModifyRouteTableAttributes modifyRouteTableAttributes(array $options = [])
 * @method static ModifyRouterInterfaceAttribute modifyRouterInterfaceAttribute(array $options = [])
 * @method static ModifyRouterInterfaceSpec modifyRouterInterfaceSpec(array $options = [])
 * @method static ModifySnatEntry modifySnatEntry(array $options = [])
 * @method static ModifySslVpnClientCert modifySslVpnClientCert(array $options = [])
 * @method static ModifySslVpnServer modifySslVpnServer(array $options = [])
 * @method static ModifyVRouterAttribute modifyVRouterAttribute(array $options = [])
 * @method static ModifyVSwitchAttribute modifyVSwitchAttribute(array $options = [])
 * @method static ModifyVirtualBorderRouterAttribute modifyVirtualBorderRouterAttribute(array $options = [])
 * @method static ModifyVpcAttribute modifyVpcAttribute(array $options = [])
 * @method static ModifyVpnConnectionAttribute modifyVpnConnectionAttribute(array $options = [])
 * @method static ModifyVpnGatewayAttribute modifyVpnGatewayAttribute(array $options = [])
 * @method static MoveResourceGroup moveResourceGroup(array $options = [])
 * @method static RecoverVirtualBorderRouter recoverVirtualBorderRouter(array $options = [])
 * @method static ReleaseEipAddress releaseEipAddress(array $options = [])
 * @method static ReleaseIpv6InternetBandwidth releaseIpv6InternetBandwidth(array $options = [])
 * @method static RemoveBandwidthPackageIps removeBandwidthPackageIps(array $options = [])
 * @method static RemoveCommonBandwidthPackageIp removeCommonBandwidthPackageIp(array $options = [])
 * @method static RemoveGlobalAccelerationInstanceIp removeGlobalAccelerationInstanceIp(array $options = [])
 * @method static RemoveIPv6TranslatorAclListEntry removeIPv6TranslatorAclListEntry(array $options = [])
 * @method static ReverseLogCollectionStatus reverseLogCollectionStatus(array $options = [])
 * @method static SetLogCollectionAttribute setLogCollectionAttribute(array $options = [])
 * @method static SetPublicIpTrafficAuditLogStatus setPublicIpTrafficAuditLogStatus(array $options = [])
 * @method static SetTrafficAuditLogStatus setTrafficAuditLogStatus(array $options = [])
 * @method static TerminatePhysicalConnection terminatePhysicalConnection(array $options = [])
 * @method static TerminateVirtualBorderRouter terminateVirtualBorderRouter(array $options = [])
 * @method static TestAction testAction(array $options = [])
 * @method static TestCrmAction testCrmAction(array $options = [])
 * @method static TestParam testParam(array $options = [])
 * @method static UnassociateEipAddress unassociateEipAddress(array $options = [])
 * @method static UnassociateGlobalAccelerationInstance unassociateGlobalAccelerationInstance(array $options = [])
 * @method static UnassociateHaVip unassociateHaVip(array $options = [])
 * @method static UnassociatePhysicalConnectionFromVirtualBorderRouter unassociatePhysicalConnectionFromVirtualBorderRouter(array $options = [])
 * @method static UnassociateRouteTable unassociateRouteTable(array $options = [])
 * @method static VpcApiResolver vpcApiResolver(array $options = [])
 */
class Vpc
{
    use ApiResolverTrait;
}
